2001-03-30  Dave Peticolas  <dave@krondo.com>

	* src/scm/report/average-balance.scm: tweak default accounts

	* src/scm/html-utilities.scm (gnc:html-build-acct-table):
	put in a horizontal line before grand total.

	* src/gnome/dialog-tax-info.c: use form & description, not
	code & form, in clist. more work on display.

	* src/scm/report/txf-export.scm: fix bug

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_modify_current_cell): reset item edit position

	* src/register/gnome/gnucash-item-edit.c (item_edit_reset_offset):
	new func

	* src/gnome/gnc-currency-edit.c (add_item): don't use namespace
	in string

	* src/quotes/finance-quote-helper.in: check for non-standard
	Perl modules

	* src/quotes/Makefile.am: add update-finance-quote

	* src/quotes/update-finance-quote.in: new file

	* src/guile/guile-util.c: new funcs for wrapping price lists

	* src/guile/gnc.gwp: wrap more pricedb api. g-wrap price lists.

	* src/gnome/dialog-tax-info.c: more work

	* src/gnc-ui-util.c (gnc_push_locale): new func
	(gnc_pop_locale): new func

	* src/gnome/gnc-html-guppi.c: use C locale when parsing doubles

	* src/gnc-ui-util.c (gnc_lconv_set): strdup value to make
	sure changing the locale doesn't affect the cached value

	* src/gnome/window-register.c: make 'record' work like 'enter'

	* src/scm/prefs.scm: add internal prefs for tax window size

	* src/gnome/gnc-splash.c: make splash a regular window

2001-03-30  James LewisMoss  <jimdres@mindspring.com>

	* src/test/gnc-test-stuff.c (test_files_in_dir): use file list
	rather than dir so we can control the order of files tested (to
	allow parent accounts to be parsed first)

	* src/test/test-real-data.sh (EXIT_VALUE): make sure test fails if
	at least one of the tests fail.

2001-03-29  Dave Peticolas  <dave@krondo.com>

	* doc/sgml/C/xacc-incomeexpense.sgml: fix debit/credit distinction

	* src/scm/report/taxtxf.scm: more work

	* src/scm/report/category-barchart.scm: remove url FIXME

	* src/scm/html-barchart.scm: add bar & legend urls to render

	* src/gnome/top-level.c: Robert Stephenson's patch for
	gtkhtml & gconf

	* src/gnome/gnc-html-guppi.c: fix bugs

	* src/scm/html-text.scm: fix bug

	* src/scm/report/portfolio.scm: work on display

	* src/scm/report/stylesheet-plain.scm: add styles for totals

	* src/scm/html-document.scm: bug fix

	* src/scm/report/taxtxf.scm: more work

	* src/engine/gnc-commodity.c (count_coms): use
	GNC_COMMODITY_NS_ISO instead of the string const.

	* src/engine/rpc/Makefile.am: use GLIB_CFLAGS instead of
	hard-coded include dir.

	* src/engine/rpc/RpcUtils.c (rpcend_build_gnccommoditylist): use
	GNC_COMMODITY_NS_ISO instead of the string const. Fix compiler
	warning.

2001-03-29  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/io-gncxml-v2.c (write_counts): don't add an amount if
	it's == 0.

2001-03-29  Christian Stimming  <stimming@tuhh.de>

	* src/scm/report/report-list.scm, Makefile.am: Added new file.

	* src/scm/report/category-barchart.scm: Two new reports. Shows
	barchart of income (or expense) categories over time.

	* src/scm/report/income-expense-graph.scm: Use more
	option-utilities.scm. Fixed gnc:dateloop usage (last interval was
	wrong).

	* src/scm/html-barchart.scm: Added record components for bar- and
	legend-urls and their accessor/modifier functions. FIXME: They
	don't get rendered yet -- somebody has to add that.

	* src/scm/date-utilities.scm (gnc:dateloop): Fixed last interval
	not to be longer than the specified end date.

2001-03-29  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/io-gncxml-v2.c (write_counts): don't add an amount if
	it's == 0.

2001-03-29  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/portfolio.scm: New file.  Stock portfolio
	overview.

	* src/engine/date.[ch]: Added timespec_normalize,
	timespec_diff, and timespec_abs.

	* src/engine/gnc-pricedb.[ch]: added
	gnc_pricedb_lookup_nearest_in_time, courtesy Rob B.

2001-03-28  Dave Peticolas  <dave@krondo.com>

	* src/SplitLedger.c: fix bug

2001-03-28  James LewisMoss  <jimdres@mindspring.com>

	* src/test/gnc-test-stuff.c (get_random_split): set a share
	amount.

	* src/engine/gnc-transaction-xml-v2.c (spl_quantity_handler):
	should have been xaccSplitSetShareAmount not SetValue

2001-03-28  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-tax-info.c: more work

	* src/guile/gnc.gwp: wrap more of pricedb api

	* src/engine/gnc-pricedb.c (gnc_pricedb_get_prices): new func

2001-03-28  Bill Gribble  <grib@billgribble.com>

	* src/gnome/dialog-column-view.c: set the view dirty on edit

	* src/gnome/dialog-style-sheet.c: dirty every report using a
	stylesheet when it's edited.

	* src/gnome/window-report.c: Add display register/unregister for
	reports so the reports know which report-windows they are being
	displayed in.
	
	* src/scm/html-{bar,pie}chart.scm: Add a little space to work
	around a gtkhtml-0.8.3 bug in table display

	* src/scm/html-document.scm: move tree collapse and
	stringification to the html document rather than the report.  Add
	functions to render just the body elements of a document.

	* src/scm/html-table.scm: fix broken html-table-set-cell! 

	* src/scm/report.scm: add parents list to report struct.  Mark
	parents dirty when report is marked dirty.  reload windows showing
	a report on dirty.  Clean up rendering functions a little

	* src/scm/report/view-column.scm: Add a link to open each report
	in a window by itself.  Change rendering to allow children to be
	cached.
	
2001-03-28  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-tax-info.c: more work

	* src/engine/Transaction.c (DxaccSplitSetSharePriceAndAmount):
	do the double->numeric conversion directly.

	* src/guile/gnc.gwp: remove unused deprecated functions

	* src/engine/Transaction.c (xaccSplitsComputeValue): convert
	imbalance to base_currency fraction if possible

	* src/SplitLedger.c (LedgerDestroy): commit pending instead
	of rolling back.

2001-03-28  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/Transaction.c (xaccSplitGetAccount): use
	xaccSplitSetAccount_Internal to set.  Don't want to NULL out data
	if xaccAccountLookup doesn't give us data (for testing).
	(xaccSplitSetAccount_Internal): new func that doesn't null out
	account guid data

	* src/engine/gnc-transaction-xml-v2.c
	(gnc_transaction_dom_tree_create): add test to not add trn:num
	item when it's an empty string.

	* src/test/Makefile.am (clean-local): add to remove .log files.

2001-03-27  James LewisMoss  <jimdres@mindspring.com>

	* doc-tools/Makefile.am (LDADD): remove all the unneccesary libs.

2001-03-27  Christian Stimming  <stimming@tuhh.de>

	* src/scm/report/average-balance.scm: Major rework: Uses
	option-utilities.scm. Added basic multi-currency handling. Fixed
	time interval handling.

	* src/scm/report/income-expense-graph.scm,
	income-or-expense-pie.scm: Use option-utilities.scm.

	* src/scm/options-utilities.scm: Added date interval multichoice
	option, report currency option, and plot size option.

2001-03-27  Dave Peticolas  <dave@krondo.com>

	* configure.in: add --enable-etags argument to turn on
	automatic TAGS creation

	* src/scm/report/register.scm: add notes field

	* src/scm/report/stylesheet-plain.scm: more reports centered
	by default

	* src/scm/html-document.scm: Christopher Browne's markup
	style extension.

	* src/gnome/window-main.c (gnc_report_in_main_window): show new
	page

	* doc/sgml/pt_PT/Makefile.am: remove demo html files

	* doc/sgml/es/Makefile.am: remove demo html files

	* doc/sgml/C/Makefile.am: remove demo html files

	* src/gnome/dialog-column-view.c: mark the options dialog
	changes as appropriate

	* src/gnome/dialog-options.c (gnc_options_dialog_changed): new
	public func

	* src/gnome/dialog-tax-info.c: more work

	* src/gnome/dialog-options.c: set apply button sensitivity
	appropriately

	* src/scm/report/average-balance.scm: use option-utilities

	* src/scm/report/transaction-report.scm: use option-utilities

	* src/scm/options-utilities.scm: remove superfluous (begin)'s

2001-03-26  Dave Peticolas  <dave@krondo.com>

	* src/gnome/gnc-html.c: fix compiler warning

	* src/scm/prefs.scm: add new liability/equity debit/credit labels

	* src/register/gnome/pricecell-gnome.c (PriceDirect): don't use
	key stroke if cell value doesn't change

	* src/register/pricecell.c (xaccSetPriceCellValue): return TRUE
	if cell value actually changed

2001-03-27  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/io-gncxml-v2.c (add_account_local): duh.  currency
	not commodity.  commodity is same as Security.  Old gets freed
	really hosing the data known_commodities structure.

2001-03-26  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/gnc-commodity.c (count_coms): new func.
	(gnc_commodity_table_get_size): Actually return size rather than
	namespace size.
	(gnc_commodity_table_get_number_of_namespaces): new func.  Used to
	be the get_size one.

	* src/test/test-commodities.c (test_commodity): Improve error
	output for size diffs.

2001-03-26  Bill Gribble  <grib@billgribble.com>

	* src/gnome/dialog-column-view.{c,h}: new files.  Options editor
	for the multicolumn report view.

	* src/gnome/dialog-options.{c,h}: add API to get notebook widget
	from standard options dialog

	* src/gnome/gnc-html.c: add handler for gnc-options:report-id=%d 
	url... pops up the options editor for that report. 

	* src/gnome/window-main.c: make the app main widget a notebook
	with side tabs.  When a report is run from the menu, it makes a
	new tab and put itself there (via gnc_report_in_main_window).

	* src/gnome/window-report.c: ask the report how to edit its
	options. Redo options dialog handling.  Add a "open in new window"
	option to the report toolbar/popup

	* src/scm/report.scm: add 'options-editor field to report template
	struct.  It's optional (there's a default).  Add a "Report name"
	option for all reports. Not used yet but will be soon.

	* src/scm/report/view-column.scm: a generic table layout for
	multiple reports.  Each report is in a table cell with a
	configurable rowspan and colspan.
	
2001-03-26  James LewisMoss  <jimdres@mindspring.com>

	* README (NOTE): Update how make-gnucash-patch works.

2001-03-26  Dave Peticolas  <dave@krondo.com>

	* src/scm/report/transaction-report.scm: fix i18n bug

	* src/scm/report/register.scm: more work

	* src/SplitLedger.c: update for api change

	* src/gnome/window-register.c: update for api change

	* src/engine/Transaction.c (xaccSplitGetCorrAccountName): update
	name used for split transactions
	(xaccSplitGetOtherSplit): rename to be more consistent

	* src/gnome/gnc-dialogs.glade: use 'contains' instead of
	'matches' in search dialog

	* src/guile/gnc.gwp: update for api changes below

	* src/engine/Account.c: use US in api names and tags of
	US-specific tax info.

2001-03-25  Dave Peticolas  <dave@krondo.com>

	* src/test/test-exp-parser.c (test_parser): add / 0 test

	* src/scm/report/txf-export.scm: fix bugs

	* src/gnome/gnc-dialogs.glade: work on tax info dialog

	* src/gnome/dialog-tax-info.c: more work

	* src/engine/sixtp.c (gnc_is_our_xml_file): don't use
	g_return_if_fail for not finding a file -- avoid ** CRITICAL **
	warning.

2001-03-24  Dave Peticolas  <dave@krondo.com>

	* src/engine/gnc-pricedb-xml-v1.c (pricedb_v2_end_handler): fix bug

2001-03-23  Dave Peticolas  <dave@krondo.com>

	* src/scm/report/txf-export.scm: redo data structure
	for txf info

	* src/guile/gnc.gwp: wrap tax info api getters

	* src/scm/report/income-or-expense-pie.scm: show total in subtitle

	* src/scm/html-utilities.scm (gnc:assign-colors): make the order
	of color assignment stable

	* src/engine/Account.c: add api for tax info

	* src/engine/kvp_frame.c: handle NULL pointers

	* src/engine/kvp_doc.txt: add tax kvp keys

	* doc/gnucash-gdb-cmds: remove, out of date

2001-03-23  Christian Stimming  <stimming@tuhh.de>

	* src/scm/report/income-or-expense-pie.scm: Included new option to
	summarize all subaccount balances below a certain level threshold.

2001-03-23  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/gnc-pricedb-xml-v1.c (gnc_pricedb_to_dom_tree): Don't
	return and empty tree.  Return NULL.

	* src/engine/io-gncxml-v2.c (write_pricedb): check for null return
	from pricedb tree generator and ignore.  It's ok to get NULL.

2001-03-22  Dave Peticolas  <dave@krondo.com>

	* src/Makefile.am: compile src/test after compile src/

	* src/guile/gnucash.c.in (gnc_main): change from main
	function so other executables can link with this lib

	* src/gnc-main.c: new file with gnucash main

	* src/test/test-stuff.c: add api to turn on success printing

	* src/test/test-exp-parser.c: new test file for testing
	expression parser

	* src/scm/report/income-or-expense-pie.scm: display totals
	in legend

	* src/gnome/druid-stock-split.c: check for proper currencies
	on income & asset accounts. allow price to be recorded.

	* src/gnome/account-tree.c: add api for setting selectability
	with a filter function

	* src/engine/Group.c (xaccGroupRemoveAccount): check for
	group/account mismatch

2001-03-21  Dave Peticolas  <dave@krondo.com>

	* src/scm/date-utilities.scm: set isdst to -1 before calling
	mktime

	* src/gnome/window-main.c: put summary info on left side

	* src/gnome/gtkselect.c: don't display button unless there is
	something to select. put button on left side

2001-03-22  Robert Graham Merkel <rgmerk@mira.net>

	* src/scm/date-utilities.scm (moddate): set is-dst to unknown to
	hopefully fix daylight-saving time errors.

2001-03-21  Dave Peticolas  <dave@krondo.com>

	* configure.in: take out --enable-gpg argument, is run-time dep

2001-03-21  Bill Gribble  <grib@billgribble.com>

	* gnc-network.{c,h}: new files.  Functions for user registration
	and authentication. 

	* gnc-gpg.c: fix bugs.  make gpg operations optionally
	asynchronous via gdk_input_add().

	* gnc-html.c: fix URL base name handling.  Rework processing of
	http requests. 

	* gnc-http.c: memory management in gnome_http.  Still some 
	memory leaks in there, I think.

	* gnc-html-actions.{c,h}: remove files.  Content moved into
	gnc-network.

	* prefs.scm: Add hidden preference for GnuCash Network user ID.

2001-03-21  Dave Peticolas  <dave@krondo.com>

	* src/scm/report-utilities.scm
	(gnc:accounts-get-comm-total-income): new func
	(gnc:accounts-get-comm-total-expense): new func

	* src/scm/report/income-expense-graph.scm: allow user to display
	both income & expense side-by-side

	* src/scm/report/pnl.scm: use sprintf to make title

	* src/guile/guile-util.c (gnc_get_debit_string): use g_strdup
	(gnc_get_credit_string): use g_strdup

	* src/gnome/gnc-html.c: add guid type to register anchor

	* src/scm/report/register.scm: work on display

	* src/engine/Query.c (xaccQueryGetSplitsUniqueTrans): fix bug

	* src/gnome/window-register.c: add arguments to report window
	for title & debit/credit strings

2001-03-21  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/Account.c (xaccAccountInsertSplit): add test to not
	remove if the account is the same.
	(xaccAccountInsertSplit): add check to see if the split already
	exists in the account.

	* src/test/test-xml2-is-file.c (main): use simple_success_test.

	* src/test/test-xml-transaction.c (test_add_transaction):
	cleanup. use simple_success_test.

	* src/test/test-xml-commodity.c (test_add_commodity): use
	simple_success_test.

	* src/test/test-xml-account.c (test_add_account): use
	simple_success_test.

	* src/test/test-string-converters.c (test_string_converters): use
	success_with_error_args. 

	* src/test/test-kvp-frames.c (test_kvp_copy_compare): use
	simple_success_test.

	* src/test/test-dom-converters1.c
	(test_dom_tree_to_commodity_ref): user simple_success_test

	* src/test/test-load-xml2.c (main): use success_test_with_error_args

	* src/test/test-stuff.c (get_random_string_in_array): new func to
	get a random string from a string array.
	(get_random_commodity): move func here from test-xml-commodity.c
	(success_test_with_error_args): new func.
	(vfailure_args): new func. make failure_args call this.
	(vsuccess_args): new func. make success_args call this.

	* src/engine/io-gncxml-v2.c (gnc_book_load_from_xml_file_v2): zero
	out totals as well.

	* src/engine/gnc-book.c (gnc_book_push_error): add new parameter
	the message string.
	(gnc_book_push_error): Change everything to use it (adding NULL
	everywhere) 
	(get_default_error_message): new func to return a message based on
	type of error.
	(gnc_book_get_error_message): new func to return error message.
	(gnc_book_pop_error): change to use clear error so the freeing
	behavior of the error message doesn't have to be copied.
	(gnc_book_clear_error): free the error message.

	* src/engine/io-gncxml-v2.c (gnc_is_xml_data_file_v2): use new
	func from sixtp.h

	* src/engine/sixtp.c (gnc_is_our_xml_file): extract out v2 xml is
	ours test code and create new func.
	(search_for): move here from io-gncxml-v2.c
	(eat_whitespace): likewise.

	* src/engine/io-gncxml-v2.c (gnc_book_load_from_xml_file_v2): set
	count totals to 0.

	* src/gnome/cursors.c (set_cursor_helper): add NULL test for
	window.  I think this is a timing thing found by not having the
	window come up quickly enough.

2001-03-20  Christian Stimming  <stimming@tuhh.de>

	* src/scm/report/income-expense-graph.scm,
	income-or-expense-pie.scm: Fixed account choosing, fixed default
	report currency, added currency exchange calculation. 

2001-03-20  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-progress.c
	(gnc_progress_dialog_set_activity_mode): new func

	* src/guile/gnc.gwp: add new progress dialog api

	* src/engine/date.h: remove unneeded includes

	* src/scm/report/income-or-expense-pie.scm: make 'other' slice
	a link to a new pie report

	* src/scm/report.scm (gnc:make-report-options): new func

	* src/register/splitreg.c (configLayout): don't show balance
	column in stock registers

	* src/gnc-ui-util.c (xaccSPrintAmount): put currency symbol
	after quantity for shares values

	* src/guile/option-util.c (gnc_commit_option): update GUI value

	* src/gnome/gnc-html-guppi.c: new func for shutting down guppi

	* src/gnome/top-level.c (gnc_ui_shutdown): shutdown guppi

	* src/scm/report/income-or-expense-pie.scm: use shorter names
	for reports

	* src/scm/report/income-expense-graph.scm: work on display

	* src/scm/html-utilities.scm (gnc:account-anchor-text): new func

	* src/gnome/gnc-html.c: check for null args

	* src/scm/report/income-or-expense-pie.scm: work on display

	* src/scm/html-utilities.scm: add function for assigning colors

2001-03-20  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/Group.c (xaccGroupRemoveAccount): rename function
	from xaccRemoveAccount and add Group parameter to make it fit with
	the rest better.
	(xaccAccountRemoveGroup): rename function from xaccRemoveGroup to
	better fit naming conventions and add Account parameter.  Actually
	make the parameter just an Account.

	* src/test/test-xml2-is-file.c (main): same as below.

	* src/test/test-xml-transaction.c (main): same as below.

	* src/test/test-split-vs-account.c (main): same as below.

	* src/test/test-string-converters.c (main): add print_test_stats
	call. 

	* src/test/Makefile.am (STUFF): remove test-dom-parser1 because
	it's not automated.

	* src/test/test-dom-converters1.c (main): same as below.

	* src/test/test-date-converting.c (main): add print_test_stats
	call.

	* src/test/test-stuff.c (print_stats): new func.
	(success_args): print success only if set.
	(success_args): increment successes.
	(failure_args): increment failures.

	* src/engine/gnc-transaction-xml-v2.c (split_to_dom_tree): don't
	add a memo field with an empty string as the value.

	* src/engine/sixtp-dom-parsers.c (dom_tree_to_text): don't return
	NULL if no children.  This just means there is no text and we
	should return a strduped "".

	* src/engine/gnc-transaction-xml-v2.c (trn_dom_handlers): make
	slots not required transaction item.

	* src/engine/gnc-account-xml-v2.c: make code and description not
	necessary. 
	(account_parent_handler): Add tests for NULL data.

2001-03-19  Dave Peticolas  <dave@krondo.com>

	* src/gnome/gnc-html-guppi.c: fix callback pointer

	* src/engine/Transaction.c (xaccSplitGetCorrAccountName): i18n
	(xaccSplitGetCorrAccountCode): i18n

	* src/guile/gnucash.c.in (gnucash_lowlev_app_init): update
	last stable version

	* src/scm/report.scm: more work on display

	* src/scm/report/register.scm: add api for printing a
	register report. more work on display

	* src/gnome/window-report.c (gnc_print_report): add api
	for printing reports

	* src/gnome/gnc-html.c: check for no urltype callback

	* src/scm/report/stylesheet-plain.scm: add some more space
	between table cells

	* src/gnome/window-register.c: add support for printing reports

	* src/guile/gnc.gwp: add print report api

	* src/gnome/gnc-html.c: use PWARN, not printf

	* rpm/gnucash.spec.in: add finance-quote-helper as executable

2001-03-19  Derek Atkins  <warlord@MIT.EDU>

	* src/engine/rpc/*: Gnucash RPC Subsystem (Backend and Server).
	  Still considered experimental.  Note that the RPC protocol may
	  change over time causing client/server incompatibilities between
	  various versions of client and server.

	* configure.in: Add option to --enable-rpc.  Hook in RPC Subsystem
	
	* src/engine/Account.c: Fix for initial balance on
	  stock/etc. accounts.  In particular, don't set to zero if there
	  are no splits.

	* src/engine/Backend.h: New RPC errors
	
	* src/engine/Query.{c,h}: Add function to obtain the internal
	  Query Predicate functions (for use in rebuilding Queries from
	  the RPC subsystem)
	
	* src/engine/Transaction.c: Be sure to call the backend in
	  xaccTransRollbackEdit()

	* src/engine/gnc-book.{c,h}: Added gnc_run_rpc_server() function.
		Added hooks to call RPC Backend

	* src/guile/gnc.gwp: added gnc_rpc_server() and new RPC Backend errors

	* src/scm/command-line.scm: added --rpc-server optio

	* src/engine/Makefile.am: Added RPC subdir

2001-03-19  Dave Peticolas  <dave@krondo.com>

	* src/gnome/gnc-dir.h.in: move to src/gnome. fix for make dist
	tarballs

	* src/gnome/Makefile.am: add gnc-dir.h target

	* src/Makefile.am: remove gnc-dir.h target

	* src/quotes/Makefile.am: add gnc-prices to dist

	* src/scm/report/transaction-report.scm (record): use number-cell
	style

	* src/scm/report/register.scm: use number-cell style

	* src/engine/gnc-pricedb.c (gnc_price_unref): unref quote source

2001-03-18  Dave Peticolas  <dave@krondo.com>

	* src/engine/gnc-pricedb.c (compare_prices_by_date): sort
	in descending order so the most recent quote is first.

	* AUTHORS: update author info

	* doc/sgml/C/xacc-about.sgml: update author info

	* src/gnome/top-level.c: add VERSION arg to gnome_init

2001-03-16  Rob Browning  <rlb@cs.utexas.edu>

	* src/scm/utilities.scm
	(item-list->hash!): new - fancy (possibly over-customizable)
	list->hash converter function.
	(filteroutnulls): simplify via SRFI-1.
	(flatten): speedup - avoid intermediate appends.
	(striptrailingwhitespace): speedup - avoid intermediate substrings.
	(string-join): speedup - (maybe), trade string-appends for conses.

	* src/scm/process.scm
	(gnc:run-sub-process): renamed from run-sub-process.
	(gnc:cleanup-sub-process): new - take various steps to make sure
	we don't leave a zombie lying around.

	* src/scm/price-quotes.scm: substantial rework - now much smarter,
	though still a bit too obfuscated.

	* src/scm/engine-utilities.scm: various cleanups, speedups, and
	new functions.
	(gnc:filename->book): deleted.
	(gnc:call-with-account-data-from-file): deleted.
	(gnc:url->loaded-book): new function.

	* src/scm/command-line.scm (gnc:*arg-defs*): add
	--add-price-quotes option.

	* src/quotes/finance-quote-helper.in: new file - renamed from
	price-quote-helper.in.

	* src/quotes/README: various updates.

	* src/quotes/Quote_example.pl: document that we *don't* use the
	"fetch" method in gnucash.

	* src/quotes/gnc-prices: new file -- replaces gnc-prices.in and is
	now just a wrapper for "gnucash --add-price-quotes".

	* src/quotes/Makefile.am: accomodated renaming of
	price-quote-helper to finance-quote-helper.  Also moved
	finance-quote-helper to GNC_SHAREDIR from pkgdatadir.
	(gncsharedir): grab GNC_SHAREDIR.
	(gncshare_SCRIPTS): put finance-quote-helper in GNC_SHAREDIR.

	* src/guile/gnc.gwp: wraped new quote timezone API.  Added new
	gnc-book wrappers and new pricedb wrappers -- still not finished.

	* src/gnome/gnc-dialogs.glade: add quote timezone menu.

	* src/gnome/dialog-utils.h: added prototypes for timezone menu
	funcs.

	* src/gnome/dialog-utils.c: 
	(known_timezones): new - list of quote timezones we support.
	(gnc_find_timezone_menu_position): new.
	(gnc_timezone_menu_position_to_string): new.
	(gnc_ui_quote_tz_menu_create): new.

	* src/gnome/dialog-account.c
	(struct _AccountWindow): add quote_tz_menu.
	(gnc_account_to_ui): support quote_tz_menu.
	(gnc_ui_to_account): support quote_tz_menu.
	(gnc_account_window_create): create quote_tz_menu.

	* src/gnc-ui-util.h: warn to update price-quotes.scm when
	PriceSourceCode changes.

	* src/engine/io-gncbin-r.c
	(cvt_potential_prices_to_pricedb_and_cleanup): Timespec* ->
	Timespec for price time function(s).

	* src/engine/gnc-pricedb.h: Timespec* -> Timespec for time
	functions.

	* src/engine/gnc-pricedb.c
	(gnc_price_clone): re-enable, and Timespec* -> Timespec
	(gnc_price_set_time): Timespec* -> Timespec
	(gnc_price_get_time): Timespec* -> Timespec
	(compare_prices_by_date): Timespec* -> Timespec
	(gnc_pricedb_lookup_at_time): Timespec* -> Timespec
	(gnc_price_print): minor fixes (still lame).
	(gnc_price_print_stdout): new (for lame guile side debugging).

	* src/engine/gnc-pricedb-xml-v1.c: change price time args/results
	from Timespec* to Timespec (to be more guile friendly).

	* src/engine/gnc-book.c (gnc_book_init): be more thorough.

	* src/engine/Backend.h: warn to update gnc.gwp on some mods.

	* src/engine/Account.h: support new funcs and update docs.

	* src/engine/Account.c
	(xaccAccountSetQuoteTZ): new.
	(xaccAccountGetQuoteTZ): new.

2001-03-16  Dave Peticolas  <dave@krondo.com>

	* src/scm/report/transaction-report.scm: add line before
	grand total

	* src/scm/report/register.scm: more work

	* src/gnome/window-register.c: display shares & current value
	in stock registers.

	* src/engine/gnc-pricedb.h: fix spelling error

	* src/gnc-exp-parser.c (gnc_exp_parser_parse): check for
	bad numeric value

	* src/calculation/finvar.h: add new parser error type

	* src/gnome/dialog-transfer.c (gnc_xfer_dialog_create): don't
	set editable_enters for amount field

	* src/engine/gnc-numeric.c: check for invalid arg

2001-03-15  Dave Peticolas  <dave@krondo.com>

	* src/engine/sixtp-to-dom-parser.c (dom_chars_handler): use
	xmlNodeAddContentLen

	* src/gnome/gnc-dialogs.glade: tweak stylesheet dialog

	* src/gnome/dialog-style-sheet.c: tweak looks

	* src/scm/report/register.scm: new report

	* src/guile/gnc.gwp: g-wrap new query api

	* src/gnome/window-register.c: add report menu and toolbar items

	* src/engine/Query.c: handle NULL pointers, add api to get list
	of splits with unique transactions

2001-03-15  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/gnc-book.c (gnc_book_load_from_file): add xml v2
	loading.  Make use new funcs (below)
	(happy_or_push_error): new func.
	(gnc_book_determine_file_type): new func.
	
2001-03-14  Dave Peticolas  <dave@krondo.com>

	* rpm/gnucash.spec.in: simplify

	* configure.in: add 'da' to language list

	* src/gnome/dialog-totd.c (totd_close_cb): increment tip on
	close so we open with the next one

	* src/scm/tip-of-the-day.scm: make current tip number a preference
	so it is saved and restored

	* src/gnome/druid-commodity.c: same as below

	* src/gnome/druid-qif-import.c: same as below

	* src/gnome/dialog-commodity.c: prevent user from creating
	a new iso commodity

	* src/gnome/gnc-html.c: set busy cursor on html widget
	while request is being processed

	* src/gnome/window-main.c: hierarchy not heirarchy

	* src/gnome/window-help.c: specify the help window as the
	request dialog parent

	* doc/sgml/C/xacc-dochack.sgml: remove and fix broken links

2001-03-14  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/io-gncxml-v2.c (gnc_book_load_from_xml_file_v2): Add
	counter callback.
	(add_account_local): add call to countCallback
	(add_commodity_local): same
	(add_transaction_local): same.

2001-03-13  Dave Peticolas  <dave@krondo.com>

	* src/engine/io-gncxml-r.c (gnc_is_xml_data_file): don't print
	a warning just because we couldn't open the file

	* src/FileDialog.c (gncPostFileOpen): clear the non-iso
	commodities before loading the new file

	* src/SplitLedger.c (xaccSRGetEntryHandler): convert imbalance
	to transaction currency fraction

	* src/FileDialog.c (gncFileNew): clear the non-iso commodities

	* src/engine/gnc-commodity.c (gnc_commodity_table_remove_non_iso):
	new func

	* src/test/test-xml-commodity.c: remove duplicate string_to_integer

	* src/gnome/dialog-userpass.c: add missing #include

	* src/register/gnome/Makefile.am: add gnome & glib flags

	* src/engine/Makefile.am: add glib libs

	* src/engine/sql/Makefile.am: add glib flags

	* configure.in: fix includes used to check for sizes

	* acinclude.m4: fix guppi macro

	* macros/: update m4 files

2001-03-13  James LewisMoss  <jimdres@mindspring.com>

	* src/test/test-stuff.c (get_random_string): sometimes generate
	empty strings and NULL (10% each).
	(get_random_string): and 10% of the time generate a larger string.
	(get_random_character): Generate better characters.

	* src/engine/io-gncxml-v2.c (gnc_counter_end_handler): complete
	func. 
	(print_counter_data): new func.
	(gnc_book_load_from_xml_file_v2): call above func at end of
	parse. 

	* src/engine/sixtp-dom-parsers.c (string_to_integer): move here
	from gnc-commodity-xml-v2.c

	* src/engine/io-gncxml-v2.c (gnc_book_write_to_xml_file_v2): add
	transaction number output.

	* src/engine/Group.c (xaccGroupForEachTransaction): actually make
	this work.
	(xaccGroupVisitUnvisitedTransactions): actually make this work.
	Don't get accounts from group.  We already are looking at all of
	them by xaccGroupGetSubAccounts.
	(xaccGroupVisitUnvisitedTransactions_thunk): new func for
	xaccAccountForEachTransaction call.

	* src/test/test-string-converters.c (test_string_converters): add
	func to test some more difficult strings (including xml special
	characters)

	* src/engine/gnc-account-xml-v2.c (gnc_account_dom_tree_create):
	convert to use text_to_dom_tree.

	* src/engine/gnc-commodity-xml-v2.c
	(gnc_commodity_dom_tree_create): convert to use text_to_dom_tree.

	* src/engine/gnc-book.c (gnc_book_count_transactions): new func.

	* src/engine/io-gncxml-v2.c: (write_account_group)new func.
	extract out stuff from write_accounts.  Forgot to traverse down
	accounts so a bunch of the accounts weren't being written.
	(write_accounts): now just call the write_account_group func.
	(gnc_book_write_to_xml_file_v2): use xaccGroupNumSubAccounts to
	get the number of accounts.

2001-03-13  Dave Peticolas  <dave@krondo.com>

	* src/engine/sixtp-utils.c (gnc_timegm): new func. define as
	timegm if present, otherwise implement using mktime.
	(string_to_timespec_secs): use gnc_timegm for UTC parsing

	* src/engine/io-gncxml-r.c (gnc_book_load_from_xml_file): remove
	TZ save & restore.

	* src/test/test-date-converting.c: remove putenv

	* src/test/test-dom-converters1.c: remove putenv

	* src/test/test-xml-transaction.c: remove putenv

	* src/gnome/gnc-http.c: same as below

	* src/engine/NetIO.c (setup_request): use config.h instead
	of hard-coding package and version

	* configure.in: check for timegm function

	* src/scm/report/taxtxf.scm: more porting work

	* src/scm/html-text.scm (gnc:html-markup-em): new func

	* src/scm/report/stylesheet-plain.scm: add some default styles

	* src/scm/html-style-sheet.scm: remove non-type styles

	* src/scm/html-document.scm (gnc:html-document-markup-start):
	check for non-string attributes

2001-03-12  Dave Peticolas  <dave@krondo.com>

	* src/scm/html-style-info.scm: cleanup

2001-03-12  James LewisMoss  <jimdres@mindspring.com>

	* src/gnome/window-main.c (gnc_ui_xml_v2_cb): new func.
	(gnc_ui_account_heirarchy_cb): new empty func.
	(gnc_main_create_menus): add devel menu.

	* src/engine/io-gncxml-v2.h (struct _load_counter_struct): add
	counters stuff.

	* src/engine/io-gncxml-v2.c: mostly complete everything.  Writing
	only partially tested.  Reading not tested at all.

	* src/engine/gnc-xml.h: add pricedb declarations.

	* src/engine/gnc-transaction-xml-v2.c (split_to_dom_tree): check
	for NULL return from kvp_frame_to_dom_tree and don't add if we get
	it.
	(gnc_transaction_dom_tree_create): same.

	* src/engine/gnc-commodity.c (gnc_commodity_table_get_size): add func.

	* src/engine/gnc-account-xml-v2.c (gnc_account_dom_tree_create):
	check for NULL return from kvp_frame_to_dom_tree and don't do
	anything if we get it.

	* src/gnome/gnc-http.c (gnc_http_start_post): cast data to char*
	(it's const char*) (compile warning)

	* src/gnome/gnc-html.c: put const on char *ptr (compile warning)

	* src/doc/xml/io-gncxml-version2.dtd: reorder commodity and
	prices.  Add count data defs.

	* src/engine/sixtp-dom-generators.c (timespec_to_dom_tree): Only
	write nanoseconds if > 0.
	(kvp_frame_to_dom_tree): don't return an xmlNodePtr if the frame
	is null or contains no data.

	* src/engine/gnc-commodity-xml-v2.c
	(gnc_commodity_dom_tree_create): check to see if xcode is > 0

	* src/engine/gnc-account-xml-v2.c (gnc_account_dom_tree_create):
	check for description and code strlen > 0

	* src/engine/gnc-pricedb-xml-v1.c (pricedb_v2_end_handler): make
	this func work in the v2 manner with a callback in the global
	data.
	(gnc_pricedb_sixtp_parser_create): change to work in the v2 manner
	with an end handler that does the final link of the data into the
	book. 
	(pricedb_after_child_handler): add upping the counter for prices
	loaded. 

2001-03-12  Dave Peticolas  <dave@krondo.com>

	* src/engine/io-gncxml-r.c (gnc_book_load_from_xml_file): use
	TZ=UTC while parsing xml.

	* src/engine/sixtp-utils.c: adjust for timezone offset manually

	* src/scm/html-table.scm ((gnc:make-html-table-header-cell/markup
	markup . objects)): new func

	* src/scm/report/taxtxf.scm: more work on porting

	* src/scm/html-style-sheet.scm: add "<number-cell>" and
	"<number-header>" styles.

	* src/scm/report/account-summary.scm: use "Total" not "Net
	Assets". This is a general report, not just limited to asset
	accounts.

2001-03-10  Dave Peticolas  <dave@krondo.com>

	* src/engine/Ledger-xml-parser-v1.c
	(ledger_data_after_child_handler): mark pricedb as clean after
	loading

2001-03-09  Bill Gribble  <grib@billgribble.com>

	* add configure/acconfig option for GPG

	* src/gnome/gng-gpg.c: add handlers for creation of keypair
	(with passphrase) and for exporting public key block to GnuCash
	Network server.  Fix bugs in old keypair creator.  Add passphrase
	handling to data encrypt/decrypt.

	* src/gnome/gnc-html-actions.c: rewrite privacy notice to use
	GnuCash Network terminology.  The longer you guys wait to bitch
	about the name the more stuck it is.  Rewrite gnc-info/form handler
	to submit GnuCash version and feature information.

	* src/gnome/gnc-html.c: respect global preferences for HTTP, SSL,
	and GnuCash Network transactions.  Change submit handler calls to
	unpack encoded form data into a hash table and possibly re-encode
	and re-pack if necessary.  Fix bugs in submit handler lookups.
	Add RFC-1738 decoder to go with the encoder. 

	* src/gnome/window-help.c: fix bugs in Open dialog.

	* src/scm/html-table.scm: Add new table-cell/markup and
	append-row/markup functions to make it easier to set semantic data
	styles in style sheets.  Remove dead code. 

	* src/sc/prefs.scm: New preferences section, "Network", with
	options to globally disable HTTP, SSL, and GnuCash Network, and to
	assign the GnuCash Network server name.

	* src/scm/report/table-test.scm: new test report to demonstrate 
	row and cell semantic style
	
2001-03-09  James LewisMoss  <jimdres@mindspring.com>

	* src/doc/xml/prices-v1.dtd: Add rest of def.

	* src/engine/gnc-pricedb-xml-v1.c (add_child_or_kill_parent):
	remove unneeded check since NULL has already been checked.
	(xml_add_gnc_pricedb): extract out pricedb xmlNodePtr creation to
	func not requiring parent then add that to parent passed into this
	func.
	(gnc_pricedb_to_dom_tree): new func.
	(gnc_pricedb_sixtp_parser_create): new func to call other so names
	are standard in v2 parser setup.

	* src/engine/Account.c (xaccAccountInsertSplit): Remove unused
	var oldacc (assigned to once) and the block that went with it.

	* src/gnc-ui-util.c (gnc_account_print_info_helper): New helper
	func.
	(gnc_account_quantity_print_info): Use new helper func.
	(gnc_account_value_print_info): same.
	(gnc_default_print_info_helper): new helper func.
	(gnc_default_share_print_info): use new helper func.
	(gnc_default_price_print_info): same.
	(gnc_split_quantity_print_info): add test for NULL split and
	return a default.
	(gnc_split_value_print_info): same.

2001-03-08  James LewisMoss  <jimdres@mindspring.com>

	* src/test/test-stuff.c (failure): don't print num if == -1.
	(success): same.
	(get_random_account): move here from test-xml-account.c
	(get_random_split): move here from test-xml-transaction.c
	(get_random_transaction): same.
	(success_args): New func.
	(success): Simplified version
	(failure_args): new func.
	(failure): Simplified version.

	* src/engine/io-gncbin-r.c: same as below.

	* src/engine/TransLog.c (xaccTransWriteLog): same as below.

	* src/engine/Group.c (xaccGroupMergeAccounts): same as below.

	* src/engine/Backend.c (xaccTransactionGetBackend): Convert to not
	use the split's acc part directly, but only to access through
	funcs 

	* src/engine/sixtp-dom-parsers.c (dom_tree_generic_parse): Add
	generic parser.

	* src/engine/gnc-account-xml-v2.c (gnc_account_end_handler): use
	generic parser extracted from here and used here and
	gnc-transaction-iml-v2.c 

	* src/engine/Transaction.c (xaccInitSplit): Add a split->acc_guid
	field that is set to the account's guid.  This way an Account is
	not required to exist yet when loading the split.  Later when
	xaccSplitGetAccount is called the account is looked up, cached and
	returned.  Make sure everything accesses ->acc through the helper
	function.

	* src/engine/AccountP.h: same as below.

	* src/engine/Account.c (xaccAccountSetGUID): mark guid argument
	const since it doesn't keep a pointer to it.

	* src/doc/xml/transactions-v2.dtd: change guid -> id.

2001-03-08  Dave Peticolas  <dave@krondo.com>

	* src/scm/report/report-list.scm: load tax report if possibly in
	US locale.

	* src/scm/report/taxtxf.scm: work on tax report (unfinished)

2001-03-07  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/Transaction.c (get_denom_internal): New helper func.
	(get_currency_denom): use func.
	(get_security_denom): use func.

	* src/engine/sixtp.c: (sixtp_sax_end_handler,
	sixtp_sax_characters_handler, sixtp_sax_start_handler): don't use
	g_return_if_fail to test pdata->parsing_ok so we don't see the
	million CRITICAL warnings.  We'll print an error at the end
	anyway.

2001-03-07  Dave Peticolas  <dave@krondo.com>

	* src/scm/report/hello-world.scm: use new html format functions.
	Add scheme reference.

	* src/gnome/dialog-fincalc.c (gnc_ui_fincalc_dialog_create): hide
	schedule button. Use 'lookup_widget'.

	* src/gnome/gnc-html.c (gnc_html_export): handle cancelling

	* src/scm/html-style-info.scm: remove cruft

2001-03-08  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm: More colourization.
	
2001-03-07  Bill Gribble  <grib@billgribble.com>

	* summary: separate the HTML and HTTP processing functions into
	different files to facilitate reuse.  Modularize much of the
	gnucash-specific behavior of the HTML code (<object> and form
	submission) to use run-time-expandable bahavior tables.  Add the
	gnc-action: mechanism for installing form submission handlers.

	* src/gnome/gng-gpg.c: initialize gnc-html handler for crypted
	HTML objects.  Remove all mention of GPG from gnc-html.c

	* src/gnome/gnc-html-actions.c: new file.  Add a simple form
	submission action (action=gnc-action:gnc-info/form?CGI_URL) to
	test submit and action processing.  This is useless ATM.  Some of
	the stuff in the privacy comments is unimplemented yet.

	* src/gnome/gnc-html-guppi.c: move all Guppi references from
	gnc-html.c into a separate file, with an initializer for 
	the Guppi <object> tags. 

	* src/gnome/gnc-html.c: get rid of SSL references; all that stuff
	is now in gnc-http.c.  Restructure to use gnc-http instead of
	ghttp directly.  Finish GET and POST default handlers, and add
	handler lookup/install mechanism for gnc-action: actions.  crib
	urlencoding function from gtkhtml guts.

	* src/gnome/gnc-http.c: new file.  Move HTTP stuff here. Finish
	POST handling.

	* src/gnome/top-level.c: add calls to Guppi, GPG, and gnc-html
	init functions.  These calls will eventually go into loadable
	module startup functions, when we get loadable modules.

	* src/scm/html-text.scm: Add html-markup/format.
	(html-markup/format "%a %a %a %a" 1 2 3 4) does what you'd expect,
	even if the non-format args are html-markup objects.
	
2001-03-07  Dave Peticolas  <dave@krondo.com>

	* src/gnome/top-level.c (gnc_ui_check_events): add timeout
	handler for checking backend events.

	* src/engine/gnc-book.{ch}: add api calls to use backend
	event hooks.

	* src/engine/BackendP.h (struct _backend ): add events_pending
	and process_events callbacks.

	* src/scm/command-line.scm: extend usage command with argument
	list

	* src/pixmaps/Makefile.am: switch splash graphics

	* src/gnome/gnc-splash.c (gnc_show_splash_screen): add a border.
	use new graphic.

	* src/gnome/window-main.c: store namespace & mnemonic instead
	of commodity pointers in the asset/profit widget.

2001-03-07  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm: Added row colors to make
	things look pretty.  Comments on effectiveness appreciated.

	* src/scm/html-table.scm: keep track of how many rows are in the
	table.

2001-03-06  Dave Peticolas  <dave@krondo.com>

	* src/scm/iso-4217-currencies.scm: remove duplicate currency
	fix colonial franc names

	* src/engine/sixtp-dom-parsers.c (dom_tree_to_commodity_ref): use
	gnc_commodity_destroy, not g_free.

	* src/guile/gnc.gwp: fix for new commodity insert

	* src/gnome/druid-qif-import.c: fix for new commodity insert

	* src/gnome/dialog-commodity.c: check for existing commodity.
	fix for new commodity insert.

	* src/engine/io-gncbin-r.c: fix for new commodity insert

	* src/gnome/druid-commodity.c: fix for new commodity insert

	* src/engine/gnc-commodity.c: change commodity insert semantics to
	use an existing commodity if present. Remove
	gnc_commodity_table_remove(). It wasn't used and was a mem leak.

	* src/engine/Commodity-xml-parser-v1.c
	(commodity_restore_end_handler): use gnc_commodity_destroy,
	not just g_free.

2001-03-05  Dave Peticolas  <dave@krondo.com>

	* src/register/gnome/gnucash-item-edit.{ch}: improve horizontal
	scrolling behavior.

2001-03-05  Christian Stimming  <stimming@tuhh.de>

	* src/scm/html-utilities.scm: reorganizing of the hierarchical
	reports: subtotals are now printed *below* the subaccounts instead
	of above.

2001-03-05  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/Transaction.c (xaccSplitSetAccount): new func.

	* src/doc/xml/transactions-v2.dtd: move splits to an array type
	structure. 

2001-03-04  Dave Peticolas  <dave@krondo.com>

	* configure.in: define a new substitution GNC_PIXMAP_DIR for
	a pixmap directory. check for gal.

	* src/pixmaps/Makefile.am (gncpixmapdir): install in configured
	pixmap directory

	* src/gnc-dir.h.in (GNC_PIXMAP_DIR): define pixmap directory

	* src/Makefile.am (gnc-dir.h): configure pixmap directory
	for gnc-dir.h.in

	* src/gnome/dialog-utils.c (gnc_get_pixmap): use configured
	pixmap directory

	* src/engine/gnc-associate-account.c: fix some uses of glib
	list routines (they always return the new head of the list).

	* src/pixmaps: add gnucash_long.png graphic

	* src/gnome/top-level.c (gnucash_ui_init): show splash screen

	* src/gnome/gnc-splash.{ch}: splash screen functionality

	* src/gnome/dialog-utils.{ch} (gnc_get_pixmap): new function

	* src/gnc-dir.h.in: add header file with directory info

	* src/guile/Makefile.am: use BUILT_SOURCES for *.in sources

2001-03-04  Christian Stimming  <stimming@tuhh.de>

	* src/scm/html-utilities.scm: Added different printing of stock
	accounts. Started a new layout/ordering for sub-totals.

	* src/scm/commodity-utilities.scm (gnc:sum-collector-stocks):
	added such that stock prices are no longer shown but foreign
	currencies are. Rounding precision increased. Added sanity checks
	for arguments of various funtions.

	* src/scm/report-utilities.scm (gnc:account-is-stock?): added
	function

2001-03-04  Dave Peticolas  <dave@krondo.com>

	* src/gnome/window-help.c: save & restore window size

	* src/gnome/window-report.c: save & restore window size

	* src/scm/prefs.scm: add vars for report & help win sizes

2001-03-03  Dave Peticolas  <dave@krondo.com>

	* src/engine/sql/README: add info about running without root
	privileges

	* src/engine/sql/design.txt: update design docs

	* src/engine/sql/PostgresBackend.c (pgend_session_begin): connect
	to template1 database instead of 'gnucash'

2001-03-02  Dave Peticolas  <dave@krondo.com>

	* src/gnome/new-user.glade: tweak layout, strings

	* src/gnome/new-user-funs.h: add gpl header

	* src/gnome/new-user-funs.{ch}: add gpl header

	* src/gnome/new-user-callbacks.c: tweak layout, add gpl header

	* src/gnome/gnc-dialogs.glade: add title to transfer dialog

	* src/engine/gnc-pricedb.c (gnc_pricedb_destroy): fix mem leak

	* src/gnome/dialog-options.c: cleanup destruction semantics.
	destroy tooltips

	* src/engine/io-gncxml-r.c (gnc_book_load_from_xml_file): fix mem
	leak

	* src/gnome/dialog-utils.c (gnc_build_option_menu): destroy
	tooltips when menu is destroyed

2001-03-02  James LewisMoss  <jimdres@mindspring.com>

	* src/test/test-xml-transaction.c (test_generation): add success
	call for creation accuracy.

	* src/test/test-xml-commodity.c (test_generation): Add success
	call for creation accuracy.

	* src/test/test-xml-account.c (test_generation): Add call to
	xaccGUIDinit.  Don't know how this was working before without this
	call.  Maybe hit good memory spots before.
	(test_generation): add success call for creation accuracy.

	* src/engine/Transaction.c (xaccSplitSetSlots_nc): New func.
	(xaccTransSetSlots_nc): new func.

2001-03-01  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/gnc-account-xml-v2.c (account_id_handler): fix mem
	leak because xaccAccountSetGUID doesn't keep pointer to guid
	passed in.

2001-03-01  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-transfer.c: destroy tooltips object

	* src/gnome/window-main.c (gnc_ui_destroy_all_subwindows): now all
	windows use component manager

	* src/gnome/window-report.c: add report to component manager.
	cleaner destruction behavior

	* src/gnome/window-help.c: cleaner destruction behavior

	* src/gnome/gnc-html.c: fix to avoid having the ref the container
	from outside for destruction

	* src/FileDialog.c (gncAddHistory): fix mem leak

	* src/gnome/dialog-options.c (gnc_option_create_date_widget): fix
	bug & mem leak.

2001-03-01  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/gnc-account-xml-v2.c (account_id_handler): fix mem
	leak because xaccAccountSetGUID doesn't keep pointer to guid
	passed in.

2001-03-01  Dave Peticolas  <dave@krondo.com>

	* src/register/gnome/gnucash-sheet.c: if input is cancelled by
	user during delete, ignore the insert callback.

	* src/MultiLedger.c: update for new view api

	* src/register/recncell.{ch}: allow setting a parent to be used
	for the dialog.

	* src/gnome/query-user.c (gnc_verify_dialog_parented): handle null
	parent by using gnc_get_ui_data.

	* src/gnome/window-register.c: eliminate calls to
	xaccSRCheckReconciled. confirmation is done in SplitLedger.c now.

	* src/SplitLedger.c: use new data entry confirmation callback
	to confirm changes to a reconciled split.

	* src/register/splitreg.{ch}: mod for table-allgui changes

	* src/register/table-allgui.{ch}: encapsulate 'view' callbacks
	into a struct. add a callback for confiming data entry.

2001-03-01  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm (add-split-row): Now 
	uses date-posted rather than date-entered.
	(used-<foo>, build-column-used): use a vector rather than a 
	record.  *Big* speedup :)

	* src/scm/html-document.scm (gnc:document-fetch-markup-style): use
	a let rather than repeated variable lookups.
	(gnc:document-fetch-data-style): ditto.
	(gnc:html-document-markup-end): use new closing-font-tag? variable
	for more speedup.

	* src/scm/html-document.scm (<html-markup-style-info>): add new
	closing-font-tag? variable to speedup closing tags.  Also modify
	setter functions to set closing-font-tag to appropriate values,
	and add a setter and getter for it.
	(gnc:html-style-info-markup-set): modify to set closing-font-tag
	to appropriate state.
	(gnc:html-style-info-markup-merge): modify to set closing-font-tag
	to appropriate state

	* src/scm/html-table.scm: replace for-each-in-order with for-each,
	which has exactly the same semantics according to R5RS (which
	guile is a superset of).  Was done in hope of speedup, but none
	forthcoming.  Didn't change back because for-each is R5RS, but
	for-each-in-order isn't.  Probably should make the substitution
	globally.

2001-02-28  Dave Peticolas  <dave@krondo.com>

	* src/engine/Transaction.c (xaccSplitsComputeValue): fix a bug

	* src/engine/gnc-book.c (gnc_book_load): fix spelling

	* src/engine/Scrub.c (xaccTransScrubImbalance): don't use sub_fixed
	since the value may not have the right denominator
	(xaccSplitScrub): handle splits without accounts

	* src/gnome/query-user.c
	(gnc_choose_radio_option_dialog_parented): actually set the parent

	* src/SplitLedger.c (xaccSRCheckReconciled): check current
	transaction, not current split.

	* src/engine/GNCId.c: use GUID allocator for hash keys.

2001-02-28  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/gnc-commodity-xml-v2.c (gnc_commodity_end_handler):
	mem leak.  free the node in the end handler.

	* src/engine/gnc-commodity.c (reset_unique_name): new func.
	(reset_printname): new func.
	(gnc_commodity_new): use new funcs
	(gnc_commodity_set_mnemonic): use new funcs.
	(gnc_commodity_set_namespace): use new funcs.
	(gnc_commodity_set_fullname): use new funcs.

	* src/engine/gnc-commodity-xml-v2.c (gnc_commodity_end_handler):
	Don't free commodity.  That's the globaldata funcs job if it wants
	to.
	(set_commodity_value): Must remember compare equals == 0.  Duh.

	* src/engine/sixtp.c (sixtp_parse_file): Only run end handler if
	parsing is already ok.

	* src/test/test-xml-account.c (test_generation): oops should have
	continued here.

	* src/engine/gnc-commodity-xml-v2.c (valid_commodity): Complete func.

	* configure.in (LIBS): disable libxml/xmlversion.h checks so we can't
	compile for libxml2 for now.

	* src/test/test-xml-account.c (node_and_account_equal): fix mem
	leak. 
	(test_add_account): new func.
	(test_generation): Actually test the node created and the
	parser. Everything looks good other than some sixtp oddness I
	don't understand yet.

	* src/engine/gnc-transaction-xml-v2.c
	(gnc_transaction_end_handler): same as below.

	* src/engine/gnc-commodity-xml-v2.c (gnc_commodity_end_handler):
	Use data struct from io-gncxml-v2.h

	* src/engine/gnc-account-xml-v2.c (account_currency_handler): Make
	not use engine commodity funcs to make this testable.  Will have
	to have something to clean this up in production code.
	(account_security_handler): Same.
	(gnc_xml_set_account_data): Oops.  Actually set that we have
	gotten this so the got all test succeeds.
	(gnc_account_end_handler): Start the main parsing setup by relying
	on data struct from io-gncxml-v2.h
	(gnc_account_end_handler): fix free to free the correct thing.
	Add some g_warning calls to make errors more apparent.

2001-02-28  Dave Peticolas  <dave@krondo.com>

	* src/FileDialog.c: store the original (not comma-fied) version
	of the url in the file history.

2001-02-28  James LewisMoss  <jimdres@mindspring.com>

	* src/test/test-xml-account.c (delete_random_account): new func to
	cleanup commodities not generally freed at xaccAccountDestroy.
	(node_and_account_equal): complete func to compare account and the
	dom tree created.  Looks good except for some warnings from
	dom_tree_to_text.

	* src/test/test-stuff.c (equals_node_val_vs_commodity): new func.
	(equals_node_val_vs_guid): New func.
	(equals_node_val_vs_string): new func.

	* src/engine/gnc-account-xml-v2.c (account_code_handler): Add func.
	(account_description_handler): Add func.  Oops forgot a couple.
	(gnc_account_dom_tree_create): Move all string tags in file to
	const gchar*s.
	(account_slots_handler): Complete func.

	* make-gnucash-patch.in: Test to see if makepatch exists.

	* src/engine/sixtp-dom-parsers.c (dom_tree_to_text): same as
	below.  Add NULL tests for arguments.  Affected many functions in
	this file.

	* src/engine/gnc-pricedb-xml-v1.c (price_parse_xml_sub_node): Same
	as below.

	* src/engine/gnc-commodity-xml-v2.c (set_commodity_value): Convert
	dom_tree_to_text to act as rest looking at children on it's own.

2001-02-27  Dave Peticolas  <dave@krondo.com>

	* src/register/gnome/gnucash-scrolled-window.c: subclass of
	gtk_scrolled_window for use in register.

	* src/register/gnome/gnucash-item-list.c: use scrolled window
	for really long account names.

	* doc/sgml/es/Makefile.am (GNUCASH_SGML_FILES): fix list of sgml
	files

	* src/gnc-ui.h: use gncUIWidget not GtkWidget* in non-gnome
	directories.

	* src/engine/sql/PostgresBackend.c (pgendSyncTransaction): add
	missing call to gnc_engine_resume_events ().

2001-02-28  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm: Formatting cleanups.
	Gotta keep Dave P happy . . .

	* src/scm/html-table.scm: html table data field list now stored in
	*reverse* order, to make appending rows fast (prepending is now
	O(n^2) however.  If we want linear-time appends and prepends,
	we'll need a Glist wrapper :) )

	* src/scm/report/folio.scm: use renamed collector functions (dunno
	why, code is dead . . .)

	* src/scm/report/taxtxf.scm: use renamed collector functions (see
	above)

	* src/scm/report/average-balance.scm: changed to use renamed
	collector functions.

	* src/scm/commodity-utilities.scm: changed to used renamed
	make-<foo>-collector functions.

	* src/scm/report-utilities.scm (gnc:make-<foo>-collector): renamed
	to prevent namespace pollution.

2001-02-27  James LewisMoss  <jimdres@mindspring.com>

	* src/test/test-xml-account.c (node_and_account_equal): Start
	proper comparison between node and Account.

	* src/engine/sixtp-dom-parsers.c (dom_tree_to_guid): Merge in Hans
	de Graaff's xml patch.  Use safe_strcmp.

	* src/engine/gnc-xml-helper.h: cleanup.  Merge in Hans de Graaff's
	xml patch.

	* src/engine/gnc-account-xml-v2.c: Merge in Hans de Graaff's xml
	patch.

	* src/test/test-stuff.c (check_dom_tree_version): Add func.

	* src/test/Makefile.am (LDADD): Add EFENCE_LIBS to LDADD  list.

	* src/Makefile.am: Add EFENCE_LIBS to LDADD list.

	* acconfig.h: Add required USE_EFENCE def.

	* configure.in: Add --enable-profiling argument.
	(GHTTP_CFLAGS): Add --enable-efence argument.

2001-02-27  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-userpass.c: add a dialog for username/password
	entry

2001-02-26  Dave Peticolas  <dave@krondo.com>

	* src/engine/gnc-engine-util.h: don't evaluate debug macro
	arguments unless it's going to be printed.

2001-02-25  Robert Graham Merkel  <rgmerk@mira.net>

	* src/engine/Query.[ch]: added support for sorting by account
	names and codes, as well as names and codes for the "other" split
	in the transaction.  also, modified (xaccQuerySetSortIncreasing)
	so you can sort in different orders for the three criteria
	specified.

	* src/engine/Transaction.[ch]: Added new functions for comparing
	splits on account names and codes.

	* src/engine/reconcile-list.c (gnc_reconcile_list_set_sort_order):
	modified to use new query sorting interface.
	
	* src/scm/report/transaction-report-2.scm: New file.  Transaction
	report rewritten for our new improved HTML generator.  Most 
	functionality is now present, but the layout is "homely".  Will 
	fix later.

	* src/scm/report/transaction-report.scm: Old transaction report,
	removed.

	* src/scm/report/report-list.scm: added new transaction report.

	* src/scm/report-utilities.scm: modified for new query sorting
	interface.

	* src/doc/design/multicurrency.discussion.txt: The log of an IRC
	discussion between cstim and myself about his currency-collector
	code.  Included because it's the only documentation we have on
	this material.

	* src/doc/design/.cvsignore: ignore additional generated files.

2001-02-24  Rob Browning  <rlb@cs.utexas.edu>

	* configure.in (AC_ARG_ENABLE): add --enable-error-on-warning.
	Enables -Werror and whatever else is needed for super-strict
	checks.  I'm compiling with this now, and I urge everyone else to
	as well.  We do have a few aggravating things we still ignore,
	like unused variables, but as of today, the whole codebase
	compiles successfully with this turned on.
	(AC_CHECK_PROG): Add a check for etags.
	(AC_ARG_WITH): --with-perl-includes - don't die if CORE not found.
	I install modules in a local directory and use --perl-includes to
	enable gnucash to find Finance::Quote at runtime, but there won't
	be a CORE file.
	(AC_CHECK_LIB): popt - note required Debian -dev package. 

	* macros/autogen.sh (conf_flags): omit --enable-compile-warnings.
	This was adding flags that overrode our configure.in settings;
	specifically, this kept --enable-error-on-warning from working.

	* Makefile.am (noinst_DATA): add optional TAGS target.
	(DISTCLEANFILES): add tags cleanup bits.
	(TAGS): Add fancy TAGS handling.  TAGS file is only built if you
	have etags available, and now it takes into account
	additions/deletions of files in addition to modifications.

	* src/engine/gnc-engine-util.c
	(g_hash_table_key_value_pairs): new - returns a GSList of all the
	key value pairs in a given hash table so you can manipulate them.
	(g_hash_table_kv_pair_free_gfunc): new - g_slist_foreach helper
	for deleting key value hash pairs when you're finished with the
	results from g_hash_table_key_value_pairs.  You'll still need to
	call g_slist_free as well to delete the spine of the list.

	* src/engine/NetIO.c: comment out various bits of the code that's
	incompatible with the recent gnc-book changes.  Linas said he'd
	fix it later.

	* src/scm/price-quotes.scm: new file - not used yet.

	* src/scm/price-quotes.scm: new file - launch a sub-process you
	can talk to bidirectionally from scheme read/write.

	* src/scm/command-line.scm: (disabled) support for getting prices.

	* src/scm/command-line.scm
	(gnc:group-map-accounts): implementation simplified dramatically,
	probably should be dropped entirely, in favor of just calling (map
	thunk (gnc:group-get-subaccounts group)) -- which is what's in the
	replacement code.

	* src/quotes/price-quote-helper.in: new file.

	* src/Backend.h: Delete ERR_FILEIO_MISC (use ERR_BACKEND_MISC).
	Replace ERR_FILEIO_ALLOC with ERR_BACKEND_ALLOC.

	* src/engine/gnc-book.c: add support for GNCPriceDB element.  Move
	still relevant FileIO bits here.  Add support for gnc-book
	clean/dirty checking instead of just Group checking.

	* src/engine/gnc-book.h: fixes for gnc-book marking, private
	header, and addition of pricedb.

	* src/engine/gnc-book-p.h: new file - private book functions.

	* src/engine/Ledger-xml-parser-v1.c
	(ledger_data_after_child_handler): new function to handle grabbing
	the pricedb when we hit it.

	* src/FileDialog.c: Various fixes to replace uses of the top level
	AccountGroup with the parent GNCBook.  Also add support for
	reading/writing the GNCPriceDB.  This file still needs a lot of
	work.  Much of it should become a proper file IO Backend.

	* src/guile/gnc.gwp: Add <gnc:Book*>.  Add gnc:get-current-book.
	Add gnc:book-get-group. Add gnc:account-get-price-src.

	* src/gnome/druid-commodity.c (finish_helper): add support for
	GNCPriceDB.

	* src/engine/sixtp-writers.h: add support for GNCPriceDB.

	* src/engine/sixtp-to-dom-parser.c
	(sixtp_dom_parser_new): change signature to add fail and result
	cleanup functions.  These can be NULL, in which case they're
	ignored.  Also modify overall scheme to clean internal garbage up
	properly in case of failure.

	* src/engine/sixtp-parsers.h
	(sixtp_dom_parser_new): change signature.

	* src/engine/sixtp-dom-parsers.c (dom_tree_to_text): minor fixes.

	* src/engine/sixtp-dom-generators.c
	(text_to_dom_tree): new function.

	* src/engine/sixtp-dom-generators.h
	(text_to_dom_tree): new prototype.

	* src/engine/io-gncxml-w.c: add support for pricedb and using
	GNCBook at top level rather than Group.

	* src/engine/io-gncxml.h: support migration from top level Group
	to top level GNCBook.

	* src/engine/io-gncbin-r.c: add support for detecting legacy
	prices and migrating them to the new pricedb.  Replace top level
	uses of a Group with a GNCBook.

	* src/engine/io-gncbin.h: support pricedb and gnc-book changes.

	* src/engine/io-gncxml-p.h: new file - private header.

	* src/engine/io-gncxml-r.c: move bits to private header.  Make
	changes to support move from top level to Group to top level
	GNCBook.

	* src/gnome/druid-qif-import.c: -Werror fixes.

	* src/engine/gnc-pricedb.h: new file.

	* src/engine/gnc-pricedb-p.h: new file.

	* src/engine/gnc-pricedb.c: new file.

	* src/engine/gnc-pricedb-xml-v1.c: new file.

	* src/engine/gnc-engine-util.h: accomodate new functions.

	* src/engine/gnc-commodity-xml-v2.c
	(gnc_commodity_sixtp_parser_create): fix sixtp_dom_parser_new call.

	* src/engine/gnc-account-xml-v2.c
	(gnc_account_end_handler): -Werror fixes.
	(gnc_account_sixtp_parser_create): fix sixtp_dom_parser_new call.

	* src/engine/date.h (timespec_equal): add back.

	* src/engine/date.c (timespec_equal): add back.

	* src/engine/Commodity-xml-parser-v1.c
	(xml_add_commodity_ref): cleanup.

	* src/FileIO.h: deleted.

	* src/FileIOP.h: deleted.

	* src/FileIO.c: deleted.

	* src/test/test-dom-parser1.c: fixes for new sixtp_dom_parser_new.

	* src/test/test-xml-account.c: fixes for new sixtp_dom_parser_new.

	* src/test/test-xml-commodity.c: fixes for new sixtp_dom_parser_new.

	* src/guile/option-util.h: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/guile/option-util.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/guile/guile-util.h: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/guile/guile-util.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/guile/global-options.h: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/guile/global-options.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/window-register.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/window-main.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/gnc-currency-edit.h: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/gnc-currency-edit.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/gnc-commodity-edit.h: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/gnc-commodity-edit.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/druid-commodity.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/dialog-account.c: remove consts from gnc_commoditities
	(after consultation with Bill).

	* src/gnome/dialog-options.c: remove consts from gnc_commoditities
	(after consultation with Bill).

	* src/gnome/dialog-commodity.h: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnome/dialog-commodity.c: remove consts from
	gnc_commoditities (after consultation with Bill).

	* src/gnc-ui-util.h: remove consts from gnc_commoditities (after
	consultation with Bill).

	* src/gnc-ui-util.c: remove consts from gnc_commoditities (after
	consultation with Bill).

	* src/engine/Transaction.h: remove consts from gnc_commoditities
	(after consultation with Bill).

	* src/engine/Transaction.c: remove consts from gnc_commoditities
	(after consultation with Bill).

	* src/engine/Scrub.c: remove consts from gnc_commoditities (after
	consultation with Bill).

	* src/AccountP.h: remove consts from gnc_commoditities (after
	consultation with Bill).

	* src/Account.h: remove consts from gnc_commoditities (after
	consultation with Bill).

	* src/Account.c: remove consts from gnc_commoditities (after
	consultation with Bill).

	* src/SplitLedger.c: remove consts from gnc_commoditities (after
	consultation with Bill).

	* src/EuroUtils.h: remove consts from gnc_commoditities (after
	consultation with Bill).

	* src/EuroUtils.c: remove consts from gnc_commoditities (after
	consultation with Bill).

2001-02-23  Bill Gribble  <grib@billgribble.com>

	* src/scm/qif-import/qif-dialog-utils.scm: Be more flexible
	about account types on QIF import

	* src/scm/qif-import/qif-objects.scm: make sure the list of
	allowed types is in the right order

	* src/scm/qif-import/qif-to-gnc.scm: be more flexible about type;
	check on parent type after creating child; don't set security on
	non-{stock,mutual} accounts.

2001-02-22  Christian Stimming  <stimming@tuhh.de>

	* src/engine/Transaction.h: Added xaccSplitGetAmount to be used
	instead of SplitGetShareAmount. Added some explanatory comments
	about our commodity restructuring.

2001-02-22  James LewisMoss  <jimdres@mindspring.com>

	* src/test/test-dom-parser1.c: Move generic funcs to test-stuff.c

	* src/test/test-dom-converters1.c: Move generic funcs to
	test-stuff.c 

	* src/test/test-date-converting.c: move generic funcs to
	test-stuff.c 

	* src/engine/sixtp-to-dom-parser.c (dom_start_handler): cast arg
	to xmlNewChild to xmlNodePtr
	(dom_chars_handler): Remove is_whitespace func and use isspace_str
	from other file.

	* src/engine/sixtp-dom-parsers.c: Add all the dom_tree_to funcs.

	* src/engine/sixtp-dom-generators.c (guid_to_dom_tree): Make GUID
	arg const.
	(commodity_ref_to_dom_tree): check nulls.
	(add_kvp_value_node): Add all the kvp code.

	* src/engine/kvp_frame.c: Use string cache func.
	(charstar_va_list_to_gslist): new func.
	(kvp_frame_get_frame): More refactoring.

	* src/engine/gnc-engine.h: Add func def as below.

	* src/engine/gnc-engine.c: Move string cache creation to function
	to get so that you don't have to gnc_engine_init to use the global
	string cache.
	(gnc_engine_get_string_cache): Add func as above.

	* src/engine/gnc-book.h: Add func as below.

	* src/engine/gnc-book.c (gnc_book_get_commodity_table): Add
	function.

	* src/engine/gnc-account-xml-v2.c (gnc_account_dom_tree_create):
	Complete func.
	(gnc_account_end_handler): Fix up.  Finish work.

	* src/engine/Transaction.c (xaccInitSplit): Use func to get string
	cache rather than accessing the var directly.

	* src/engine/Account.h: same as Account.c.  Add comment on
	xaccAccountSet{Currency,Security} that they take control of the
	gnc_commodity args.

	* src/engine/Account.c: Rename xaccAccountSetSlots to *_nc so we
	use the kvp_frame provided rather than copy.

	* src/doc/xml/types.dtd: Fix up kvp type list.  clean up timestamp
	tuff.  Simplify a bit.

	* src/doc/xml/account-v2.dtd: add code and description.

2001-02-19  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/kvp_frame.c: Fix < to be > in binary datasize
	argument (bug fix).  Add comment about appropriateness of
	comparing data sizes first.
	Fix double compare.  was using just gint64 compare.  Extracted out
	double compare into double_compare function.
	Fix return value of kvp_value_compare from gboolean -> gint.
	Fix bug in kvp_glist_compare where it should have read (!lp2 &&
	lp1) and it read (!lp2) so glists never compared equal.
	(kvp_frame_get_hash): Add func.
	(kvp_frame_to_string): Add func.
	(kvp_value_to_string): Add func.
	(kvp_value_glist_to_string): Add func.
	(binary_to_string): Add func.

2001-02-15  Bill Gribble  <grib@billgribble.com>

	* src/scm/qif-import/qif-guess-map.scm: add stock hash
	save/restore to map IO

	* src/scm/qif-import/qif-to-gnc.scm: bug fixes to remove duplicate
	account problems
	
2001-02-15  Christian Stimming  <stimming@tuhh.de>

	* src/scm/report-utilities.scm: Added functions to filter accounts
	by type, and helpers for calculating balances.

	* src/scm/commodity-utilities.scm: (gnc:make-exchange-function)
	now uses <gnc-monetary>.

	* src/scm/html-utilities.scm: (gnc:html-build-acct-table) major
	code cleanup. Added new function to generate a <html-table> of
	exchange rates.

	* src/scm/options-utilities.scm: Added function for another
	option.

	* src/scm/report/{pnl,account-summary}.scm: Added options.

2001-02-15  James LewisMoss  <jimdres@mindspring.com>

	* src/engine/Account.h: Add prototype for SetSlots.

	* src/engine/Account.c (xaccAccountSetSlots): add func.

	* src/test/test-dom-converters1.c (main): Add return_value
	handling to better be a "check"able program.

	* src/test/test-date-converting.c (main): Add return_value
	handling to better be a "check"able program.

	* src/engine/kvp_frame.c (kvp_frame_get_frame): refactor to use
	glist func.
	(kvp_frame_parse_slash_path): extract from slashpath func
	(kvp_frame_get_frame_slash): refactor to use gslist func

	* src/test/test-dom-converters1.c
	(test_dom_tree_to_commodity_ref): Use no_engine version.

	* src/engine/sixtp-dom-parsers.c
	(dom_tree_to_commodity_ref_no_engine): rename func.
	(dom_tree_to_commodity_ref): Add func to do complete commodity
	creation including adding to engine cache.

2001-02-14  James LewisMoss  <jimdres@mindspring.com>

	* src/test/test-dom-converters1.c (Repository): fix mem leak.

	* src/engine/sixtp-dom-parsers.h (Repository): start of kvp code.

	* src/engine/sixtp-dom-parsers.c (Repository): fix mem leak.
	Start of kvp code.

	* src/engine/sixtp-dom-generators.c (Repository): fix mem leak.
	(Repository): Start of kvp code.

	* src/test/test-date-converting.c (Repository): Tests to make sure
	date <-> string converting strings work.

	* src/test/test-dom-converters1.c (Repository): Add tests for rest
	of converters.

	* src/test/Makefile.am (Repository): add new test.  Make "make
	check" work here.

	* src/engine/sixtp-xml-write-utils.c (Repository): use date format
	strings from sixtp-utils.h

	* src/engine/sixtp-utils.h (Repository): add date format strings.
	#include sixtp.h

	* src/engine/sixtp-utils.c (Repository): Use define as timespec
	date format string.

	* src/engine/sixtp-dom-parsers.c (Repository): Add funcs from
	Rob.  make consistent.  Fix a few bugs.  Make
	dom_tree_to_commodity_ref testable by adding new func
	"associate_commodity_ref_with_engine_commodity" to do final
	association with engine commodity table.

	* src/engine/sixtp-dom-generators.c (Repository): Fix to_guid to
	be generic.  Oops.  Add rest of funcs to to foo_to_dom_tree to
	match funcs in sixtp_dom_parsers.

	* src/engine/gnc-numeric.c (Repository): Comment out unused var.

	* src/engine/gnc-account-xml-v2.c (Repository): change to use
	dom_tree_to_commodity_ref. 

	* src/doc/xml/types.dtd: Change cmd: to cmdty: and add ts: to the
	timespec tags.

2001-02-14  Dave Peticolas  <dave@krondo.com>

	* src/engine/date.c: use nl_langinfo (D_FMT) instead of %x for
	locale-based date formatting and parsing.

2001-02-14  Bill Gribble  <grib@billgribble.com>

	* src/scm/qif-import/*.scm: fuzzify account type rules a bit to
	make imports more likely to match up with existing accounts.  Fix
	broken "New" detection.

	* src/gnome/druid-qif-import.c: add default acct based on file 
	name

	* src/gnome/dialog-account-picker.c: make sure picker gets
	scrolled to initial selection.
	
2001-02-14  Christian Stimming  <stimming@tuhh.de>

	* src/scm/html-utilities.scm (gnc:html-build-acct-table): Add
	grouping of accounts according to their types and show their
	subtotal. Major cleanup.

2001-02-13  Bill Gribble  <grib@billgribble.com>

	* src/engine/gnc-numeric.c: fix stupid. stupid. stupid. stupid 
	log10 error

	* src/guile/gnc-helpers.c: start to fix scm_to_gint64 for
	guile-1.3.. this is sort of a duct-tape fix.  We need to port some
	stuff from the guile-1.4 source tree.  Should work fine unless you
	are Bill Gates and you do your accounting in lira.

	* src/gnome/dialog-style-sheet.c: handle WM delete event 

	* src/scm/qif-import/qif-to-gnc.scm: fix backtrace-if-exception 
	usage; add preliminary memo/payee-to-account mapping.

	* src/scm/utilities.scm: define hash-fold if it's not builtin

2001-02-12  Bill Gribble  <grib@billgribble.com>

	* src/scm/html-style-info.scm: minor fixes to html style
	compile

	* various in src/scm: fixes for i18n .. use (N_ instead of (_ 
	where appropriate. 

	* src/engine/gnc-numeric.{c,h}, src/scm/gnc-numeric.scm: add
	support for a new auto-denom type, GNC_DENOM_SIGFIGS(x), where x
	is the number of "significant figures" you want in the output.
	This means that the output denominator will always be a poewr of
	10, but which power is determined by the magnitude of the
	argument.

	* src/engine/Transaction.c, src/gnc-exp-parser.c,
	src/gnc-ui-util.c: make minor changes to use GNC_DENOM_SIGFIGS
	where appropriate.

	* src/gnome/dialog-account-picker.{c,h}: totally rewritten QIF
	import account picker.  this one is much less likely to get you
	into trouble.  Still some rough edges but MUCH better than
	the old one.
	
	* src/gnome/druid-qif-import.c: fixes.  Add memo/payee matching
	(but it's not hooked up to the import yet so don't get that 
	excited).

	* src/scm/qif-import/qif-dialog-utils.scm: memo mapping stuff,
	i18n fixes.

	* src/scm/qif-import/qif-to-gnc.scm: update error catching; print
	backtrace on failure. 
	
2001-02-09  Christian Stimming  <stimming@tuhh.de>

	* src/scm/commodity-utilities.scm: Functions to calculate exchange
	rates (weighted average) for different commodities (moved from
	report-utilities.scm). Major cleanup.

	* src/scm/options-utilities.scm: Option creation functions common
	to several reports. (moved from report-utilities.scm)

	* src/scm/report-utilities.scm: Major cleanup.

2001-02-08  Bill Gribble  <grib@billgribble.com>

	* src/gnome/druid-qif-import.c: restructure druid a bit to 
	allow more flexible navigation (in particular, so we can have 
	a global pref to skip documentation pages)

	* src/scm/html-*.scm: change rendering model to speed up reports.
	use a "string tree" instead of the old with-output-to-string and
	compile style tables where possible.  Strangely enough, alists
	are faster than hash tables.

	* src/scm/html-table.scm: clean up row/col style stuff a little.
	semantics changed a wee bit: now row style takes precedence over
	column style.  this was necessary for performance.

	* src/scm/prefs.scm: add a global pref to skip doc pages in the 
	QIF importer. 

	* src/scm/report.scm: shuffle around a bit for the new rendering
	model.

	* src/gnome/window-report.c: back out some overly-aggressive
	memory reclamation.  I need to figure out how to do this right.

2001-02-08  Christian Stimming  <stimming@tuhh.de>

	* src/scm/date-utilities.scm Added (gnc:timepair-previous-day).

	* src/scm/report-utilities.scm (gnc:account-get-balance-interval)
	Fix bug with start date.

	* src/scm/html-style-info.scm: Fix bug.

	* src/scm/gnc-numeric.scm: Add more functions on gnc-monetary.

	* src/scm/html-utilities.scm: Add balance sign reversal
	conditioned on gnc:account-reverse-balance? for the account
	table. Add function to print exchange rates.

	* src/scm/report-utilities.scm: Modify commodity-collector to
	enable more sign reversals and usage of gnc-monetary. Add option
	creation functions common to several reports.

	* src/scm/report/account-summary.scm: Removed function now in
	report-utilities.scm. Added variables for option names.

	* src/scm/report/pnl.scm: New Profit And Loss report, based on
	account-summary report.

2001-02-08  James LewisMoss  <dres@phoenixdsl.com>

	* src/engine/sixtp.c (sixtp_parse_file): Only set parse_result if
	it points somewhere.

	* src/engine/sixtp-to-dom-parser.c (dom_chars_handler): fix
	character adding.

2001-02-07  James LewisMoss  <dres@phoenixdsl.com>

	* make-gnucash-patch.in: Add a file ending that is ignored.

	* src/doc/xml/types.dtd: Change currency-type -> commodity-type.
	Add defs for cmd:space and cmd:id.

	* src/doc/xml/io-gncxml-version1.dtd: Change currency-type ->
	commodity-type.

	* src/doc/xml/account-v2.dtd: Change currency-type ->
	commodity-type.

2001-02-06  James LewisMoss  <dres@phoenixdsl.com>

	* src/engine/sixtp.c: Use frame creator.
	Move sixtp_handle_catastrophe to here. Add functions
	sixtp_context_new, sixtp_context_destroy.  And change and move
	sixtp_parse_file and sixtp_parse_buffer here from io-gncxml-r.c
	Add concept of a parsing context to hold data.

	* src/engine/sixtp-stack.h: Add creator.  Add headers.

	* src/engine/sixtp-stack.c: Add creator.

	* src/engine/sixtp-parsers.h: add needed headers.
	Add func from sixtp-to-dom-parser.c

	* src/engine/io-gncxml.h: Fix name.

	* src/engine/io-gncxml-w.c: Fix name.

	* src/engine/io-gncxml-r.c: Fix name.  Create stack frame creator
	function and use here.

2001-02-05  James LewisMoss  <dres@phoenixdsl.com>

	* src/engine/sixtp-stack.h: Add glib.h include (needed for GSList)

	* src/engine/sixtp.c: Add catchall tag for parsing handlers.  Use
	name instead of next_parser_tag since that can now contain a magic
	value.

2001-02-05  Bill Gribble  <grib@billgribble.com>

	* src/scm/qif-import/qif-merge-groups.scm: new file.  Utilities
	for detecting duplicate transactions in two account groups.

	* src/scm/qif-import/qif-quick-import.scm: new file (unfinished).
	A start at a "quick import" facility that will import a single
	QIF file with very little interaction. 

	* src/engine/Group.c: be sure to free account split list and
	set to NULL on merge

	* src/engine/Query.c: add a new API to get Transactions from a
	query instead of splits.  you have to specify whether you want
	transactions with one split matching the query or all splits
	matching the query.  More options later.

	* src/gnome/druid-qif-import.c : add a few slots to the 
	QIF window struct and add the extra pages to the dialog to 
	allow review and selection of duplicate transactions 

	* src/guile/gnc.gwp: wrap new Query functions and enums; wrap 
	gnc:group-concat-group 

	* src/scm/gnc-numeric.scm: add gnc-numeric enumerated types.  
	They need to be bitwise combined so don't use g-wrap enum 
	features.

	* src/scm/qif-import/qif-to-gnc.scm: change semantics slightly to
	put new xtns in a new Group and return it before committing.

2001-02-05  Christian Stimming  <stimming@tuhh.de>

	* src/scm/html-utilities.scm: Added sorting of accounts according
	to their account-code. Added calculation of a total sum.

	* src/scm/report-utilities.scm: Improved calculation of the
	exchange rates such more complicated currency configurations can
	be handled.

2001-02-03  Christian Stimming  <stimming@tuhh.de>

	* src/scm/html-utilities.scm: add account table generating
	function which builds a hierarchy and is generalized enough to be
	used in balance- and profit-and-loss style reports. (moved from
	report/account-summary.scm)

2001-02-02  Christian Stimming  <stimming@tuhh.de>

	* src/scm/report-utilities.scm: add function for determining the
	account tree depth (moved from account-summary)

	* src/scm/report/account-summary.scm: changed semantics of account
	selection option. 

2001-02-01  Bill Gribble  <grib@billgribble.com>

	* src/gnome/gnc-html-history.{h,c}: add destroy callback. part of
	report memory management cleanup

	* src/gnome/window-report.c: set report dirty flag when options
	apply or reload is clicked.  Store report object in window 
	struct while it's visible. 

	* src/scm/qif-import/qif-file.scm: expand detection of opening
	balance transactions.  

	* src/scm/qif-import/qif-parse.scm: fix regexp bug in miscincx and
	miscexpx category parsing (thanks carol!)

	* src/scm/qif-import/qif-to-gnc.scm: use correct amount for
	non-stock investment transactions (dividends etc).  Use fuzzy
	equality predicate for inexact numbers.

	* src/scm/report.scm: Add dirty flag and 'children' (other reports
	created by this report... nobody uses it yet) to report struct.
	Add function to clean up report when it's erased from the window
	history.  Add some debugging timing bits to the report-run
	function.  Display cached HTML if not dirty.   

	* src/scm/report.scm: WARNING! Change prototype of report
	rendering functions... they take a <report> object as argument
	instead of an options object.  This is necessary for memory
	management stuff when reports create other reports.

	* src/scm/report/account-summary.scm: fix to use new renderer
	signature

	* src/scm/report/average-balance.scm: fix to use new renderer
	signature

	* src/scm/report/hello-world.scm: fix to use new renderer
	signature

2001-01-30  Bill Gribble  <grib@billgribble.com>

	* src/scm/report/stylesheet-{plain,fancy}.scm: add a new boolean
	option to disable hyperlinks in reports.  This will make it nicer
	to have a "printing" style sheet that disables links when you want
	to print.  (if you change a report's style sheet, click "Reload"
	to see it take effect.  this needs to be fixed)

	* src/gnome/gnc-html-embedded.c: add support for URLsa attached to
	double clicks of pie slices, bar chart bars, and legend entries of
	guppi graphs.  Still need to do this for scatter chart.

	* src/scm/html-{piechart,barchart}.scm: add API for callbacks.
	Not totally finished with barchart yet.

	* src/scm/qif-import/qif-to-gnc.scm: check for currency and type
	mismatches between QIF-imported and existing GNC accounts.  If
	there's a name conflict, rename the new account with a unique name
	and a description indicating there was a conflict.  This should
	fix several reports of crashes for multi-currency users.

	* src/scm/report-utilities.scm: back out my previous breakage of
	gnc:amount->string

	* src/scm/report.scm: Thanks to the guile mailing list for
	pointing my at this odd bit of code needed to print backtraces on
	guile exceptions while still running.  You need to run with
	--debug to get the trace.
	
2001-01-26  Bill Gribble  <grib@billgribble.com>

	* src/gnome/gnc-gpg.{c,h}: if Linas can add useless prototype
	code, so can I :) Gnucash now supports display of GPG-encrypted
	HTML pages via another special <object> block.  

	* src/gnome/gnc-html.c: Add support for GPG stuff.  Fix error 
	reporting to display errors from GHTTP if available. 

	* src/gnome/window-help.c: Add an Open button to open an arbitrary
	URL.  The network IS the computer!

	* src/scm/html-document.scm: Change interface to additional 
	attributes on html-document-markup-start. 

	* src/scm/html-table.scm: Fix rendering of <html-table-cell> to do
	rowspan/colspan correctly.  Add new constructors to build <th>
	<html-table-cells> in addition to <td>

	* src/scm/report-utilities.scm: Rename misnamed d-gnc:foo
	functions to gnc:foo.  d-gnc: is only for preexisting engine
	interface functions that had signature changes.  there's nothing
	inherently deprecated about using doubles in reports.

	* src/scm/report.scm: Start trying to print backtraces on
	exceptions in reports.  Only partially successful at this point;
	the error gets printed but the backtrace won't.  Stay tuned.  You
	need to run with --debug to see the error information.

	* src/scm/report/account-summary.scm: Modify to use new 
	table-cell ctors where appropriate.  Set justification for 
	cells correctly. 

	* src/scm/report/average-balance.scm: Add title. 

	* src/scm/report/stylesheet-plain.scm: Render title in plain
	stylesheet.  Set default table border to 0.
	
2001-01-15  Bill Gribble  <grib@billgribble.com>

	* src/gnome/druid-qif-import.c: remove printout 

	* src/scm/qif-import/qif-parse.scm: Warning dialog on unknown
	Action type.  Add new actions from Q2000.  
	
	* src/scm/qif-import/qif-to-gnc.scm: Fix handling of commissions
	for (hopefully) the last time.  Add new security Action types.
	Don't puke on unknown Action.

	* src/scm/qif-import/qif-dialog-utils.scm: Change default account
	for ShrsIn/ShrsOut to 'Retained Earnings', which is a normal
	account; replaces old policy of stock-denominated Equity
	subaccounts.
	
2001-01-15  Rob Browning  <rlb@cs.utexas.edu>

	* configure.in (G_WRAP_LINK_ARGS): require g-wrap 1.1.5.  This
	should fix a number of problems, including guile 1.3.4
	compatibility (g-wrap was using the *_NEWSMOB macros which guile
	1.3.4 doesn't have), and maybe even Dave's ugly memory issues.

	* src/scm/report/average-balance.scm: new g-wrap fix.
	Essentially all of these g-wrap fixes are to accomodate the new
	type names and visible bindings for g-wrapped non-native types.
	Where we had <gw:wct-void*> we now have <gw:void*>.  This naming
	convention has been applied unilaterally, even for native types,
	so we now have <gw:int>.  Further, types that are gnucash types
	appear as <gnc:Account*>, and types that are glib appear as
	<glib:GList*>, etc.  Finally, in cases where the name of the type
	is already prefixed with gnc, the prefix is not doubled, so we
	have gncSomeThing -> <gnc:SomeThing> and gnc-commodity* ->
	<gnc:commodity*>.

	* src/scm/report-utilities.scm
	(gnc:account-get-balance-at-date): new g-wrap fix.

	* src/guile/option-util.c
	(gnc_option_db_register_change_callback): new g-wrap fix.

	* src/guile/guile-util.c
	(gnc_copy_split): new g-wrap fix.
	(gnc_copy_split_scm_onto_split): new g-wrap fix.
	(gnc_copy_trans): new g-wrap fix.
	(gnc_copy_trans_scm_onto_trans_swap_accounts): new g-wrap fix.
	(gnc_glist_account_ptr_to_scm_internal): new g-wrap fix.
	(gnc_scm_to_commodity): new g-wrap fix.
	(gnc_commodity_to_scm): new g-wrap fix.
	(gnc_glist_commodity_ptr_to_scm): new g-wrap fix.

	* src/guile/gnucash.c.in (gnucash_main_helper): new g-wrap fix.

	* src/guile/gnc.gwp: major rework (mostly s///) for new g-wrap.

	* src/guile/gnc-helpers.c (gnc_scm_traversal_adapter): new g-wrap fix.

	* src/gnome/top-level.c (gnc_ui_show_main_window): new g-wrap fix.

	* src/doc/design/engine.texinfo (Splits): mention location of
	kvp_frame.txt -- the reserved key list.

2001-01-12  Bill Gribble  <grib@billgribble.com>

	* doc/html/C/account-tree-demo.html: add a simple demo of
	embedding a gnucash main window widget in HTML

	* src/gnome/dialog-options.c: add a 'pixmap' option type to
	the GNC options 

	* src/gnome-dialog-style-sheet.{c,h}: new dialog for creating 
	and editing HTML style sheets 

	* src/gnome/druid-qif-import.c: add support for false-if-exception
	error handling within QIF import process

	* src/gnome/gnc-html-embedded.c: add backslash escaping for
	converting string arrays to and from single HTML strings

	* src/gnome/gnc-html-embedded.c: error handling in creating guppi
	plots, and add new embedded object type for embedding a gnucash
	mainwindow-account-tree in HTML (preliminary).  Add x axis 
	label rotation as an option to the barchart.

	* src/gnome/gnc-html.c: fixes for renaming of report objects and
	handling false-if-exception returns from report runs.  Use async
	mode for ghttp requests and add a gtk_timeout callback to check on
	their status.  Add a gnc_html_cancel() which gets rid of pending
	ghttp requests (called by the stop buttons in help, report
	windows)

	* src/gnome/window-help.c: bug fixes for search results printing.
	Don't expand help topics nodes on creation.  Add stop and reload
	buttons to the toolbar.
	
	* src/gnome/window-report.c: Add stop and reload buttons to the
	toolbar.

	* src/guile/gnc-helpers.c: fix helpers for recordization of
	<gnc-numeric> on Scheme side

	* src/scm/engine-utilities.scm: rewrite transaction map functions
	to eliminate ith-transaction calls 

	* src/scm/gnc-numeric.scm: make gnc-numeric into a first class 
	type on the scheme side (<gnc-numeric>)

	* src/scm/html-*.scm (7 files): new architecture for generating
	HTML within reports.  See src/scm/report-html.txt for an overview.

	* src/scm/options.scm: support for pixmap options 

	* src/scm/qif-import/: add false-if-exception error catching in
	QIF import entry points.

	* src/scm/report-utilities.scm: add functions to get immediate 
	subaccounts; rewrite get-balance-at-date.

	* src/scm/report.scm: rename report objects; now the thing that
	gets created by define-report is a <report-template> and the thing
	that has a window and a set of parameters is a <report>.  Add a
	"style sheet" option automatcally to EVERY report, and a "General"
	section to put it in; report with only 1 page of options should
	use "General".  Add false-if-exception error catching to report
	run.

	* src/scm/report/account-summary.scm, src/scm/report/hello-world.scm,
	src/scm/report/average-balance.scm: rewrite some reports using the
	new HTML generation infrastructure.  Old reports won't work until
	they are rewritten.

	* src/scm/report/stylesheet-*.scm (2 files): create some sample
	stylesheet templates. 

2001-01-03  Rob Browning  <rlb@cs.utexas.edu>

	* src/engine/Transaction.h :start documenting reserved split slots.
	add prototypes for new functions below.

	* src/engine/Transaction.c
	(xaccSplitGetType): new function.
	(xaccSplitMakeStockSplit): new function.

	* src/doc/design/engine.texinfo
	(Engine Introduction): add docs for split types, including the new
	stock-split split.
	(General Split API): remove Slot Get/Set function docs.
	(General Split API): add xaccSplitMakeStockSplit docs.
	(Split Getters): add xaccSplitGetType docs.

	* .cvsignore: add TAGS.

2000-12-20  Bill Gribble  <grib@billgribble.com>

	* src/scm/report.scm: minor changes to allow report URLs
	(mainly a structure for "instantiated" reports and a global index
	of instantiated reports).

	* src/scm/help-topics-index.scm: first pass at an index of the
	user manual.  Mainly just to see how it looks.

	* src/gnome/window-report.c: major surgery.  Add embedded
	parameters editor, constructor option for putting in an external
	container, popup menu when no toolbar.

	* src/gnome/window-help.c: major surgery. add topics browser, 
	keyword search, etc etc.  

	* src/gnome/print-session.{c,h}: fix b0rken printing stuff and
	start using gnome-print's print dialog and preview.  Now prints to
	PDF!
	
	* src/gnome/gnc-html*.c: new html infrastructure.  gnc-html.c is
	the basic struct and operations; gnc-html-history is the history
	object; gnc-html-embedded is support for creating embedded graphs
	in HTML.

	* gnc-dialogs.glade: get rid of homemade print preview window; 
	we're using gnome's now.  Add nifty features to help and 
	report windows.

	* src/gnome/dialog-options.c: redo to allow embedding in a 
	pane within a report window.  this means not being a 
	GnomePropertyBox.

	* src/engine/gnc-commodity.c: memory management cleanups 
	(thanx memprof!)

	* src/engine/Query.c: get rid of Split** internally and in 
	return from xaccQueryGetSplits

	* src/SplitLedger.c: update for GList return from 
	xaccQueryGetSplits

	* doc/html/C/guppi*.html: some simple demos of the guppi
	plot system.  You can get at them through the help topics
	browser.

	* build-help-index.pl : a dirt stupid HTML index builder. 
	Constructs a DB2 file from a list of input files. 

	* Add configure checks for guppi, libghttp
	

2000-12-18  Dave Peticolas  <dave@krondo.com>

	* src/register/gnome/quickfillcell-gnome.c: add support for mb
	char sets

	* src/register/gnome/pricecell-gnome.c: add support for mb char
	sets

	* src/register/gnome/gnucash-sheet.c: add support for mb char sets

	* src/register/gnome/datecell-gnome.c: add support for mb char
	sets

	* src/register/gnome/combocell-gnome.c: add support for mb char
	sets

	* src/register/numcell.c: add support for mb char sets

	* src/register/basiccell.c: add support for mb char sets

	* src/register/QuickFill.c: add support for mb char sets

2000-12-14  Robert Graham Merkel  <rgmerk@mira.net>

	* src/guile/Makefile.am: replace hardwired g-wrap module dir
	with value from configure.in.

	* src/engine/gnc-associate-account.[ch] : New files with code for
	associating income/expense accounts with a stock account. Not yet
	hooked up to the UI.

2000-12-13  Rob Browning  <rlb@cs.utexas.edu>

	* src/scm/text-export.scm: kill pointer-token*

	* src/scm/report/transaction-report.scm: minor formatting changes.

	* src/scm/report/taxtxf.scm: kill pointer-token*

	* src/scm/report/folio.scm: use new g-wrap enum support.

	* src/scm/report/budget-report.scm:
	disable report until we fix the enumeration usage.

	* src/scm/report/balance-and-pnl.scm: kill pointer-token*

	* src/scm/report/average-balance.scm: minor formatting changes.

	* src/scm/report-utilities.scm: kill pointer-token*
	(gnc:account-has-shares?): use new g-wrap enum support.

	* src/scm/qif-import/qif-to-gnc.scm: kill pointer-token*

	* src/scm/qif-import/qif-parse.scm:
	delete unusd gif-parse:print-acct-type

	* src/scm/qif-import/qif-guess-map.scm: kill pointer-token*

	* src/scm/main.scm
	(gnc:main): add handle-batch-mode-item so --evaluate works.

	* src/scm/engine-interface.scm: kill pointer-token*.

	* src/scm/c-interface.scm: kill pointer-token*.

	* src/quotes/gnc-prices-2.in: various small fixes (big ones later).

	* src/optional/swig/.cvsignore: add Makefile Makefile.in

	* src/guile/option-util.c
	(gnc_option_db_register_change_callback): update for new g-wrap.

	* src/guile/guile-util.c
	(gnc_copy_split): update for new g-wrap.
	(gnc_copy_split_scm_onto_split): update for new g-wrap.
	(gnc_copy_trans): update for new g-wrap.
	(gnc_copy_trans_scm_onto_trans_swap_accounts): update for new g-wrap.
	(gnc_glist_account_ptr_to_scm): use gnc_glist_to_scm_list.
	(gnc_scm_to_glist_account_ptr): use gnc_scm_list_to_glist.
	(gnc_scm_to_commodity): update for new g-wrap.
	(gnc_commodity_to_scm): update for new g-wrap.
	(gnc_glist_string_to_scm): double speed - use stack.
	(gnc_scm_to_glist_string): don't reverse result.
	(gnc_glist_commodity_ptr_to_scm): update for new g-wrap.
	use gnc_glist_to_scm_list.
	(gnc_scm_to_glist_commodity_ptr): use gnc_scm_list_to_glist.

	* src/guile/gnucash.c.in
	(gnucash_main_helper): add g-wrap module dir to %load-path.
	(gnucash_main_helper): call init_g_wrapped_gnc, not init_gnc.

	* src/guile/gnc.gwp: update for the new g-wrap.

	* src/guile/gnc-helpers.h: add prototypes for new functions.

	* src/guile/gnc-helpers.c
	(glist_to_scm_list_helper): new (private) function.
	(gnc_glist_to_scm_list): new public function.
	(gnc_scm_list_to_glist): new public function.
	(glist_map_helper): new (private) function.
	(gnc_glist_scm_map): new public function.
	(gnc_glist_scm_for_each): new public function.
	(gnc_gettext_helper): always strdup result.
	(gnc_timespec2timepair): use gint64, not long long.
	(gnc_timepair2timespec): use gint64, not long long.
	(gnc_timepair_p): use more accurate test (including range check).
	(gnc_scm_traversal_adapter): use new g-wrap wcp code.
	(gnc_gint64_to_scm): new public function.
	(gnc_scm_to_gint64): new public function.
	(gnc_gh_gint64_p): new public function.
	(gnc_scm_to_numeric): use gint64, not long long.
	(gnc_numeric_to_scm): use gint64, not long long.
	(gnc_numeric_p): use gint64, not long long.

	* src/guile/Makefile.am: update for new g-wrap.

	* src/gnome/top-level.c (gnc_ui_main): use new g-wrap wcp code.

	* src/gnome/druid-qif-import.c: use new g-wrap wcp code.

	* src/engine/gnc-commodity.c: g_strdup the key.
	(gnc_commodity_table_delete_namespace): g_free the key.
	These fixes are probably not sufficient.

	* src/engine/Account.c: make temp warnings more informative.

	* configure.in: update for new g-wrap.
	check for guile bug (sizeof long_long >= long long).
	check that sizeof unsigned long >= guint32.

	* acinclude.m4: update for new g-wrap.

2000-12-08  Dave Peticolas  <dave@krondo.com>

	* src/gnome/gnc-dateedit.c: use more care when using parsed
	date values.

	* src/register/gnome/datecell-gnome.c: use more care when using
	parsed date values.

	* src/engine/Query.c: make sure to use end-of-day times for the
	end date in a search.

	* src/engine/date.c: remove xaccValidateDate -- use mktime instead.
	Use more care when setting struct tm values, especially with is_dst.

2000-12-05  Robert Graham Merkel  <rgmerk@mira.net>

	* src/gnome/account-tree.[ch] (gnc_account_tree_unselect_account):
	Add unselect account functionality as required by mainwindow
	account tree

2000-12-04  Robert Graham Merkel  <rgmerk@mira.net>

	* src/gnome/mainwindow-account-tree.[ch]: new file.  Widgetizes
	the current contents of the main window in preparation for
	pane-ization.

	* src/gnome/window-main.c: modified to take account of the above.

2000-11-17  James LewisMoss  <dres@debian.org>

	* src/doc/design/reports.texinfo (Reports): Reorder option
	descriptions to match the order in the example function.

	* src/doc/design/Makefile.am (gnucash_design_TEXINFOS): Add info
	files to clean list (why the hell aren't they already cleaned?)

2000-11-15  James LewisMoss  <dres@debian.org>

	* src/doc/design/register.texinfo (Split Register): Move a little
	something around to make sure dvi/ps output doesn't spill off side
	of page.

	* src/doc/design/intro.texinfo (Introduction): Move a little
	something around to make sure dvi/ps output doesn't spill off side
	of page.

	* src/doc/design/fdl.texinfo (GNU Free Documentation License):
	Comment out @bye causing texi2dvi to quit not completing the
	output. 

2000-11-09  Bill Gribble  <grib@billgribble.com>

	* src/engine/gnc_numeric.c: fix remainder-handling error

	* src/scm/qif-import/qif-dialog-utils.scm: only ask about 
	stocks that are in the QIF files being loaded.

	* src/scm/qif-import/qif-file.scm: add progress bar to file read

	* src/scm/qif-import/qif-to-gnc.scm: add progress bar to 
	transaction mark and import.

2000-11-08  Bill Gribble  <grib@billgribble.com>

	* src/engine/SplitLedger.c: use new SetShareAmount/SetValue
	semantics (need to make sure this is correct!)

	* src/engine/Group.c: fix the "splits in GList with NULL data"
	problem.

	* src/engine/Transaction.c: get rid of Set***Directly functions,
	and modify the gnc_numeric versions of SetValue and SetShareAmount
	to use the direct semantics (i.e. SetValue doesn't affect the
	ShareAmount any more unless you use the deprecated double API).

	* src/engine/gnc-numeric.c: fix gnc_numeric_convert and
	double_to_gnc_numeric to ameliorate overflow problems.  This
	should fix the wrong balance problems people are seeing.

	* src/gnome/druid-qif-import.c: make selection persistent in
	account/cat pick lists

	* g-wrap gnc-numeric datatype and API; shuffle the Scheme API in
	the same way the C was done to add the new gnc-numeric API using
	the "real" function names and deprecate the old double API by
	prefixing the names with d-.  Now (for example)
	gnc:split-set-value takes a gnc_numeric arg, and
	d-gnc:split-set-value takes a double.  All calling scheme code was
	sed'ed to make this change.

	* src/scm/qif-import/qif-dialog-utils.scm: fix stock name regexp
	parsing bug in QIF importer.  This should fix the crash that many
	people have reported.

	* src/scm/qif-import/qif-file.scm: fix an Opening Balance
	processing bug that was causing some opening balance transactions
	to be duplicated.

	* src/scm/qif-import/qif-to-gnc.scm: fix double-counting of
	Commissions.  Change to use gnc_numeric and new Set semantics;
	this should (maybe) fix some reported off-by-a-penny problems.
	
2000-11-05  Rob Browning  <rlb@cs.utexas.edu>

	* src/engine/io-gncxml-w.c: sort commodities by namespace and id
	before writing so we get stable output.

2000-10-30  Dave Peticolas  <dave@krondo.com>

	* src/gnc-exp-parser.c: modify to use gnc_numerics instead of
	doubles.

	* src/engine/gnc-numeric.c: special case num == 0 to prevent
	divide by zero exception.

2000-10-27  Dave Peticolas  <dave@krondo.com>

	* src/calculation/expression_parser.c: handle (num) as -num.

2000-10-26  Dave Peticolas  <dave@krondo.com>

	* src/engine/util.c (DxaccParseAmount): handle (num) as -num.

2000-10-23  Rob Browning  <rlb@cs.utexas.edu>

	* src/scm/main.scm:
	(gnc:*batch-mode-things-to-do*): new var - keep track of startup bits.
	(gnc:main): add --load processing for "things-to-do".

	* src/scm/engine-utilities.scm:
	(gnc:filename->account-group): new - likely temporary.
	(gnc:call-with-account-data-from-file): new - likely temporary.

	* src/scm/command-line.scm (gnc:*arg-defs*): add --load option in
	addition to --evaluate.

	* src/engine/sql/PostgresBackend.c: handle changes in the rest of
	the code.

	* src/engine/kvp_frame.c: change the datatype a little to pull the
	union tag into the main struct.  Also update the functions and
	datatypes to more closely mirror glib types.  i.e. lists are now
	just GLists that must contain only kvp_value pointers.  The kvp
	docs have *not* been updated to reflect these changes (nor the
	changes listed below).
	(kvp_frame_set_slot): now setting a slot to a NULL value deletes
	the slot.  This is not in the docs yet.
	(init_frame_body_if_needed): new function - only initialize the
	guts of the kvp_frame if we need them.  This helps in some
	situations and should be free otherwise.  All the other functions
	should handle this properly now.
	(kvp_value_new_binary_nc): new function - create a new binary
	object using the pointer given directly.
	(kvp_frame_for_each_slot): new function.
	(kvp_value_compare): new function.
	(kvp_frame_compare): new function.

	* src/engine/kvp_frame.h: accomodate changes to kvp_frame.c.
	
	* src/engine/guid.c:
	(guid_compare): new function.
	(guid_hash_to_guint): hash function from glib.
	(guid_hash_table_new): new function.
	(guid_g_hash_table_equal): new function.

	* src/engine/guid.h: accomodate changes to guid.c.

	* src/engine/date.c:
	(timespec_equal): new function.

	* src/engine/date.c: accomodate changes to date.c.
	
	* src/engine/Transaction.c: update all functions to mark the
	account's dirty flags when needed.
	(xaccTransGetSlot): deleted - replaced by xaccTransGetSlots.
	(xaccTransSetSlot): deleted - replaced by xaccTransGetSlots.
	(xaccTransGetSlots): new function.
	(xaccTransEqual): new function.
	(DATE_CMP): don't use pointer to pointer args (unnecessary).
	(xaccSplitDateOrder): now a total order - sort on guid if needed.
	(xaccSplitOrder): deleted - unused.
	(xaccTransOrder): now a total order - sort on guid if needed.
	(xaccTransSetDocref): deleted.
	(xaccTransGetDocref): deleted.

	* src/engine/Transaction.h: accomodate changes to Transaction.c.

	* src/engine/TransactionP.h: accomodate changes to Transaction.c.
	
	* src/engine/Session.c:
	(xaccSessionGetFileError): new function - migrate away from using
	global for error status.
	(xaccSessionBegin): change semantics - a begin does *not* load the
	file automatically now.  You must call xaccSessionLoad for that.
	This is better, particularly in the SaveAs case when the load is
	wasteful, and, until we fix the GUID code up so that loading the
	same file twice doesn't cause a detonation, safer.
	(xaccSessionBegin): change semantics - same as for
	xaccSessionBegin.
	(xaccSessionLoad): new function - loads the session data.
	(xaccSessionSaveMayClobberData): new function - predicate.
	(xaccSessionSave): change semantics - don't delete the file if
	topgroup is NULL.  This is too scary given all the other changes.
	We can bring it back later if needed, but I'd probably rather see
	an xaccSessionPurgeStorage, or similar.
	
	* src/engine/Session.h: support changes to Session.c.

	* src/engine/Makefile.am: handle new, deleted, and renamed files.

	* src/engine/Group.c: handle vanished account id's, etc.
	(xaccGroupEqual): new function.
	(xaccGroupVisitUnvisitedTransactions): new function.
	(xaccGroupForEachTransaction): new function.
	(xaccGroupMapAccounts): new function (probably going away later).
	(xaccGroupForEachAccountDeeply): ditto.

	* src/engine/Group.h: handler changes to Acccount*'s and to Group.c.

	* src/engine/GNCId.c:
	(xaccGetAndResetEntityTable): new function - needed when you want
	to load two files representing the same data for
	comparison.
	(xaccSetEntityTable): new function - needed when you want
	to load two files representing the same data for
	comparison.

	* src/engine/GNCIdP.h: accomodate changes to GNCId.c

	* src/engine/Account.c: many changes, removed some unused fields,
	changed Account's to have a GList of splits rather than a NULL
	terminated array of pointers - allowed optimizing several things
	and made the code cleaner in spots.
	(xaccAccountBeginEdit): remove defer argument - difficult to
	handle with nesting - may add later if really needed.  Change this
	and
	(xaccAccountCommitEdit): to handle nesting.  Fix up all setter
	routines to respect Begin/Commit, including ones for splits over
	in Transaction.c.
	(xaccInitAccount): Add/use sort_dirty and balance_dirty flags.
	Change kvp_data to always be initialized (also changed kvp_frames
	to be lighter weight when empty).
	(xaccAccountEqual): new function.
	(xaccSortSplits): new function.
	(xaccAccountBringUpToDate): new function.
	(xaccAccountGetSlot): deleted - replaced by xaccAccountGetSlots
	(xaccAccountSetSlot): deleted - replaced by xaccAccountGetSlots
	(xaccAccountGetSlots): new function - returns kvp_frame.
	(xaccAccountGetID): deleted - accounts no longer have IDs.
	(xaccAccountGetID): deleted - accounts no longer have flags.
	(xaccAccountCheckDateOrder): renamed to xaccAccountFixSplitDateOrder.
	(xaccCheckTransDateOrder): renamed to xaccTransFixSplitDateOrder.
	(xaccAccountSetNotes): notes now stored in slot "notes".
	(xaccAccountGetNotes): ditto.
	(xaccAccountTypeEnumAsString): new function - required by text IO.
	(xaccAccountStringToType): new function - required by text IO.
	(xaccAccountSetPriceSrc): prices now stored in slot "old-price-source".
	(xaccAccountGetPriceSrc): ditto.
	(xaccAccountVisitUnvisitedTransactions): new function.
	(xaccAccountForEachTransaction): new function.
	
	* src/engine/Account.h: changes to accomodate above changes to
	Account.c.

	* src/engine/Account.h: changes to accomodate above changes to
	Account.c.

	* src/engine/io-gncxml-r.c: new xml format reader.  This has a
	semi-abstract incremental configurable low-ish memory XML tree
	parser inside which should later be broken out into a separate
	file.

	* src/engine/io-gncxml-w.c: new xml format writer.  This is pretty
	straightforward, but due to limitations in libxml, has large
	memory requirements.  It has to build the entire XML tree in RAM
	before it writes anything.

	* src/engine/io-gncxml.h: new file - the current XML handling does
	*not* have any transparent file compression.  Expect that soon -
	it doesn't make the performance any worse (thank goodness).

	* src/engine/io-gncbin-r.c: renamed from src/engine/FileIO.c.
	Only the reader is still active.  All writing is as XML now.

	* src/engine/io-gncbin.h: renamed from src/engine/FileIO.h.

	* src/engine/FileIO.c: new file - now the meta-level file that has
	functions that handle the various underlying file types.  Any old
	docref fields are stored in an "old-docref" slot and any old price
	sources are stored in an "old-price-source" slot.  Handle the fact
	that account id's are gone.

	* src/engine/FileIO.h: new file.

	* make-gnucash-patch.in: ignore some more autogen files.

	* src/FileDialog.c: update to handle new Session* semantics.
	Saving and SavingAs are not the same anymore, session-wise.  We
	don't perform a pointless (and GUID dangerous) load before we
	SaveAs.

	* Many changes, not all of which will be documented right now.
	This patch must get out.  I'll come back and fix this up later.
	The highlights are...

2000-10-16  Bill Gribble  <grib@billgribble.com>

	* Patch for new numeric representation, new commodity 
	  representation, and rewritten QIF importer.  

	  - numeric format: the engine's internal representation of values
	  changed from 'double' to 'gnc-numeric', an exact number format.
	  see src/doc/gnc-numeric.txt.  This patch is step 1; the old
	  'double' engine API remains, but the names have been changed
	  from (for example) xaccSplitSetValue to DxaccSplitSetValue. The
	  D means deprecated.  Will be gradually migrating the usage of
	  doubles to gnc-numeric throughout gnucash, eventually removing
	  the Dxacc API completely.  ATM, there is no scheme support for
	  gnc-numeric, so I just left the Scheme API alone (old function
	  names still work, and work the same way).

	  - commodity representation: up to now, the engine has just used
	  strings to represent currencies.  Now we use a struct
	  'gnc-commodity', which has more information about the
	  currency/stock/commodity than its name, including what exchange
	  it trades on and what the resolution of transactions is in
	  fractional units.  When you read in an old gnucash file, you
	  will get a 'wizard' that will ask questions about the currencies
	  and stocks in your old file.

	  - QIF importer: I redid the GUI to be more of a wizard style.
	  This should get rid of a lot of people's problems using it since
	  it's more step-by-step oriented.

	* src/scm/qif-import/qif-to-gnc.scm: set Reconcile correctly.
	Also numerous other small changes.

	* src/scm/qif-import/qif-parse.scm: handle 20000101 date formats
	and MiscExpX category lines correctly.

	* src/scm/qif-import/qif-file.scm: correctly handle ambiguous 
	date format by asking the right answer.

	* src/scm/qif-import/qif-dialog-utils.scm: use the correct account
	separator char for automatically created accounts 

	* src/scm/hooks.scm: added a file-opened-hook that gets run 
	any time a gnucash file is opened.  

	* src/engine/gnc-engine.{c,h}: new files for global engine
	meta-operations.  I mainly needed it to add a global list of known
	'commodities' (currencies, stocks, etc), but there's now an
	gnc-engine-init function called at startup with settable hooks.

	* src/gnome/dialog-account.c: add "select" buttons for account
	security and currency.  Still need to make "smallest currency
	unit" configurable per-account, but need to fix common-currency
	problem first.

	* src/gnome/dialog-find-transactions.c: use gnc_dateentry widget

	* src/engine/Translog.c: warning! log format for numbers is 
	now "%Ld/%Ld", numerator/denominator.

	* src/engine/Query.c: change date query functions to be more
	useful.  Start and end dates are optionally ignored, making it 
	possible to say "any date before.." or "any date after.." 

	
2000-09-16  Dave Peticolas  <dave@krondo.com>

	* src/register/table-allgui.c: re-implement using gtables.

	* src/register/cellblock.c: re-implement using gtables.

	* src/register/gtable.c: implentation of a dynamic 2-d array.

2000-09-13  Dave Peticolas  <dave@krondo.com>

	* src/SplitLedger.c (xaccSRSaveChangedCells): don't copy memo
	and action to other split.

2000-09-12  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-transfer.c (gnc_xfer_dialog_close_cb):
	disconnect amount edit entry signals to avoid gtk warnings.

	* src/engine/Transaction.h: make xaccInitTransaction a private
	function.

	* src/scm/qif-import/qif-to-gnc.scm: Don't init a new transaction.
	gnc:transaction-create does this automatically. Doing it again leaks
	memory.

2000-09-11  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-transfer.c: incorporate amount editing widget
	into the transfer dialog.

	* src/gnome/gnc-amount-edit.c: new widget to allow amount editing
	with expression parsing.

2000-09-05  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/date-utilities.scm ((gnc:reldate-initialize)): New
	function - initialise explicitly at startup rather than in ad-hoc
	manner

2000-08-31  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/balance-and-pnl.scm: Bug fixes for new date
	options.

	* src/scm/report/transaction-report.scm: Bug fixes for new date
	options.

	* src/scm/report/budget-report.scm: Bug fixes for new date options.

2000-08-30  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/hello-world.scm: A couple of new functions to
	test the relative and combination date style options.

	* src/scm/report/*.scm: Modified date options to take the new
	function.  Most are still using absolute options at this stage,
	will get modified to use relative dates later.

	* src/scm/options.scm (gnc:make-option): new argument
	(option-data-fns) for manipulating multi-choice style options.
	Changes to option-makers to either support this.
	(gnc:make-date-option): modified to support relative and
	combination dates.

	* src/scm/date-utilities.scm: Extensive additions for manipulating 
	relative dates.

	* src/guile/option-util.c: Support for new relative-date and
	combination options , and use of scheme getters
	rather than direct data structure manipulation.
	(gnc_oiption_db_lookup_date_option): modified to
	support relative and combination date options.
	(gnc_option_date_option_get_subtype: new function.

	* src/guile/guile-util.c (gnc_timepair2timespec): Check to make
	sure it's a timepair before doing conversion.

	* src/gnome/dialog-options.c: Extensive changes to support relative
	and combination date options.  Also changed multichoice callback
	to use wrapped scheme getter rather than directly manipulating
	scheme data structure.

	* make-gnucash-patch.in: Exclude generated HTML.

2000-08-26  Dave Peticolas  <dave@krondo.com>

	* src/engine/Group.c (xaccGetAccountRoot): remove unnecessary
	casts.

	* src/gnome/window-reconcile.c
	(gnc_ui_reconcile_window_delete_cb): rewrite to use g_lists.

2000-08-23  Dave Peticolas  <dave@krondo.com>

	* src/engine/kvp_frame.c: use g_strdup, not strdup.

	* src/calculation/expression_parser.c: use glib memory routines.
	(exit_parser): fix a bug where pe->named_vars was freed twice.

2000-08-22  Dave Peticolas  <dave@krondo.com>

	* src/engine/Transaction.c (xaccSplitSetBaseValue): check to
	make sure the security is not "" before allowing price changes.

	* src/gnome/window-register.c (gnc_register_check_close): use
	xaccSRCancelCursorTransChanges to cancel any pending changes.

2000-08-21  Dave Peticolas  <dave@krondo.com>

	* src/gnome/reconcile-list.c (gnc_reconcile_list_fill): fix
	a memory leak. xaccTransGetDateStr returns a malloc'd string.

	* src/engine/: Move transaction date routines from date.c to
	Transaction.c. Move definition of Timespec from Transaction.h
	to date.h. Some code cleanup in date.c.

	* src/register/QuickFill.c (qfInsertTextRec): When inserting new
	strings, don't replace older strings that are prefixes of the new
	string.

	* src/engine/gnc-common.h: remove gncBoolean type and constants.
	Replace all uses with glib versions.

2000-08-12  Dave Peticolas  <dave@krondo.com>

	* src/engine/Transaction.c (xaccSplitSetBaseValue): don't adjust
	the price when the base currency is the security of the account.

2000-08-10  Dave Peticolas  <dave@krondo.com>

	* src/register/table-allgui.c (gnc_table_physical_cell_valid): bug
	fix -- get the virtual cell of the target location before getting
	the cellblock.

2000-08-09  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-utils.c: remove unused code

	* src/gnome/dialog-account.c: new file implementing the
	consolidated account add and account edit windows using glade.

2000-08-07  Dave Peticolas  <dave@krondo.com>

	* src/register/*.c: Use glib memory allocation routines.

	* src/register/cellblock.c: fix memory leaks and use glib memory
	allocation routines.

	* src/register/table-allgui.c: reimplement the Table code using
	glib's dynamic arrays. Clean up the code and homogenize the
	function naming convention.

2000-08-04  Dave Peticolas  <dave@krondo.com>

	* src/register/table-gnome.h: remove unused data members

	* src/register/basiccell.h: remove the pixel_width argument
	to the realize callback, it is no longer used.

	* src/register/table-allgui.c: remove the gnc_table_column_width
	call.

2000-08-07  Rob Browning  <rlb@cs.utexas.edu>

	* src/scm/tip-of-the-day.scm: don't initialize at startup.

	* src/scm/main.scm (gnc:*batch-mode-forms-to-evaluate*): new
	global to hold forms added by --evaluate for execution after
	startup.
	(gnc:main): support --evalutate properly.

	* src/scm/engine-utilities.scm (gnc:transaction-map-splits): moved
	here.
	(gnc:group-map-accounts): moved here.

	* src/scm/command-line.scm (gnc:*arg-defs*): add --evaluate
	option.  This should be considered beta, and it's not documented
	yet, but it's useful for me right now, we need something like it,
	and I'd like others to see what they think.  Also, this will only
	work right when I finish fixing up tip-of-the-day to not
	initialize when the file loads.

	* src/pixmaps/Makefile.am: minor typo.

	* src/guile/option-util.c: include string.h

	* src/guile/guile-util.c: include string.h

	* src/guile/gfec.c: include string.h

	* doc/gnucash.1: change filename extension in example to .gnc

	* configure.in: always report missing templates as an error.

	* README: updates (also change = to # for section seps (helps CVS))

2000-07-22  Dave Peticolas  <dave@krondo.com>

	* src/gnome/window-reconcile.c: After reconciliation, if the
	account is a credit card account, automatically pop up a transfer
	window with the appropriate amount and accounts.

2000-07-21  Dave Peticolas  <dave@krondo.com>

	* src/calculation/fin.c: Some cleanup and renaming of function
	names to be longer and more descriptive.

	* src/gnome/dialog-transfer.c: Add Num field to the transfer
	dialog. Add APIs to change the amount, the description, and the
	accounts. Fix a bug in the default sense of the show/hide buttons.

2000-07-20  Dave Peticolas  <dave@krondo.com>

	* src/gnome/top-level.c (gnc_ui_destroy_all_subwindows): destroy
	open transfer windows.

	* src/Destroy.c: remove notes window functions.

	* src/AccWindow.h: remove notes window functions.

	* src/gnome/dialog-transfer.c: Make transfer dialog modeless.

2000-07-19  Dave Peticolas  <dave@krondo.com>

	* src/gnome/account-tree.c: Use income_expense instead of
	category for names.

2000-07-12  Dave Peticolas  <dave@krondo.com>

	* src/SplitLedger.c (LedgerAutoCompletion): simplify, and fix a
	bug with split auto-completion.

	* src/scm/bootstrap.scm.in: add HOME/.gnucash to scm search path.

2000-07-04  Dave Peticolas  <dave@krondo.com>

	* src/scm/bootstrap.scm.in: bump up the stack limit

	* src/engine/date.c (xaccValidateDate): move this function from
	src/register/datecell.c to here, so it can be used elsewhere.

	* src/gnome/gnc-dateedit.c: make the widget respond to the same
	accelerators as the register date cell.

2000-07-03  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/c-interface.scm: Added scheme definition for
	pointer-token-null? if not already defined by g-wrap. Fixes bug
	when compiling with g-wrap >= 0.9.4.

2000-06-28  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-budget.c (entry_down_button_clicked): bug fix.

	* src/gnome/dialog-options.c: implement font options.

	* src/scm/prefs.scm: add options for the register fonts.

	* src/gnome/top-level.c: configure the register fonts from
	callbacks.

	* src/register/gnome/gnucash-style.c: make the register font and
	hint fonts configurable outside the register.

2000-06-28  Robert Graham Merkel  <rgmerk@mira.net>

	* src/gnome/dialog-totd.c: If somebody tries to open a second
	tip of the day window, just raise the original.  Fixes a crash
	when somebody tried to do this before.

2000-06-27  Robert Graham Merkel  <rgmerk@mira.net>

	* src/gnome/dialog-totd.c: Added code to make "Tip of the day"
	dialog modeless

2000-06-27  Dave Peticolas  <dave@krondo.com>

	* src/gnome/top-level.c (gnucash_ui_init): set the reconciled cell
	string getter to the dialog-utils function for i18ning the reconcile
	flag value.

	* src/engine/Transaction.c (xaccSplitSetReconcile): make sure the
	reconciled flag given is good.

	* src/register/splitreg.c: modify for the changes in the reconcile
	cell.

	* src/SplitLedger.c: modify for the changes in the reconcile cell.

	* src/register/recncell.c: make the reconcile cell a real object,
	not just a BasicCell with some extra functions. Add functionality
	for distinguishing between the flag value and the displayed value.

2000-06-26  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-utils.c (gnc_get_reconcile_str): new function.
	Return i18n'd string for reconciled flag.

	* src/gnome/reconcile-list.c: use i18n'd reconciled flag string.

	* src/scm/tip-of-the-day.scm: put the check for whether tips
	should be shown or not inside the hook. We can't do the check
	here because the options haven't been loaded yet.

	* src/scm/options.scm: fix bug in writing options. Use 'write'
	to output section and option names for proper escaping.

2000-06-27  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/date-utilities.scm: Added date-granularity timepair
	comparison functions. Removed direct access functions to the time
	structures in various functions (Dave also worked on this).

	* src/scm/report/transaction-report.scm: Changed to use date
	comparison functions in date-utilities.scm.

2000-06-26  Robert Graham Merkel  <rgmerk@mira.net>

	* src/guile/global-options.[ch] (gnc_option_refresh_ui_by_name):
	New function to make refreshing the GUI options possible from C as
	well as scheme.
	(gnc_set_boolean_option): C function to set boolean options from
	outside the options dialog.

	* src/gnome/dialog-totd.[ch]: New files containing the GUI
	functions for doing tips of the day.

	* src/guile/tip-of-the-day.[ch]: New files with a C interface for
	the scheme tip of the day engine.

	* src/guile/option-util.[ch] (gnc_option_db_set_boolean_option):
	New function to set a boolean option.
	
	* src/scm/tip-of-the-day.scm: New file: an interface for reading
	in and passing tips to the gui in text form.

	* src/scm/tip-list.scm: A list of tips as a Scheme list.  File
	should probably be shifted somewhere else.

	* src/scm/startup.scm: Loads tip-of-the-day.scm

	* src/scm/prefs.scm: Add an option for displaying tips of the day
	at startup.  Also added gnc:support line.

	* src/gnome/window-main.c (gnc_ui_totd_cb): Added menu entries and
	callbacks to add "tips of the day" to help menu.

2000-06-23  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-utils.c (gnc_window_adjust_for_screen): new
	function. if the window size is bigger than the screen, adjust
	it down. Use this for the account add and edit, reconcile, and
	register windows.

	* doc/html/C/projects.html: update last version info

	* doc/html/C/xacc-about.html: update last version info

	* src/guile/gnucash.c.in: update last version info

2000-06-21  Dave Peticolas  <dave@krondo.com>

	* src/register/splitreg.h: break out the register type and the
	register style into two separate struct members, instead of using
	bitmasks. This is much, much simpler.

	* src/optional/swig/Makefile.am (gnucash-engine-perl5_wrap.c):
	remove the -stat argument, it's no longer support in later swig
	versions.

	* src/register/Makefile.am: don't compile table-html.c, it is
	not needed for linking.

	* src/gnome/window-register.c: remove include of table-html.c

	* src/engine/gnc-common.h: use 'gboolean' to typedef gncBoolean.
	We should probably just phase out the use of gncBoolean.

2000-06-20  Dave Peticolas  <dave@krondo.com>

	* src/engine/util.c (xaccParseAmount): accept 8 decimal places
	instead of 6, and trucate if more than 8.

	* src/gnome/dialog-add.c: make this window modeless.
	(gnc_ui_accWindow_ok_cb): don't let the user add an account with
	the same fully-qualified name as another account.

	* src/gnome/top-level.c (gnc_ui_destroy_all_subwindows): destroy
	all the account add windows, too.

	* src/gnome/window-main.c (gnc_refresh_main_window_title): new
	function to put the current filename in the main window title.
	(gnc_refresh_main_window): use the above when refreshing.

	* src/FileDialog.c (gncFileSaveAs): refresh the main window after
	'saving as' to update the filename in the main window.

2000-06-19  Dave Peticolas  <dave@krondo.com>

	* src/guile/gnc.gwp: take out GUIDs for Groups.

	* src/engine/Group.c: take out GUIDs for Groups. Groups are really
	just lists with no additional structure, and giving them GUIDs
	complicates matters without adding any utility. You can always use
	the parent account GUID instead.

	* src/gnome/top-level.c: configure list auto-popping from here.

	* src/register/gnome/combocell-gnome.c: determine whether or not
	to auto-pop lists based on a class variable, and not by looking
	up the guile function. This removes a src/guile dependency from
	src/register/gnome.

2000-06-14  Dave Peticolas  <dave@krondo.com>

	* src/register/gnome/gnucash-item-edit.c (item_edit_show_list):
	make sure the current selected item is visible and, before doing
	so, process all pending events to make sure the list is shown and
	sized first.

2000-06-13  Dave Peticolas  <dave@krondo.com>

	* src/SplitLedger.c: refresh the main window before refreshing the
	register. This makes sure balances are recomputed first.

	* src/engine/Transaction.c (xaccSplitSetBaseValue): mark the split
	as having changed.

	* src/gnome/gnc-currency-edit.c: loosen the restrictions on what
	can be typed in. The 'currency' could potentially be a stock
	symbol.

2000-06-12  Dave Peticolas  <dave@krondo.com>

	* src/gnome/dialog-transfer.c: don't use 'Categories', it's a
	confusing term.

	* src/SplitLedger.c (LedgerAutoCompletion): open transaction
	without deferring rebalancing.

2000-06-09  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm (): commented out
	"merged" style because of conflict with double-column amounts.

2000-06-08  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/average-balance.scm (average-balance-renderer): 
	added a condition to catch incorrectly entered dates without crashing.

2000-06-07  Dave Peticolas  <dave@krondo.com>

	* src/engine/Query.c: fixed a "dave is an idiot" bug in cropping
	the split list.

	* src/gnome/window-register.c (gnc_register_create_menu_bar): don't
	use stock close menu -- it's for closing files not closing windows.

	* src/gnome/dialog-add.c (gnc_ui_accWindow_create_account): don't
	make an opening balance transaction.

	* src/SplitLedger.c: use value, not share amount, for debit/credit
	cells in equity registers.

	* src/gnome/dialog-utils.c (gnc_ui_install_field_strings): set the
	code even if it's blank. Auto-coding doesn't work right now.

2000-06-06  Dave Peticolas  <dave@krondo.com>

	* src/SplitLedger.c (LedgerTraverse): use correct argument for
	exact_cell to gnc_table_find_valid_cell_horiz.
	(LedgerMoveCursor): ditto.

	* src/register/splitreg.c (xaccInitSplitRegister): Don't blank
	zeros in the price cell.

	* src/guile/gfec.c: fix bugs in usage of internal guile functions.
	more cleanup.

2000-06-05  Dave Peticolas  <dave@krondo.com>

	* src/register/splitreg.c (xaccInitSplitRegister): use higher
	precision for stock prices.

	* src/<lots>: moved gui-dependent definitions from
	src/engine/gnc-common.h to src/engine/gnc-ui-common.h.
	Use guint32 instead of home-grown typedef. This touched
	many files.

	* src/guile/guile-util.c (gnc_get_debit_string): make sure to
	return a malloc'd string.

	* src/register/splitreg.c (configLabels): check for NULL strings
	from the label getters.

	* src/gnome/window-register.c (gnc_register_date_window): if 'show
	all transactions' is not set in the preferences, limit it to
	30. Temporary fix for 1.4, this should be configurable.

	* configure.in: changed '! test' to 'test !'.

	* src/engine: removed *Consolidate* functions. These were cruft
	used by the old QIFIO routines.

2000-06-04  Dave Peticolas  <dave@krondo.com>

	* src/engine/util.c: add log level modification functions.

	* src/scm/command-line.scm: add a --loglevel argument to set the
	logging level.

2000-06-04  Rob Browning  <rlb@cs.utexas.edu>

	* */Makefile.am and others: fix up make dist to build a full-blown
	tarfile.

2000-06-04  Dave Peticolas  <dave@krondo.com>

	* src/engine/Session.c (xaccSessionSave): record file writing errors
	in the session error code.

	* src/FileDialog.c (gncFileSave): print an error message in a dialog
	on file-writing errors.

	* src/register/quickfillcell.c (quick_modify): before updating the
	original copy, make sure it's still the same as the old value,
	modulo case.

2000-06-03  Dave Peticolas  <dave@krondo.com>

	* src/engine/FileIO.c: John Goerzen's patch for 64-bit
	architectures.

2000-06-02  Dave Peticolas  <dave@krondo.com>

	* src/register/splitreg.c: added functions for getting cell types
	and getting the locations for cell types.

	* src/SplitLedger.c: add functionality for auto-completion

2000-06-02  Rob Browning  <rlb@cs.utexas.edu>

	* quite a few bugfixes to the automake stuff.

	* guid-md5.* -> md5.* - Dave liked this better, and I did too.

	* src/register/gnome/* - restored ... for now.

2000-06-01  Rob Browning  <rlb@cs.utexas.edu>

	* README: many mods to accomodate new changes, but still unfinished.

	* configure.in: --with-opt-style-install changed to
	--enable-opt-style-install

2000-05-31  Rob Browning  <rlb@cs.utexas.edu>

	* Giant automake switchover.
	doc/html/*/pix/ -> doc/html/*/image/
	intl/* - new directory/contents (filled via gettextize).
	src/doc - new directory to collect src docs.
	src/experimental - new directory.
	src/gg -> src/experimental/gg
	src/cbb -> src/experimental/cbb
	src/optional - new directory for configure --with and --enable bits.
	src/swig -> src/optional/swig - preparation for new quoting system.
	src/swig/perl5 deleted - swig is now just in a single directory.
	src/reports/File.c -> src/guile/File.c
	src/register/gnome/* -> src/register/* - automake wants flat lib dirs. 
	src/qt deleted - docs indicate how to get it if you want it.
	src/motif deleted - docs indicate how to get it if you want it.
	src/g-wrap merged into src/guile.
	src/engine/guid/* -> src/engine - automake wants flat lib dirs.
	man/* -> doc/
	lib/* deleted - nothing needed right now; see lib/README.
	gnucash.gdb-cmds -> doc/
	gnucash.desktop -> src/gnome/
	gnucash deleted - see doc/README.build-system
	etc/config -> src/guile/config
	doc/html/logos/ -> doc/html/C/logos - this should handle intl better.
	doc/build-system -> doc/README.build-system
	doc/aix.txt -> doc/build-aix.txt
	doc/SuSE-6.3.txt -> doc/build-suse.txt
	doc/solaris.txt -> doc/build-solaris.txt
	doc/README -> README - as per GNU coding/automake standards.
	doc/INSTALL -> INSTALL - as per GNU coding/automake standards.
	Makefile.init.in deleted - not needed with automake.
	Makefile.common deleted - not needed with automake.
	Configure-uw7 -> doc/Configure-uw7
	Configure-osr5 doc/Configure-osr5
	ABOUT-NLS - new file.
	AUTHORS - as per GNU coding/automake standards.
	*/Makefile.am - new automake files.
	acconfig.h - aclocal.m4 is now autogenerated, so use this instead.
	Various libtool files automagically added by libtool.
	src/examples/xacc-shell.c -> old/xacc-shell.c

	* src/scm/startup.scm: load depend.scm here.

	* src/scm/report/average-balance.scm: handle new possible #f
	return from gnc:group-get-account-list.

	* src/scm/engine-utilities.scm (gnc:group-get-account-list):
	moved here and reworked to build result in order, no reverse.
	Change to return #f on error so it can be distinguished from an
	empty list.

	* src/scm/engine-utilities.scm: new file.

2000-05-31  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c (configLabels): label the straight xfer
	and xfer to cells as 'Account', label the mirrored xfer as just
	'Transfer'.

	* src/register/gnome/gnucash-header.c
	(gnucash_header_reconfigure): also redraw if the style changes.

2000-05-30  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/quickfillcell.c: if a quickfill attempt fails,
	replace the string with the original case string.

2000-05-29  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report-2.scm (make-account-subheading): 
	added the ability to display balances at start-of-report date
	when sorting by accounts.  Also replaced gnc:split-get-amount
	(which doesn't exist) with gnc:split-get-value for amount sorting.

	* doc/guile-hackers.txt: Added pointers to g-wrap now that it's
	not part of the main gnucash distribution.

2000-05-24  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c: some simplification, some additional
	complexity :) Fixed a crash-bug with traversing out of the
	pending transaction and rolling it back. Fixed traversal out
	of the blank line of a multi-split transaction that has been
	edited.

2000-05-23  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine: removed QIF routines from the engine.

	* src/scm/options.scm: add a currency option type.

	* src/gnome/dialog-options.c: add support for currency options.

	* src/gnome/dialog-utils.c (gnc_ui_account_field_box_create): used
	the new currency editor widget.

	* src/gnome/gnc-currency-edit.c: new widget for picking currencies.

2000-05-22  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/guile/guile-util.c (gnc_depend): new function to access the
	gnc:depend guile function.

2000-05-21  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-reconcile.c: use share balances when
	reconciling stock, mutual fund, and currency accounts.

2000-05-20  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/Account.c (xaccAccountRecomputeBalance): added share,
	cleared share, and reconciled share balance tracking, along with
	api calls for getting them.

	* src/engine/Transaction.c: add calls to get share cleared and
	reconciled balance.

	* src/engine/Query.c: use g_list_prepend and then reverse when
	gathering splits. When pruning the list, prune from the beginning,
	not the end, per the original semantics. Handle the case when
	q->max_splits is 0.

	* src/gnome/dialog-add.c (accWindow): if the window is closed as a
	result of a gnome_dialog_close, don't save the size or destroy the
	window, it's already gone.

	* configure.in: remove check for readline. guile-config should
	return the right values. Also, change LOCALE_DIR definition to
	$datadir/locale. This seems to be more correct.

	* src/swig/perl5/Makefile.in: use -fPIC because it's needed on
	sparcs and doesn't seem to hurt for others.

	* src/gnome/window-register.c (gnc_register_sort): just sort by the
	given key and then by the standard order.

	* src/gnome/window-reconcile.c: add menus to change the sort order
	of the debits and credits list.

	* src/engine/Query.c: allow the sort order to be set as increasing
	or decreasing.

2000-05-19  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-style.c (gnucash_style_init): use
	default style's font. Unfortunately, there doesn't seem to be a
	way to get a default italic font, so use the regular one for now.

	* src/gnome/reconcile-list.c: use Queries to get the splits so
	we can do sorting. Add an api call to change the sort order.

	* src/engine/Query.c (xaccAmountMatchPredicate): debits are
	positive, credits are negative.

	* Makefile.in: install files and directories one at a time. If the
	user does not have an install script, the one supplied in the
	gnucash distribution can only handle one file at a time.

	* src/engine/util.c (xaccParseAmount): allow negative sign to be
	at the front or back of the amount.

2000-05-18  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-reconcile.c: make the finish button sensitivity
	depend on whether the reconciliation is balanced.

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_activate_cursor_cell): if the callback changes the
	value, redraw.

2000-05-17  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/Query.c: allow sorting by reconciled date and
	reconcile status.

	* src/gnome/window-reconcile.c: add a 'statement date' to the
	reconciliation date. This date is used to set all the reconcile
	dates of the splits that get reconciled.

	* src/engine/Transaction.c (xaccSplitSetReconcile): don't change
	the reconcile date when the reconcile status is changed.

2000-05-18  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report-2.scm: Fixed *some* of the
	bugs with two-column balance displays.

2000-05-17  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-reconcile.c (gnc_recn_create_tool_bar): add a
	'Finish' reconcile button to the toolbar.

	* src/register/splitreg.c (configLabels): use callbacks to get
	debit/credit headings.

	* src/guile/guile-util.c: new functions to access guile
	debit/credit synonyms by account type.

	* src/scm/prefs.scm: added debit/credit synonym configuration.

2000-05-16  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/guid/guid.h: change the GUID struct to a union with
	an integer to force 32-bit alignment on systems that need it.

	* src/register/splitreg.c (xaccInitSplitRegister): in a currency
	register, set the is_currency flag on the price cell.

	* src/register/pricecell.c (xaccSetPriceCellIsCurrency): function
	to set printing of currency prices in price cells.

	* src/engine/util.c (xaccSPrintAmount): added a PRTCUR flag for
	printing currency prices. Changed flags type from short to unsigned
	int with a typedef of GNCPrintAmountFlags. Changed other files to
	reflect this.

	* src/scm/report/balance-and-pnl.scm: fix html error (fix from
	Martin Schwenke).

	* src/guile/guile-util.c: many bug fixes.

	* src/scm/engine-interface.scm: fix list-ref arg order bug.

	* src/SplitLedger.c (xaccSRCountRows): fix a bug when a two or
	more splits from the same transaction are in the same account. Fix
	other bugs including not accessing deleted splits/transactions.
	Improve the refresh strategy. Could this code get any more
	complicated? Yes...

2000-05-15  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c (xaccSplitRegisterGetCursorTypeRowCol):
	new function, get cursor type by virt row/col.

	* src/scm/report/transaction-report.scm: debits on left, credits
	on right.

	* src/engine/guid/md5.c (md5_process_bytes): fix 32-bit alignment
	bug.

2000-05-14  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/guile/guile-util.c: added several interface functions to
	src/scm/engine-interface.scm.

	* src/Refresh.c (gnc_account_glist_ui_refresh): added a refresh
	function that takes glib lists. Much more convenient.

	* src/SplitLedger.c: add functionality for transaction
	cut/copy/paste.

	* src/MultiLedger.c (ledgerIsMember): always return true
	for SEARCH_LEDGERS. Simple, but safe.

2000-05-12  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* Makefile.in: add -follow arguments to find commands

	* Makefile.common (CFLAGS): removed hard-coded profiling option

	* configure.in: add a profiling argument.

	* src/guile/gnucash.c: use putenv, not setenv. putenv is POSIX,
	seems to be more common.

2000-05-10  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* many: removed use of SCM registry in favor of scm_protect_object
	and scm_unprotect_object.

	* src/engine/GNCId.c (xaccRemoveEntity): don't allow the NULL id
	to be removed.

	* src/scm: remove some old, unused files.

	* src/register/splitreg.c (configLayout): swap mirrored xfer from
	and xfer to field in the transaction line of the ledgers.

2000-05-09  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-add.c (gnc_ui_accWindow_create_account): insert
	the account *after* setting the account values so the sort order
	is correct.

	* src/engine/Account.c (xaccAccountInsertSplit): check the currency
	before inserting.

2000-05-08  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/GNCId.c (xaccGUIDNew): new function to generate
	IDs for gnucash. Use this, not guid_new. Also modified other
	engine files to use this function.

	* src/register/pricecell.c (COLORIZE): check for being close to
	zero before colorizing red.

	* src/scm/main.scm (gnc:main): if no filename was specified, open
	the most recent file in the history.

	* src/gnome/file-history.c (gnc_history_get_last): new function to
	return the last filename the user opened.

2000-05-08  Rob Browning  <rlb@cs.utexas.edu>

	* make-gnucash-patch.in: change gnucash.h to gnucash.c in ignores.
	Delete src/messages_i18n.h from ignores.
	Remove g-wrap files from ignores.

	* src/guile/gnucash.c.in: new file (now auto-generated)
	This and the following change fix a mutual dependency problem.

	* src/guile/gnucash.h: new file (no longer auto-generated).

	* src/Makefile.in (CLEAN_SUBDIRS): add quotes.
	(all targets): build g-wrap before guile. 

	* Makefile.init.in (VERSION): Added to fix problems with rpm spec,
	etc.

2000-05-08  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/pricecell.c: allow the cell to be blanked directly.

	* src/SplitLedger.c (xaccSRLoadRegEntry): explicitly blank the
	balance cell for the blank split.

	* src/register/splitreg.c (xaccInitSplitRegister): don't blank zeros
	on the balance cell by default.

	* src/gnome/window-main.c (gnc_main_create_menus): rename the
	'Help' menu item to 'Manual'.

2000-05-07  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/guile/i18n.h.in: always include locale.h

	* src/messages_i18n.h: no longer needs to be configured.

	* configure.in: don't bother checking for locale.h, we have
	to have it anyway.

	* aclocal.m4: always include locale.h

	* src/gnome/window-register.c (deleteCB): use g_strdup_printf
	instead of asprintf.

2000-05-06  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/Query.c: g_list_sort *returns* the new first node.

	* src/engine/Group.c
	(xaccAccountsBeginStagedTransactionTraversals): bug fix -- used wrong
	pointer type.
	(xaccSplitsBeginStagedTransactionTraversals): bug fix -- used wrong
	pointer type.

	* src/gnome/reconcile-list.c (gnc_reconcile_list_fill): print the
	amount using the account's currency.

	* src/gnome/dialog-transfer.c (gnc_xfer_dialog_create): remove the
	currency symobl from the dialog and use the account currency, if
	available, in printing amounts.

	* src/gnome/window-adjust.c: remove the currency symbol from the
	dialog and use the account currency in printing amounts.

2000-05-05  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c (xaccSRSaveRegEntry): set the date entered
	time of the blank split transaction.

	* src/gnome/window-reconcile.c: print different currencies
	correctly. Print reconciled balance so far.

2000-05-04  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-main.c (gnc_main_create_toolbar): removed the
	'open file' item from the toolbar, to lessen conflict with the
	'open account' item.

2000-05-03  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c: add a gui option for sorting by
	date entered.

	* src/engine/Query.c: add a BY_DATE_ENTERED sorting option.

	* src/scm/prefs.scm: convert the gui options to internal options.

	* src/scm/options.scm: add an interal option type with no frills.

	* src/engine/util.c (xaccSPrintAmount): add a space after the
	currency code to make the currency symbol.
	(gnc_lconv_set_char): check for the lconv default value using
	CHAR_MAX, not 127.

2000-05-02  Rob Browning  <rlb@cs.utexas.edu>

	* Makefile.in: switch to sed to handle non-makefile generation.

	* Makefile.init.in: kill PATH mangling.
	Add DIFF GUILE and g-wrap command handling.
	
	* configure.in: Many changes related to the great g-wrap exodus
        and the change to handle non-makefile with sed.
	Kill recursive var expansion.
	Kill prefix pre-expansion.
        Remove fancy guile handling - presume newer guile (which is required).
        Remove non-makefiles from AC_OUTPUT (except the locale stuff for now).

	* doc/build-system: Document configure handling of non-makefiles.

	* lib/Makefile.in: expunge g-wrap.

	* make-gnucash-patch.in: use sed @--@ handling for expansions.
	Be strict.
	Add ignore for src/messages_i18n.h

	* po/Makefile.in.in: handle extract-macros.perl.in vars with sed.

	* po/extract-macros.perl.in: handle vars with sed.

	* rpm/Makefile.in: new file.  Handle gnucash.spec.in with sed.

	* rpm/gnucash.spec.in: use @--@ vars.

	* src/Makefile.in: handle src/quotes in the build process.
	Re-order src/guile to build before src/g-wrap.
	
	* src/g-wrap/Makefile.in: handle new version of g-wrap.

	* src/gnome/Makefile.in: fix compile var handling for g-wrap, etc.

	* src/guile/Makefile.in: fix compile var handling for g-wrap, etc.
	Add sed handling for gnucash.h.in.

	* src/guile/gnucash.h.in: handle g-wrap changes.
	Handle removal of EXPANDED vars.
	Switch to sed @--@ vars.

	* src/qt/Makefile.in: fix compile var handling for g-wrap, etc.

	* src/quotes/Makefile.in: new file.
	Handle gnc-prices.in with sed.

	* src/quotes/gnc-prices.in: Switch to sed @--@ vars.

	* src/scm/Makefile.in: Handle bootstrap.scm.in with sed.

	* src/scm/bootstrap.scm.in: Switch to sed @--@ vars.

2000-05-02  Robert Graham Merkel  <rgmerk@mira.net>

	* man/gnc-prices.1: fixed typo.

	* src/scm/report/transaction-report-2.scm: fixed typo for debit string
	and reversed displayed sign in debit column.

2000-05-01  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report-2.scm : Added i18n and
	optional two-columns printout to the new transaction report.

2000-04-30  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/Queue.c (xaccQueueGetShares): computation should start
	at the tail split, not at split 0.
	(xaccQueueGetValue): ditto.

	* src/scm/report/average-balance.scm: track stock account balances,
	i.e. value, not cost.

2000-04-29  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c: add a flag determining whether to use
	regular labels or only debit/credit.

	* src/gnome/top-level.c: implement the debit/credit label option

	* src/scm/prefs.scm: added option to only use debit/credit labels
	in the register.

	* src/MultiLedger.h: remove the MAX_SPLITS constants

	* src/gnome/window-main.c (gnc_ui_refresh_statusbar): no need to
	reverse quantities.

	* src/gnome/top-level.c (gnc_configure_reverse_balance): take out
	debit sign-reversal type.

	* src/scm/prefs.scm: take out debit sign-reversal type

	* src/SplitLedger.c: debit/credit reversal.

	* src/register/pricecell.c: debit/credit reversal.

	* src/register/splitreg.c: switch the column labels for the
	debit/credit reversal.

	* src/gnome/window-reconcile.c: fix up the dialog for the
	debit/credit reversal. Also, fix the calculations so the user
	can change sign-reversal modes while the dialog is open.

	* src/gnome/window-main.c (gnc_ui_delete_account): refresh the
	main window fully.

	* src/gnome/reconcile-list.c (gnc_reconcile_list_fill): debits are
	positive, credits are negative.

2000-04-28  Robert Graham Merkel  <rgmerk@mira.net>

 	* src/scm/html-generator.scm (html-table-do-entry): Bryan Larsen's
	fix for null (#f) generators.

2000-04-28  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/option-util.c: redid the option database storage as
	a hash table, so databases have the same handle throughout their
	lifetime.

	* src/engine/Transaction.c (xaccTransOrder): only compare nums if
	they are non-blank.

2000-04-27  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-main.c (gnc_ui_refresh_statusbar): use ASSET
	type to determine sign reversal for assets quantity.

2000-04-25  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/guid/guid.c (guid_init): add hostname and domainname
 	to the mix.

	* src/engine/AccInfo.c (xaccAccountTypesCompatible): relax the
 	restrictions on account types. Go to three groups: asset &
 	liability, income & expense, equity.

	* src/engine/FileIO.c: no need to free NULL pointers.

2000-04-24  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/average-balance.scm: the min and max columns
	were swapped. Also, the last average balance entry wasn't being
	calculated correctly.

	* src/gnome/dialog-options.c: modified to use gnc-dateedit.

	* src/gnome/window-adjust.c: modified to use gnc-dateedit.

	* src/gnome/window-register.c: modified to use gnc-dateedit.

	* src/gnome/dialog-transfer.c: modified to use gnc-dateedit.

	* src/gnome/gnc-dateedit.c: new file. gnome date editor modified
 	to use gnucash date printing and parsing routines. I plan on
 	extending this with additional features, too.

	* src/engine/Group.c (xaccMallocAccountGroup): loop until we
	get a unique id. This is just paranoia code. Ditto for Account.c
	and Transaction.c.

	* src/engine/Account.c: add some 'const' keywords to string
	arguments. This affected many other files.

	* src/engine/Scrub.c: i18n strings used to make new accounts.

2000-04-22  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-options.c: use the default section, if present,
	when building the dialog.

	* src/scm/options.scm: option databases can have default sections.

	* src/scm/report/transaction-report-2.scm: make the default option
	section "Report Options". Change "x Display" section to "Display".
	Add title of report to string database.

2000-04-21  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/average-balance.scm: comment out query function.
	This needs to be fixed when the new query api gets g-wrapped.

	* src/engine/Query.c: (xaccFreeQuery): free the split list
	(xaccQueryGetSplits) handle a null account group

	* src/gnome/dialog-edit.c: figure out all the accounts affected
	by a currency/security/type change and ask the user whether the
	needed changes should be made.

	* src/gnome/dialog-utils.c (gnc_fill_menu_with_data): also recurse
	for GNOME_APP_UI_SUBTREE_STOCK.

	* src/gnome/top-level.c (gnc_configure_reverse_balance): change
	asset-expense to all debit accounts.

	* src/register/numcell.c: include <limits.h> per Eric Hanchrow's
	fix.

2000-04-16  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/g-wrap/gnc.gwp: wrap functions for getting account guids and
	looking up accounts by guids.

	* src/g-wrap/gnc-helpers.c: add helper functions for using guids.

	* src/scm/prefs.scm: add an assets-expense choice to which kinds of
	accounts are sign-reversed.

	* src/gnome/top-level.c (gnc_configure_reverse_balance): handle the
	asset-expense choice.

2000-04-15  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-style.c (gnucash_style_layout_init):
 	added a missing 'break' statement.

2000-04-14  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/AccInfo.c: allow the price source to be set to NULL.

	* lots of build system files: changes for the global id stuff.

	* src/engine/GNCId.c: engine globally unique id api implementation.

	* src/engine/guid/md5.c: taken from GNU textutils.

	* src/engine/guid/guid.c: new file with routines for generating
	globally unique ids.

2000-04-10  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* doc/README: only the environment variable LANG needs to
	be set to change the locale.

2000-04-09  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/srfi/srfi-1.r5rs.scm: renamed 'list-index' to
 	'list-index-pred'. guile-1.3.4 defines a list-index with
	different api and semantics.

	* configure.in: make gnucash.spec configured

	* rpm/gnucash.spec.in: new file, same as old gnucash.spec, but
	with @VERSION@ instead of a hard-coded version number. Removed
	gnucash.spec.

	* src/scm/prefs.scm: make the default field types be description
 	and total

	* src/gnome/window-main.c (gnc_configure_account_tree): set the
	state of the total field

	* src/gnome/account-tree.c: add in the new total field

	* src/gnome/dialog-utils.c: add the new account field key
 	ACCOUNT_TOTAL. This key refers to the account's balance plus the
 	balances of all children. The ACCOUNT_BALANCE key now refers to
 	the balance of the account itself, without children.

2000-04-08  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/balance-and-pnl.scm: remove the report description.
	It just looked weird!

	* src/scm/command-line.scm (gnc:prefs-show-version): use the
	configured version instead of hard-coding it.

	* src/scm/bootstrap.scm.in (gnc:version): configure this guile
	variable with the gnucash version info.

	* src/SplitLedger.c (xaccLoadXferCell): == not = Doh!!!

2000-04-07  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/Query.c (PROLOG): move declaration of da and db
	locals into the macros that actually use them. This gets rid
	of some annoying warnings.

	* src/register/numcell.c: added method to set the last number
 	entered.  The next number entered is now the last number + 1.

	* Makefile.in: changed [ -e filename ] to [ -f filename ]

	* src/scm/report.scm: Changed the report format to be a record.

2000-04-05  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* configure.in: removed check for eperl

	* src/reports: removed pathconfig.h.in and Sheet.? (eperl stuff)

	* src/gnome/window-help.c: took out gncReport call (eperl)

	* lib/Makefile.in: took out make dist hack

	* src/register/table-allgui.c: more error checking

	* src/SplitLedger.c: more cleanup. Fix a bug in refreshing a register
	in auto-mode where the current transaction has been deleted.

	* src/scm/report/balance-and-pnl.scm: put sub-accouts below their
	parent accounts and indent their names. Align the columns better.
	Print fully-qualified names.

2000-04-04  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-style.c: update the styles
 	appropriately for the changes below.

	* src/register/splitreg.c: configure the ledger style register
	with a xfer to field in all modes.

	* src/SplitLedger.c (xaccSRLoadRegister): remove stock price hack.
	many code cleanups throughout file.

2000-04-03  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c: changed menu definitions to be
	statically allocated.
	* src/gnome/window-main.c: ditto

	* src/SplitLedger.c: added extra checks for boundary conditions.
	When refreshing, try to go to the same cell offset as before.

2000-04-01  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c: more generalizations needed for general
 	ledger operation.

	* src/register/splitreg.c (configLayout): add the xto cell into
	the transaction cursor.

2000-03-31  Rob Browning  <rlb@cs.utexas.edu>

 	* src/scm/Makefile.in: set top_srcdir and include Makefile.init

 	* src/reports/pathconfig.h.in: use new GNC_EXPANDED_ vars.

 	* src/quotes/gnc-prices.in: new file.

 	* src/quotes/gnc-prices: deleted.

 	* src/guile/gnucash.h.in: use new GNC_EXPANDED_ vars.

 	* src/guile/i18n.h.in: use new GNC_EXPANDED_ vars.

 	* src/guile/Makefile.in (top_srcdir): set.

 	* src/Makefile.in: minor cleanups and safety code.

 	* make-gnucash-patch.in: new file.

 	* make-gnucash-patch: deleted.

 	* lib/Makefile.in: re-configure g-wrap after every distclean and
 	rebuild/install it on every build.

 	* gnucash: fix the doc-path to match the new structure.  This
 	fixes things back the way they were, but now we need to add
 	runtime locale detection.

 	* doc/build-system: new file - should eventually cover
 	build-system info and justifications.

 	* configure.in: changes to accomodate the new GNC_EXPANDED_*
 	vars.  See doc/build-system for a summary.

 	* Makefile.init.in (ABSOLUTE_TOP_SRCDIR): set
 	(top_srcdir): don't set (it has to be set in each separate Makefile.in)

 	* Makefile.config.finish: deleted.

 	* Makefile.in: minor cleanup -- some safety checks.

 	* Makefile.common: Clear all the .SUFFIXES rules.  They were
 	causing weird behaviors when I was trying to create some new
 	implicit rules.

 	* src/scm/printing/number-to-words.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/printing/print-check.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/qif-dialog-utils.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/qif-file.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/qif-guess-map.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/qif-import.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/qif-objects.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/qif-parse.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/qif-to-gnc.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/qif-utils.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/qif-import/simple-obj.scm: scope gnc:depend and
 	gnc:support calls. 

 	* src/scm/main.scm: fix load-path problems.

2000-03-31  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (gnc_transaction_delete_query): ok, we
	can't destroy the dialog on close, because we need the widgets to be
	there afterwards. gtk_widget_destroy() the dialog instead.

	* src/register/splitreg.c: add a SEARCH_LEDGER register type. Don't
	include the balance field in 'ledger' style registers.

	* src/register/gnome/gnucash-style.c (gnucash_style_layout_init):
 	new layouts for ledgers -- they don't have a balance field. We'll
 	probably need to redo them if we add a xto field. Broke out the
	actual layout construction into separate functions.

2000-03-30  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c (xaccSRSaveRegEntry): remove the 'special
 	case' for setting the price. It is no longer needed.

	* src/gnome/window-register.c (gnc_reg_set_window_name): set the
 	name regardless of whether there is a leader.

	* src/SplitLedger.c (xaccSRLoadRegister): fixed a possible memory
 	leak in destroying the buffer

2000-03-29  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/transaction-report.scm: bug fixes and speed
 	improvements

	* src/engine/Group.c: added some new transaction traversal code

	* src/scm/report/folio.scm: implement the old eperl report

2000-03-28  Robert Graham Merkel  <rgmerk@mira.net>

 	* man/gnc-prices.1: new file.  Man page for gnc-prices. Somebody
 	please add installation from makefile!

2000-03-27  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/budget-report.scm: removed use of transaction
 	report function. This was generating a value that was not
 	subsequently used.

2000-03-26  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/transaction-report.scm: i18n the report

	* src/gnome/window-register.c (gnc_transaction_delete_query):
 	destroy on close, don't hide.

	* src/register/splitreg.c: several new functions for saving and
	restore the contents of the cursor.

	* src/SplitLedger.c (xaccSRRedrawRegEntry): always redraw, caller
 	knows best!
	(LedgerMoveCursor): if we are leaving the pending transaction,
 	commit it.
	(xaccSRLoadRegister): save and restore changed cursor values.
	(xaccSRSaveRegEntry): clear the register change flags.

2000-03-24  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/quickfillcell-gnome.c (QuickFillDirect): if
 	the cursor is in the selection, move it to the start of the
 	selection.

	* Makefile.common: add the value of DEFS to the compile flags

	* Makefile.init.in: get the value for DEFS.

	* src/register/numcell.c: new cell for entering numbers. Handles
	accelerators for increasing/decreasing the number and remembers
	the largest number for auto-filling.

2000-03-23  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/average-balance.scm: fixed many things and i18n'd
	the report.

	* src/engine/util.c (PrintAmt): always use '.' as the decimal point
	coming from sprintf.

2000-03-22  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/prefs.scm: set the default currency code using the
	wrapped C function in util.c below.

	* src/engine/util.c (xaccSPrintAmount): add a PRTNMN flag for
 	printing non-monetary values.
	(gnc_locale_default_currency): return the currency code for the
 	current locale.

	* src/register/splitreg.c (xaccInitSplitRegister): update for
 	changes to the price cell api.

	* src/engine/util.c (xaccSPrintAmount): set the precision based on
 	the locale.

	* src/register/pricecell.c: remove some unneeded api calls and
	add one for specifying that the cell contains a share quantity.

2000-03-19  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-options.c (gnc_option_set_ui_widget): request
	a reasonable size for the number-range widget.

	* src/FileDialog.c (gncFileQuerySave): return a boolean value
 	indicating whether the user wants to proceed or cancel. The uses
 	of this function have been updated to respond appropriately.

2000-03-18  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/Query.c (xaccInitQuery): make the standard engine
 	order the default sort order.

	* src/gnome/window-adjust.c (adjBRefresh): update the title

	* src/Refresh.c (gnc_account_ui_refresh): refresh the edit account
	and adjust balance windows too.

	* src/gnome/dialog-edit.c: add gui for changed the account type.

	* src/engine/Account.c (xaccAccountSetType): allow account types
 	to be changed.

2000-03-15  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/extensions.scm (gnc:new-menu-namer): register and
 	translate the names correctly.

	* src/scm/report.scm (gnc:report-menu-setup win): make sure the
 	report title gets registered and translated.

	* src/scm/report/hello-world.scm: i18n'd this report.

2000-03-14  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_register_key_press_cb): generate activate event on a
 	keypad enter as well as the return key.

	* Docs/C/xacc-ticker.html: updated for Yahoo Europe information.

2000-03-13  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-utils.c: added Yahoo Europe to the quote source
 	menu.

	* src/quotes/Quote.pm: added method for getting Yahoo European
 	quotes. Also, fixed the parsing of csv data.

	* src/quotes/gnc-prices: cleanup the code, less wordy output.

	* src/quotes/Quote.pm (yahoo): updates from latest YahooQuote.pm

2000-03-12  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/c-interface.scm (gnc:error->string tag args): print a
 	stack backtrace.

	* src/gnome/cursors.c: when given a NULL argument, the set and
	unset busy cursor function change all top-level window cursors.
	This breaks the motif side though, in that the cursor will no
	longer get set there. Oh well.

	* src/gnome/window-register.c (duplicateCB): new callback for
 	duplicating the current transaction/split.

	* src/SplitLedger.c (xaccSRDuplicateCurrent): new function to
 	duplicate the current split or transaction.

	* src/gnome/window-report.c (gnc_run_report): set the busy cursor
	while running the report generator.

2000-03-10  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-main.c (gnc_ui_refresh_statusbar): revise the
 	profit and asset calculation.

	* src/MultiLedger.c (xaccLedgerDisplayRefresh): don't reverse the
 	balances ever -- let the GUI do it.

	* src/motif/RegWindow.c (regRefresh): reverse the balances
	for INCOME and expense.

2000-03-09  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (regRefresh): print
 	reversed-balanced account balances appropriately.

2000-03-07  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/transaction-report.scm: a few bug fixes.

	* src/gnome/window-main.c (gnc_ui_delete_account): destroy the
 	windows *then* remove the account from the tree. Sometimes,
 	destroying the window can result in a refresh, which will do
 	strange things if we have already removed the account from the
 	tree.

2000-03-06  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-reconcile.c (recnRefresh): resize the window

	* src/FileDialog.c (gncPostFileOpen): set the busy cursor while
 	reading the file.
	(gncFileSave): ditto.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_update_adjustments): set the step increment.

2000-03-06  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-style.c
 	(gnucash_sheet_style_set_col_width): Adjust the overall style
 	width, too.

	* src/register/gnome/gnucash-header.c
 	(gnucash_header_auto_resize_column): Resize the window to fit the
 	register.
	(gnucash_header_event): ditto on a column resize.

2000-03-05  Rob Browning  <rlb@cs.utexas.edu>

	* src/scm/report/transaction-report.scm: add support for depend
	mechanism.

	* src/scm/report/hello-world.scm: add support for depend
	mechanism.

	* src/scm/report/folio.scm: add support for depend mechanism.

	* src/scm/report/balance-and-pnl.scm: add support for depend
	mechanism.

	* src/scm/report/average-balance.scm: add support for depend
	mechanism.

	* src/scm/report.scm (gnc:report-menu-setup): fixed minor
	non-r5rsism (defines must be at the beginning of a <body>).

	* src/scm/report/report-list.scm: new file.  This is where all of
	the reports that should be loaded at startup should be listed.

	* src/scm/main.scm (gnc:startup): don't autoscan/load from the
	report dir anymore.  Use the depend mechanism instead.  This isn't
	as convenient, but it's safer.

	* src/scm/hooks.scm (gnc:hook-run-danglers): added a little
	debugging code.

	* src/scm/extensions.scm (gnc:extensions-menu-setup): fixed minor
	non-r5rsism (nested defines must be at the beginning of a <body>).

	* make-gnucash-patch: allow the user to override the default
	locations with environment variables.

2000-03-04  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/guile/gnucash.c (main): load the locale from the environment
 	with setlocale. This is needed so that guile can find the locale.

	* Docs/: reorganized the Docs directory. Then english language
 	stuff moved to the "C" directory. The french stuff goes under
 	"fr". The "En" and "Fr" directories are gone. The standard for
 	country codes uses lower-cases letters, so we should stick to
 	that. The graphics files go under "pix" directories under their
 	respective language directories.

	* src/scm/path.scm: create documentation search paths based on the
 	current locale. The default "C" locale is always searched last.

	* src/reports/File.c (gncFindFile): take out dead code.

2000-03-04  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-style.c (set_dimensions_pass_one):
 	Only set the dimensions based on percentages if the dimensions
 	have not been set before.  This gets rid of some strange behavior
 	where styles change width by a few pixels when window size was
 	changed.
	(gnucash_sheet_style_set_dimensions): Add a width argument; now we
 	compute dimensions to fit "width" as best as possible.  Most of
 	the time width should be the allocation width of the sheet, except
 	that when the style is first compiled, the allocation width may be
 	unavailable.
	(style_recompute_layout_dimensions): Set dimensions->width
 	properly.
	(gnucash_style_default_width): Nuke this function, since we can
 	now use dimensions->width.
	(gnucash_sheet_style_compile): Use a default width to set
 	dimensions.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_set_top_row):
 	Update the canvas before the scroll.  This helps eliminate some of
 	the flashing when the register scrolls.  Still not perfect,
 	though.

2000-03-03  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_size_allocate): Keep track of the allocation and
 	update everything only if the allocation changes.  This is needed
 	because gnome canvas widget items always do a gtk_widget_set_usize
 	(), which in turn forces a reconfigure of the parent widgets.  So
 	we were getting size_allocate events even when the size of the
 	window was not changing.
	(gnucash_sheet_set_top_row): Scroll the sheet by setting the
 	adjustment values rather than calling gnome_canvas_scroll_to ().

	* src/register/gnome/gnucash-header.c
 	(gnucash_header_reconfigure): Set the sheet width from the header.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_block_set_from_table): Check to see if the style
 	has changed before we reallocate all the entries and colors.
	(gnucash_sheet_block_set_entries): Don't strdup the entries from
 	the table.
	(gnucash_sheet_block_clear_entries): Don't free the text in the
 	entries, since now the table owns this.
	(gnucash_sheet_set_scroll_region): New function; sets the scroll
 	region on the register canvas.
	(gnucash_sheet_update_adjustments): This was being done
 	incorrectly.  The layout widget on which the gnome canvas is based
 	takes care of the adjustments, and we've just connected to these
 	adjustments in the smooth-scroll case.  Now that the scroll region
 	is set correctly, just let the layout manage the adjustments.
	

2000-03-03  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/pricecell.c (PriceMV): accept thousands separators.

	* src/scm/c-interface.scm: new functionality for registering
 	translatable strings and saving them to a file in a suitable
 	format for po creation. This touched a bunch of other .scm
	files as well.

2000-03-02  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-options.c: use gettext to translate the strings
	used to make the gui components.

	* src/gnome/window-reconcile.c
 	(gnc_reconcile_window_create_list_frame): always show vertical
 	scrollbars, the columns widths work out better that way.

	* src/gnome/reconcile-list.c
 	(gnc_reconcile_list_get_needed_height): better estimate of needed
 	height than just multiplying row height times rows.

	* src/register/gnome/gnucash-item-list.c (gnc_item_list_autosize):
 	new function to autosize the list. For some reason, have the list
 	autosize for each new insertion wasn't working for very large
 	registers.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_new): bump up
 	the scroll region for very large registers.

	* src/gnome/window-main.c (gnc_main_create_toolbar): removed the
 	C-a and C-d shortcuts for adding and deleting accounts.

	* src/gnome/reconcile-list.c (gnc_reconcile_list_init): print
 	selected 'y' reconcile flags in yellow for better contrast.
	(gnc_reconcile_list_unselect_row): don't unselect the row if we
 	are toggling the current row.

	* src/gnome/window-reconcile.c (recnRecalculateBalance): reverse the
	balance if appropriate.

2000-03-01  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-adjust.c (gnc_ui_AdjBWindow_ok_cb): reverse the
 	balance if appropriate.

	* src/scm/extensions.scm: add the extensions menu if  debugging.

	* src/scm/bootstrap.scm: new function to check debugging status.

	* src/FileDialog.c (gncFileQIFImport): set the busy cursor when
	reading and processing the qif.

	* src/SplitLedger.c: added a sign-reversal callback.

	* src/gnome/dialog-utils.c (gnc_ui_get_account_full_balance): used
 	the sign-reversal option in computation.

	* src/gnome/top-level.c: implement the sign-reversal configuration
	and callbacks.

	* src/gnome/window-main.c (gnc_ui_refresh_statusbar): used
 	sign-reversal option in computation.

	* src/scm/prefs.scm: add an option to choose how accounts
	are sign-reversed.

2000-02-29  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/cursors.c (gnc_ui_set_cursor): let the gtk main loop
 	catch up before we exit. This makes sure the cursor gets changed
	before we return.

	* src/gnome/dialog-filebox.c: hide the window before exiting
	the gtk main loop.

	* src/scm/prefs.scm: added a new option for expanding parent
	accounts with double-clicks instead of opening them.

	* src/gnome/window-main.c (gnc_account_tree_activate_cb): use
 	expansion option to decide whether to open or expand.

	* src/SplitLedger.c: check for common currency when saving a
 	register entry. If there is none, don't perform the split
 	insertion; instead show a warning dialog.

	* src/scm/prefs.scm: converted account type and account field
 	options to list options.

	* src/register/gnome/combocell-gnome.c (leaveCombo): if a new
 	value is returned, also set the same value as the cell value.

	* Makefile.in: added 'unfinished' to qt compile target info.

2000-02-28  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/options.scm: added a list option

	* src/scm/report/hello-world.scm: added a demo list option

	* src/gnome/dialog-options.c: added implementation of list options.

	* src/engine/QIFIO.c (xaccParseQIFDate): fix for 4-digit dates.
	(xaccParseQIFDate): fix for x/x' 00 dates, which are an old
	format for 2000 dates.

	* src/scm/report/average-balance.scm: fix report to work when
 	there are no accounts.

	* src/scm/report/transaction-report.scm: initialize the inflow and
 	outflow variables to zero each time the report is run.

2000-02-27  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/gnome/top-level.c (gnc_configure_register_borders): Add
 	options for setting cell borders.

	* src/scm/prefs.scm: ditto

	* src/register/gnome/gnucash-style.c
 	(gnucash_style_set_cell_borders):
	(gnucash_style_set_register_borders):
	(gnucash_style_set_borders):
	(gnucash_sheet_set_borders): Functions to interactively set cell
 	borders.

2000-02-26  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-style.c
 	(gnucash_sheet_style_compile): Support for turning horizontal and
 	vertical borders on and off.
	(gnucash_sheet_style_recompile): Ditto

	* src/register/gnome/gnucash-grid.c (draw_cell): ditto

	* src/register/gnome/gnucash-header.c
 	(gnucash_header_reconfigure): Fix a bug in how the scroll region
 	was set.  Remove some outdated code.

2000-02-27  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-transfer.c (gnc_xfer_dialog_create): use
 	gnc_localconv to get the currency symbol.

	* src/gnome/window-adjust.c (adjBWindow): put colons after label.
  	Use gnc_localeconv to get the currency symbol.

2000-02-26  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-adjust.c (gnc_adjust_update_cb): only update if
 	the new string is different from the old. ditto for the reconcile
	and transfer windows.

2000-02-25  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/pricecell.c (PriceHelp): print out full number for
 	help value.

	* src/register/table-allgui.c (makePassive): implement alternative
 	passive colors.

	* src/register/splitreg.h (struct _SplitRegisterColors): add color
 	for odd rows in single mode, and boolean argument determining
 	whether to alterative virtual or physical rows in double mode.

2000-02-25  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_check_grab):
 	see if we need to release the grab.

	* src/register/splitreg.c (xaccInitSplitRegister): configure the
	mxfer cell with an ignore string (SPLIT_STR) and a help string
	explaining multi-line transactions.

	* src/register/gnome/combocell-gnome.c: added help handler and
 	ignore string functions.

	* src/register/table-allgui.c (gnc_table_enter_update): don't set
 	changed flag if new string is identical.

2000-02-24  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/table-gnome.c (xaccRefreshTableGUI): redo the style
 	information so that new colors (and other info) get refreshed.

	* src/register/gnome/gnucash-header.c (gnucash_header_draw): use
 	header style color to draw header background.

	* src/gnome/option-util.c: new functions to support color options.

	* src/gnome/dialog-options.c: gui implementation of color options.

	* src/scm/report/hello-world.scm: used the new color option.

	* src/scm/options.scm: added a new color option.

2000-02-23  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/extensions.scm (gnc:new-menu-namer): new object that
 	automatically picks accelerator keys for a group of menu items.

2000-02-22  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_delete_cb):
 	don't bother with the callback if the ending position of the
 	deleted section is <= to the starting position. This can happen.

	* include/messages_i18n.h.in: added menu item strings with
	underscore accelerators. Changed several gnome files to use
	these strings.

2000-02-21  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-header.c
 	(gnucash_header_reconfigure): scroll region width should be the
 	style width, not the allocation width.

2000-02-20  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/guile/gfec.c (gfec_catcher): use a guile function for
 	printing the error instead of the C interfaces. This removes
	a dependency on guile 1.3.4.

	* src/scm/c-interface.scm: add function for return an error string.
	Used by the C-side error catcher in gfec.c.

2000-02-19  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/report/hello-world.scm: added a 'crash the report'
 	option for testing the reports code.

	* src/register/gnome/gnucash-header.c (gnucash_header_event):
 	modify per changes to pointer_on_resize_line. Allow the user to
 	resize by double-clicking anywhere in a column heading.
	(pointer_on_resize_line): set the column with a pointer argument.
  	return true if on a resize line, false otherwise.
	(gnucash_header_init): initialize normal_cursor to NULL, which
	selects the default gdk cursor.

2000-02-18  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-style.c (gnucash_style_layout_init):
 	Make only the description cell a FILL cell.

2000-02-18  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/util.c (gnc_localeconv): Diane Trout's patch to set
	the default values with a function.

	* src/register/datecell.c (DateMV): validate change values longer
 	than a single character. Also, update the date value after a
 	non-accelerator change.

	* src/register/pricecell.c (PriceMV): validate change values
 	longer than a single character.

	* src/engine/util.c (gnc_localeconv): add in default values for
	the sign and currency positions if their values are out of range.

	* src/gnome/window-reconcile.c (recnRecalculateBalance): colorize
	the negative values in the summary frame.

2000-02-17  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (gnc_register_create_menu_bar):
 	added an edit menu with cut/copy/paste.
	(gnc_register_create_menu_bar): use 'blank' instead of 'new' to
 	describe the command to jump to the blank split. Use a new tooltip
 	too. Ditto for the popup menu and the toolbar.

	* Makefile.in: reversed order of gnucash linking so gnucash.gnome
	gets linked last, so it overides the motif version. Also, install
	the gnucash.desktop entry so gnucash appears in the gnome panel.

	* src/register/splitreg.c: right-align the xfer cells

	* src/register/gnome/gnucash-item-edit.c: handle selections the
 	gtk way with the gtk_selection_ routines. Grabbed this stuff from
 	gtkeditable and gtkentry.

	* src/register/gnome/gnucash-sheet.c: use the new selection handling
	code in the item editor to do cutting and pasting.

2000-02-16  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-item-edit.c: added code to support
	real gtk selection handling. Adapted this from the gtk editable
	widget.

2000-02-15  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-transfer.c (gnc_xfer_dialog_create): allow the
 	user to resize the window

	* src/gnome/window-register.c: save and restore window size

	* src/gnome/window-main.c: save and restore window size

	* src/gnome/dialog-edit.c: save and restore window size

2000-02-14  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-add.c (accWindow): save and restore window size

	* many files: use the configured account separator

	* src/gnome/dialog-utils.c (gnc_get_account_separator): new function
	to get the account separator

	* src/scm/prefs.scm: new option for the account separator

2000-02-13  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c (configLayout): swap the xfer and desc
	cells. Add the debit and credit cells to the transaction cursor
	so we get totals.

	* src/register/quickfillcell.h: add a GUI-specific initializer.
	The motif version does nothing. The gnome version add a direct
	callback to handle auto-completion keystrokes.

	* src/register/table-allgui.c (gnc_table_direct_update): new
 	function for passing direct gui input to the table, and then the
 	cells.

	* src/register/basiccell.h: added a direct_update callback for
 	responding to raw gui input.

	* src/register/gnome/combocell-gnome.c (ComboDirect): add complete
 	to char and complete as far as possible functionality.

2000-02-12  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c: add new account menu item

	* src/engine/Transaction.c (xaccTransCommitEdit): always check the
	split ordering on a commit. Only checking the transaction date won't
	work, because other fields in the transaction and the split affect
	the order.

	* src/engine/Account.c (xaccCheckDateOrder): use
 	xaccSplitDateOrder, the same routine as xaccAccountInsertSplit to
 	do the ordering.

	* src/register/table-allgui.c (gnc_table_modify_update): new
 	function, a direct gui callback.

2000-02-11  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm
 	((gnc:tr-report-get-first-acc-name split-scm)): Fixed crash when
 	it's a lone split, and somebody's not using proper double-entry
 	accounting!

	* Doc: Extensive clean-up and documentation of new features,
 	including several new images.

2000-02-11  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c (xaccInitSplitRegister): change memo
 	cell to be a quickfill cell.

	* src/gnome/window-main.c (gnc_refresh_main_window): refresh all
	account trees.
	(gnc_ui_delete_account): remove account from all trees.

	* src/gnome/account-tree.c: added a global list of account trees.
  	added functions for refreshing all trees and deleting an account
 	from all trees.

	* src/register/basiccell.h: (and lots more files) added a cell
 	callback for getting the 'help' string of a cell. This uses a
	default which uses the value of the cell, if its not blank, and
	a "blank help" otherwise. The blank help string can be set on a
	per-cell basis.

	The date cell replaces the help callback with one that prints the
	date out in full, according to the current locale.

	The split register initialization sets a few of the cells with
	blank help values.

	Finally, the gnome register uses the help strings to set the
	status of the statusbar.

2000-02-10  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/util.c (loglevel): print warnings and errors in
	all modules.

	* src/gnome/window-main.c: change the sensitivity of menu and
 	toolbar items that need a selected account.

	* src/gnome/dialog-edit.c (editAccWindow): allow dialog to be
 	resized

	* src/scm/extensions.scm: add code for a more flexible menu
 	definition process under guile. Comment out extensions menu
	stuff -- it's not complete.

	* src/register/gnome/gnucash-sheet.c (gnucash_button_press_event):
 	after moving, get the cursor position again before setting the
 	item editor cursor position because the cursor position may have
 	changed due to auto-mode rearrangement.

	* src/scm/prefs.scm:comment out locale-based date parsing

	* src/gnome/window-main.c (gnc_main_create_menus): modify the
 	names and order of the items per gnome standards.

	* src/scm/options.scm: Only save options that have been changed
	from their default values.

	* include/messages_i18n.h.in: removed periods from end of tooltips
	(gnome standard).

2000-02-09  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-reconcile.c (recnFinishCB): rewrote to be more
 	like the other top-level windows.

	* src/gnome/dialog-transfer.c (gnc_xfer_dialog): have the amount
 	entry grab focus.

2000-02-08  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/options.scm: add a number-range option

	* src/scm/prefs.scm: add an option of number of register rows.

	* src/gnome/option-util.c: add utility functions for number
	range options.

	* src/gnome/dialog-options.c: implement number range options

	* src/scm/prefs.scm: added a register 'show all transactions'
 	option.

	* src/gnome/window-register.c (gnc_register_date_window): lookup
	guile 'show all' option to determine how to set the date range.

	* src/register/splitreg.c (xaccInitSplitRegister): Set the minimum
 	trailing zeros for share quantities to 0. All price cells are now
 	monetary values.

	* src/register/pricecell.c: modify to use integer arg for trailing
 	zeros. Add function for changing blank_zero option.

	* src/engine/util.c (PrintAmt): change the trailing zeros argument
	to an integer indicating the minimum number of trailing zeros to
	print.

	* src/register/gnome/gnucash-item-list.c: handle mouse wheel
 	scrolling from the clist.

2000-02-07  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-main.c (gnc_ui_refresh_statusbar): set the
 	color of deficit values to red in the main window status bar.

	* src/gnome/account-tree.c (gnc_account_tree_insert_row): only set
 	values as red if they are less than but not extremely close to
 	zero.

	* src/gnome/window-main.c (mainWindow): separate profit and asset
	labels in the status bar.

2000-02-07  Robert Graham Merkel  <rgmerk@mira.net>

	* src/gnome/global-options.c (gnc_options_dialog_help_cb): pops
	up a help window.

	* src/gnome/dialog-edit.c (gnc_ui_EditAccWindow_help_cb): callback
	now displays help page instead of placeholder dialog.

	* Docs/En/xacc-accountedit.html: New file explaining account edit
	dialog.

	* Docs/En/xacc-globalprefs.html: New file explaining preferences.

	* Docs/En/xacc-main.html: Added pointers to new help pages for
	account-edit and preferences dialog boxes.

	* src/top-level.h: Added new HH_* macros for new help pages for
	dialog boxes

2000-02-06  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c (xaccSRSaveRegEntry): don't refresh if the
	transfer account hasn't really changed.

	* src/gnome/window-adjust.c (gnc_ui_AdjBWindow_ok_cb): parse
 	amount with xaccParseAmount.  When the amount entry goes out of
 	focus, reformat the value with separators.

	* src/gnome/dialog-transfer.c: parse amount with xaccParseAmount.
	When the amount entry goes out of focus, reformat the value with
	separators.

	* src/gnome/reconcile-list.c (gnc_reconcile_list_fill): print the
 	amount with xaccPrintAmount, with separators.

	* src/gnome/window-reconcile.c (startRecnWindow): print the amount
 	with separators and parse it with xaccParseAmount. When the amount
 	entry goes out of focus, parse it and reformat it.

	* src/register/splitreg.c (xaccInitSplitRegister): set the stock
 	register cell options appropriately.

	* src/register/pricecell.c: add functions for setting the precision
	and trailing zeros option. removed the 'shares' option.

	* src/engine/util.c (xaccSPrintAmountGeneral): add a generalized
 	amount printing function.

	* src/gnome/window-register.c (gnc_register_date_window): add a
 	button to the date range window for setting the date range when
 	the user changes a date without 'enter' or 'double-click'.

	* src/engine/Account.c (xaccAccountGetFullName): moved this function
	from gnome to here to make it gui independent. Returns a malloc'd
	string with the fully-qualified name of the account using the given
	separator char.

2000-02-06  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-header.c
 	(gnucash_header_auto_resize_column): Support for auto sizing.
	(gnucash_header_event): Double clicks on the resize lines will
 	auto resize the column to fit the text.

	* src/register/gnome/gnucash-sheet.c (compute_optimal_width): Use
 	the style layout to compute a good width for the sheet.

	* src/register/gnome/gnucash-header.c (gnucash_header_draw): Draw
 	the big rectangle correctly.
	(gnucash_header_reconfigure): Set the scroll region and header
 	width based on the size of the sheet, not the current style.

2000-02-05  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c (xaccInitSplitRegister): flag the share
 	quantities as such.
	(xaccInitSplitRegister): initialize the physical column to 0.

	* src/register/pricecell.c: get rid of the format string, add an
 	option for printing share quantities.

	* src/engine/Session.c (MakeHomeDir): just because ~/.gnucash
 	exists doens't mean ~/.gnucash/data exists.

	* src/scm/report/hello-world.scm: renamed from dummy.scm. Added
	documentation to the source code and additional help text in the
	report. This is intended to be an example for how to write reports.

	* src/gnome/window-report.c (reportAnchorCB): use gnome_url_show
	to display the anchors.

	* src/gnome/window-help.c (helpAnchorCB): use gnome_url_show to
	display the other anchor types.

	* src/gnome/dialog-utils.c: removed tooltip setting function. I was
	using tooltips the wrong way. Instead of having one tooltips object
	for each tip, you use one tooltips object for each logical group of
	tips, i.e., all the tips on a dialog. Also, changed the dialogs to
	use this method.

	* src/gnome/dialog-transfer.c: use labels with colons.

2000-02-04  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/extensions.scm: removed cruft functions

	* src/register/gnome/gnucash-item-list.c (gnc_item_list_select):
 	set the focus row to the selected row.

	* src/register/gnome/combocell-gnome.c (ComboMV): auto-pop the
 	list on input, according to the option value below.

	* src/scm/prefs.scm: added option to auto-raise register list on
 	input.

2000-02-03  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/combocell-gnome.c (enterCombo): sort the list
 	before popping up.

	* src/engine/Query.c: do num sorting using numerical values where
 	possible.

	* src/register/gnome/gnucash-item-edit.c: added new functions for
	cutting, copying, and pasting the clipboard. We have to do this
	manually instead of relying in the gtk_entry, as it screws up the
	selection handling.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_insert_cb):
 	fixed bug where new text was being copied incorrectly for
 	insertions longer than a character.

2000-02-02  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c (compute_optimal_width):
 	return optimal width if possible

	* src/register/gnome/gnucash-style.c
 	(gnucash_style_default_width): new function, compute optimal sheet
 	width

	* src/gnome/option-util.c: interfaced with the guile option callback
	mechanism.

	* Changed all existing callbacks to use guile callbacks. Touched
	many files.

	* src/scm/options.scm: added an option change callback mechanism.

2000-02-01  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/options.scm: new file. Moved the general options code
	here. Modularized the options code.

2000-01-31  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c: use the last date entered in the blank split
	for the date of the new blank split.

	* src/scm/prefs.scm: use hash for storing options

2000-01-30  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/bootstrap.scm.in: deleted hash-for-each. This is defined
	in slib2c6, which we are requiring anyway. Not the thunk for this
	should accept two args: the key and the value.

	* src/register/QuickFill.c: add sorting option to choose between
	LIFO and alphabetic orders.

2000-01-29  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/bootstrap.scm.in: Used Matt Martin's guile error catching
	code to print errors from gnc:load.

2000-01-28  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-header.c (pointer_on_resize_line): Fix a
	problem with the limits.  Now the last column is resizable.
	(gnucash_header_event): Check for which button is pressed/released.

2000-01-27  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c (xaccInitSplitRegister): set format of
 	price cell in stock registers to 4 decimal places.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_scroll_event):
 	new function. Do mouse wheel scrolling in gnome register.

	* src/register/gnome/gnucash-style.c (gnucash_style_layout_init):
 	use printDate to find a date width using the current date style.
	(gnucash_style_layout_init): use i18n'd string to set transfer
	from field width.

	* Removed uses of nana and dependencies on nana.

	* src/scm/report/transaction-report.scm: change to handle new
 	reports.

	* src/scm/report/dummy.scm: change to handle new reports.

	* src/scm/report.scm: Change reports so that they have a function
 	which generates a new set of options. Change the report running
 	functions to accomodate this.

	* src/FileDialog.c: avoid showing multiple error dialogs.

	* src/guile/gfec.c (gfec_catcher): new file with functions for
 	running scheme code with error handlers. Grabbed this off the
 	guile faq and made a few mods.

	* src/gnome/window-report.c: modify to use the new gfec routines.

2000-01-27  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm
	(tr-report-primary-key-op),(tr-report-primary-order-op)
	(tr-report-secondary-key-op),(tr-report-secondary-order-op):
	new options controlling sorting order for transaction report
	display.
	(gnc:tr-report-get-first-acc-name): get the name of the first
	"other" account" of a split's transaction
	(gnc:sort-predicate-component): return a predicate for comparing
	two split-scm's on a certain component
	(gnc:tr-report-make-sort-predicate): process sorting options,
	return a corresponding sorting predicate
	"Account Transactions" report: added sorting.

2000-01-25  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (regRefresh): refresh the window name

	* src/gnome/dialog-edit.c: Rob Merkel's patch to reparent accounts.

	* src/engine/Account.c (xaccAccountHasAncestor): new function to
	determine whether an account has another as an ancestor.

	* src/gnome/account-tree.c (gnc_account_tree_set_filter): add a
 	filter function to an account tree to select a subset of accounts.

	* src/engine/Query.c: some new functions for setting the date
 	ranges.

	* src/gnome/window-register.c: add 'show earliest' and 'show
 	latest' options to the date range window.

2000-01-25  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-grid.c (gnucash_grid_init):
 	Initialize the fonts here.

	* src/register/gnome/gnucash-style.c
 	(gnucash_sheet_style_compile): Use sheet->grid->normal_font for
 	all the computations.  style->fonts[][] is now only used for
 	drawing in gnucash-grid, etc. when it's non-NULL.

2000-01-24  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c (xaccInitSplitRegister): make the action
	cell accept strings not in the list.

	* src/register/gnome/combocell-gnome.c (xaccComboCellSetStrict):
	new function that determines whether the combo accepts strings
	not in the list. Defaults to 'does not accept'.


2000-01-23  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-style.c: Many functions touched.
  	Fairly extensive changes to how the layouts and dimensions are
 	handled.  We now lump together cursors which should have same
 	dimensions (e.g. all the single line cursors have the same layout
 	and dimension data).

2000-01-21  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_key_press_event): oh, what a hack! The extra stuff
 	is to make sure the selection is changed appropriately according
 	to the key that is pressed. Some of the logic is extracted from
 	gtkentry.c so the behavior is similar. We have to do this because
 	the entry widget is not realized and thus does not change its
 	selection as usual. However, we can't realize it, see the
 	explanation below.

	* src/register/gnome/combocell-gnome.c: added quickfilling

	* src/register/quickfillcell.c (quick_modify): new code for gnome,
	old code for motif. motif doesn't support the cursor position and
	selection args.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_new): ok,
 	*don't* put the entry in a widget. We can't have it realized
 	because it screws up the selection changes during the insert/
 	delete callbacks. We're going to have to fake the other
 	functionality.

	* src/register/QuickFill.c: make quickfill work on non-alphabet
	characters.
	(xaccGetQuickFillStr): new function search for a prefix match on
	more than one character at a time.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_button_release_event): new function to track button
 	release for dragging purposes.
	(gnucash_motion_event): new function for tracking mouse movement
 	and updating the selection region.
	(gnucash_sheet_init): initialize top_block_offset
	(gnucash_sheet_set_top_row): adjust the new top row to show as many
	rows as possible.
	(gnucash_sheet_vadjustment_value_changed): compute visible range
	after adjusting top block in smooth scrolling.
	(gnucash_sheet_compute_visible_range): start at the top_block_offset
	(gnucash_sheet_update_adjustments): scroll faster

2000-01-20  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c (gnucash_button_press_event):
 	if we're mousing in the current cell, don't bother going through
 	modify_update and all that jazz, but only if we are currently
 	editing. This makes sure the reconcile cell still gets its enters.

	* src/register/gnome/gnucash-item-edit.c
 	(item_edit_set_cursor_pos): add option to extend selection.

2000-01-20  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm: Fixed date bug, ensuring
	"to" date is treated as a <= rather than a <.

2000-01-20  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_new): put the
	editing entry into a canvas item so it will get realized. It needs
	to be realized for full functionality.
	(gnucash_sheet_modify_current_cell): add new args to modify update.
	(gnucash_sheet_insert_cb): new args for modify update
	(gnucash_sheet_delete_cb): new args for modify update

	* src/register/gnome/gnucash-item-edit.c (item_edit_destroy): only
 	disconnect if the editor hasn't been destroyed.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_activate_cursor_cell): added new args for enter
 	update. change entry widget appropriately.

	* src/register/table-allgui.c (gnc_table_enter_update): added args
 	to set cursor position and highlited selection.

	* src/scm/prefs.scm (gnc:save-options): truncate the options file
 	when opening.

	* src/register/gnome/gnucash-item-edit.c (item_edit_draw_info):
 	calc regions for the highlited portion of the text.
	(item_edit_draw): draw the hightlited portion of the text.

2000-01-19  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/guile/gnucash.c (gnucash_lowlev_app_init): use DEBUG and PERR
	instead of print(stderr, ...);

	* src/scm/prefs.scm: new technique for saving options. Easier
	to generalize to other option databases.

	* src/gnome/window-html.c (gnc_html_load): set button states at
	the beginning, in case report doesn't work.

	* src/scm/report.scm: catch exceptions in executing the report

	* src/gnome/window-report.c (reportJumpCB): report errors that occur
	in executing the report.

	* src/register/table-allgui.c (gnc_table_traverse_update): use the
	return value consistently to indicate no move.

	* src/scm/path.scm (gnc:make-home-dir): new function. creates gnc dir

	* src/scm/main.scm: don't abort if user config file fails

	* src/scm/prefs.scm: make options save to ~/.gnucash/config.auto

	* src/gnome/dialog-options.c (gnc_option_create_account_widget):
 	if not multiple selection, use browse mode so user has to select
 	an account.
	(gnc_option_set_ui_widget): when making account list widget, connect
	the signals after the value has been set so the dialog isn't already
	in a changed state.

2000-01-17  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/bootstrap.scm.in: add a test for slib >= 2c6.

2000-01-16  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-add.c (gnc_ui_accWindow_list_box_create): Put
 	the account types in a scrolled window.
	(gnc_ui_accWindow_tree_select): scroll the list types when a new
 	type is selected.
	(accWindow): remember window size and recreate it.

	* src/engine/util.c (xaccParseQIFAmount): rename this from
	xaccParseUSAmount to explictly reflect its only usage. Modify
	the parsing to guess what symbol is used as a decimal point.

2000-01-15  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-report.c (gnc_report_export): add error checking
	and i18n messages.

	* src/gnome/window-html.c (gnc_html_load): set toolbar button
	states at end.

2000-01-15  Robert Graham Merkel  <rgmerk@mira.net>

	* src/gnome/window-report.c (gnc_report_export): new function to
 	allow generated HTML reports to be exported to a file.
	(reportWindow): added a button to the toolbar for exporting HTML

2000-01-15  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* Makefile.config.finish: Get rid of xemacs mode comments.

	* configure.in: Move the commands at the end of configure.in into
 	the EXTRA-CMDS section of AC_OUTPUT so that config.status will
 	redo them. Don't bother defining GNC_RUNTIME_* vars as they are
	not substituted using AC_OUTPUT.

2000-01-15  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-style.c (struct   _CellLayoutInfo):
	Add new flags for attributes the user can change interactively.


	* src/register/gnome/gnucash-style.c (compute_cell_origins_[xy]):
	Precompute these since they stay fixed until dimensions change.

	* src/register/gnome/gnucash-header.c (gnucash_header_draw):
	Be sure rect.width is non-negative.  Also, we draw all the
	rows in the header now.
	(gnucash_header_set_arg): Remove the ARG_ROW argument.
	For ARG_CURSOR_TYPE, only reconfigure the header
	when the type changes.  This optimizes the drawing a bit.
	(gnucash_header_reconfigure): We're drawing all rows now, so
	use the proper height.  
	(gnucash_header_event): Implement resizing of columns.  This is
	a bit rough in places, because we have to take cell alignments
	into account.  Need to work more on the styles.
	(gnucash_header_draw): Support dynamic resizing in the header,
	to give the user feedback during the resize.

	* src/register/gnome/gnucash-grid.c (gnucash_grid_draw): Optimize
	so it draws only the needed cells, not the entire row.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_init): Add a
 	compile time option for smooth vertical scrolling.  Later we can
 	add user selectable scrolling if we decide it's worth it.
	(gnucash_sheet_make_cell_visible): support smooth scrolling.
	(gnucash_sheet_update_adjustments): ditto
	(gnucash_sheet_vadjustment_value_changed): ditto
	(gnucash_sheet_create): ditto
	(gnucash_sheet_y_pixel_to_block): New function.  Convert a canvas
 	y-coordinate to a virtual row.

2000-01-14  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm: Added initial balance
	and summary displays.

2000-01-12  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm: Added balance field,
	running totals, patched for empty-second-split case, fixed
	other bugs, added documentation.

2000-01-10  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* Apply Jan Schrage's doc patch.

	* src/gnome/window-reconcile.c (recnWindow): tighter arrangement
	of the buttons.

	* src/g-wrap/gnc.gwp: removed wrap of private engine function.

	* src/engine/util.c (gnc_localeconv): new function to get a lconv
	structure for locale info.
	(PrintAmt): add argument which determines whether amounts are
	monetary or not. Use locale information to get separators.
	(xaccSPrintAmount): first cut at printing i18n'd amounts.
	(xaccParseAmount): new function for parsing i18n'd amounts,
	both monetary and non-monetary.

	* src/register/splitreg.c (xaccInitSplitRegister): let the price
 	cell format be the default monetary format. Set the shares cell
 	and, for stock registers, the credit and debit cells to
 	non-monetary cells.

	* src/register/pricecell.c (xaccSetPriceCellMonetary): new
 	function for setting 'monetary' member.

	* src/register/pricecell.h: add a 'monetary' boolean member
	of price cells which indicate whether the value should be
	parsed as money or not.

2000-01-09  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.c: print price cells in a monetary format,
 	not 4 place decimal notation.

	* src/gnome/window-register.c (regRefresh): print separators in
 	the amounts at the bottom of the register window.

	* Applied Ken Yamaguchi's QIF import patch.

	* src/scm/prefs.scm: modified the account list option so
	that it returns the default-getter value until explicitly
	set.

2000-01-09  Robert Graham Merkel  <rgmerk@mira.net>

	* src/scm/report/transaction-report.scm: Added a pile of stuff,
	should now produce a HTML formatted report containing basic info.
	Unfortunately, crashes gtk-xmhtml at this stage.

2000-01-08  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/bootstrap.scm.in: Added a check for slib.

2000-01-07  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* make-gnucash-patch: changed aclocal.m4 to lib/g-wrap/aclocal.m4
 	in the exclude list, so people can patch the main aclocal.m4 file.

2000-01-07  Jan Schrage <jan.schrage@urz.uni-heidelberg.de>

	* configure.in: for --opt-style-install add $prefix/include
	and $prefix/lib to $CPPFLAGS and $CFLAGS respectively to fix
	broken check for nana.

2000-01-06  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* various and sundry: apply Laurent P{'e}lecq's i18n with gettext
 	patch. Move raw strings from gnome code into message database.

	* src/gnome/window-report.c: modify for changes to window-html.
	Make sure properties dialog callback only changes the window if
	we are on that page.

	* src/gnome/window-help.c: modify for the changes to window-html

	* src/gnome/window-html.c: enhance window. Titles and buttons
	are now associated with each history item, not the whole window.

	* src/gnome/dialog-options.c: added support for account list
	guile options.

2000-01-05  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/option-util.c: new functions for sending and receiving
 	lists of accounts to guile.

	* src/gnome/account-tree.c: modified this widget so that
	it keeps track of a list of selected accounts. Normal mode
	is still single selection.

2000-01-04  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-add.c (gnc_ui_accWindow_list_select_cb):
 	prevent user from selecting illegal account types.

2000-01-02  Peter Pointner  <peter@wuzel.m.isar.de>

	* configure.in: disable qt build by default. --enable-qt enables it.

	* Makefile.in: new targets qt.static and qt.disable

	* make-gnucash-patch: exclude *.moc

	* src/g-wrap/gnc.gwp (current-gnc-compile-flavor): add flavor qt.static

	* src/qt/* and src/register/*-qt.*: assorted changes to make the
	  qt version compile. 

2000-01-02  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c: redid this window. Put style, sort
 	order, and date range into menu bar. Put toolbar under menu.
	Added status bar at bottom.

	* src/register/table-allgui.c (xaccVerifyCursorPosition): return
 	boolean indicating whether cursor was repositioned.
	(wrapVerifyCursorPosition): use return value from above in
 	deciding whether to refresh UI.

	* src/SplitLedger.c (xaccSRCancelCursorSplitChanges): move off of
 	an EXACT_ONLY cell, if on one.

2000-01-01  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/splitreg.h: uses ints, not shorts for values.

	* src/SplitLedger.c (xaccSRLoadRegister): use the function below
 	to find the cell where to land on.
	(xaccSRLoadRegister): fix a bug with auto mode to single/double
 	mode transition.

	* src/register/table-allgui.c (gnc_table_find_valid_cell_horiz):
	new function. Find a valid cell in the row, starting at the
	given coordinates and fanning out.

	* src/register/basiccell.h: add a new kind of io_flag.
	XACC_CELL_ALLOW_EXACT_ONLY means a cell can only be entered
	when the user specifically indicates that cell. Right now,
	this means only a mouse pointer clicked on that cell. This
	is used to prevent the reconcile cell from acting strangely.

	* src/register/table-allgui.c (gnc_table_traverse_update): do left
 	traversals a little better.

	* src/gnome/window-html.c (htmlKeyCB): handle keyboard horizontal
 	scrolling.

1999-12-31  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* Code cleanup with -Wall. Deleted unused variables. Added missing
 	#include's and missing function declarations.

	* src/engine/QIFIO.c (FavorDateType): Christopher Browne's QIF
 	import patch.

	* configure.in: Albert Chin-A-Young's patch to configure.in for
 	perl config.

	* src/MultiLedger.c: nix xaccRegisterCountHack.
	It is no longer needed.

	* Docs/En/xacc-about.html: added contributors.

	* make-gnucash-patch: new script. Make a patch for submission.

	* README: added contributors. Added sections on gnucash
	development and submitting patches.

1999-12-30  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c (xaccSRGetCurrentTrans): Fix error messages.

1999-12-29  Peter Pointner  <peter@wuzel.m.isar.de>

	* src/motif/FileBox.c (closeBoxCB): reset fileName only if !done.
	  This fixes the FileBox problems with lesstiff 0.89.1, at least
	  for me.

	* configure.in: change CPPFLAGS used to search for gtk-xmhtml  

1999-12-26  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-report.c (reportWindow): Add a properties
 	button to the html window icon bar to allow the report parameters
 	dialog to be brought up.
	(reportWindow): Add a title to the properties dialog.

	* src/gnome/window-html.c (htmlWindow): Add arguments to allow the
 	caller to add its own icons to the window.

1999-12-25  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/global-options.c (gnc_show_options_dialog): Added
 	title.

	* src/gnome/window-main.c: removed eperl reports menu items

	* src/gnome/window-report.c: new file. Report-specific gnome
	gui code will reside here.

1999-12-24  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-html.c: take out help and report specific code.

	* src/gnome/dialog-options.c: removed global options code.
	These routines now with with arbitrary options databases.

	* src/gnome/global-options.c: new function. global options are
 	implemented here. This uses dialog-options and option-util
 	functions.

	* src/gnome/option-util.c: removed global options code.

	* src/gnome/window-register.c (gnc_build_ledger_style_menu): set
 	the style menu to the default on creation.

1999-12-23  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/account-tree.c (gnc_account_tree_refresh): thaw after
 	all changes.

1999-12-22  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/option-util.c: many new functions. Rewrote this to
	add the concept of option databases, a data structure which holds
	a collection of options and allows access to them. This will be
	used to hold, e.g., options for a report window. The old functions
	now just call the new ones with the 'global' configuation option
	database as the database argument.

	* src/gnome/dialog-report.c: Rename dialog-trans-report.? to
	dialog-report.?. This will construct a generic report dialog.

1999-12-21  Robert Graham Merkel  <rgmerk@mira.net>

	* src/gnome/dialog-trans-report.c: New file.  GNOME code for
 	creating a dialog box for information on the transaction report.
  	At the moment only contains a stub for the actual dialog box code.

	* src/gnome/dialog-trans-report.h: New file.  Headers for 
	 the dialog box stuff, obviously!

	* src/gnome/Makefile.in: modified to compile dialog-trans-report.c

1999-12-21  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-reconcile.c: enhance this window with
	new, edit, and delete transaction buttons.

1999-12-20  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_size_allocate): Configure the item_editor on a
 	resize.

	* src/register/gnome/gnucash-cursor.c
 	(gnucash_cursor_get_pixel_coords): Don't use the horizontal scroll
 	offset.

	* src/register/gnome/gnucash-item-edit.c
 	(item_edit_get_pixel_coords): Ditto.

	* src/register/gnome/gnucash-item-list.c (gnc_item_list_new): Set
 	the "x" coordinate on creation.

1999-12-20  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (regWindowLedger): get the default
	register type guile option to set the register style.
	(regRefresh): set the toolbar button display based on the guile
	option value.

1999-12-19  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/MultiLedger.c (xaccRegisterRefreshAllGUI): new function.
	call gui refresh on all registers.

	* src/MultiLedger.h: remove unecessary externs.

1999-12-19  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_update_adjustments): Update the horizontal
 	adjustments, too.
	(gnucash_register_new): Attach the horizontal scrollbar to the
 	horizontal adjustment.

	* src/register/gnome/gnucash-header.c (gnucash_header_set_arg):
 	Hook up the hadjustment from the sheet so that they scroll
 	horizontally together.

1999-12-19  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/util.c: applied Grant Likely's patch to the number
	formatting routines.

	* src/register/splitreg.c: applied Grant Likely's patch to make
 	stock register have 4 decimal places of accuracy.

	* Applied Christopher Brown's html and QIFIO.c patch.

1999-12-19  Robert Graham Merkel  <rgmerk@mira.net>

	* src/src/report/transaction-report.scm: New file. Will contain
 	code for doing a transaction report on an account. At this stage
 	all it does is display unformatted raw scheme lists.
 	
	* README.guile-hackers: Added general information about Scheme and
 	a pointer to net resources about it. Also explained a little
 	about g-wrap and gave a pointer to the documentation for it.

1999-12-18  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-header.c
 	(gnucash_header_reconfigure): Don't set the width of the widget,
 	let it find it's own width.

	* src/register/gnome/gnucash-style.c
 	(gnucash_sheet_style_set_dimensions): Reworked extensively.  It
 	now tries very hard to fit the cursors in the register window.
  	Supports a number of layout options for the cursors, as detailed
 	in the source.

1999-12-18  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (gnc_register_create_tool_bar):
 	Don't cause a legister refresh.

1999-12-17  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-edit.c (gnc_ui_EditAccWindow_ok_cb): refresh
 	all the registers.

	* src/gnome/dialog-add.c (gnc_ui_accWindow_create_account):
 	refresh all the registers.

	* src/gnome/window-register.c (regRefresh): reload the transfer
 	cells.

	* src/SplitLedger.c (xaccSRLoadXferCells): new function. Load the
	transfer cells in a split register.

	* src/register/gnome/combocell-gnome.c (xaccClearComboCellMenu):
 	new function. clear all items in the combocell menu.

1999-12-16  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/table-allgui.c (gnc_table_traverse_update): Use the
	exit flags from the cellblock to decide how to set
	exit_register, and don't change entries in the traverse arrays
	to positive.

	* src/register/splitreg.c (configTraverse): Mark all the exit rows
	and columns, too.

	* src/register/cellblock.h: Add variables to the CellBlock struct
	that flag the exit cells.  We can't use negative entries in the
	traverse arrays anymore, since left traverses sometimes need
	valid negative directions.

1999-12-16  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/pricecell.c (xaccPriceCellPrintValue): new
 	function.  return a pointer to a static string buffer with the
	cell amount printed.
	(xaccSetPriceCellValue): simplify with above function.
	(PriceLeave): new leave callback for price cells. Pretty-prints
	cell value using xaccPriceCellPrintValue.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_cursor_move):
 	have this function take physical instead of virtual coordinates.
  	This function now 'does the move' using wrapVerifyCursorPosition.
	It has smarts that were in the three functions below.
	It returns TRUE if the current cell changed.
	(gnucash_button_press_event): simplify
	(gnucash_sheet_key_press_event): simplify
	(gnucash_sheet_goto_virt_row_col): simplify

1999-12-15  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/table-allgui.c (gnc_table_traverse_update): take
 	out the reverify fields. These are unnecessary for the auto modes
 	(at least for gnome) and complicate the leave semantics.

	* src/SplitLedger.c (xaccSRGetCurrentTrans): use the register
 	physical row and not the table. needed for auto mode movement.

	* src/register/table-allgui.c (gnc_table_leave_update): do the
 	wrapverify after we check for changes. I'm not sure if wrapverify
 	could change the outcome of this, but doing the check after the
 	wrap verify makes no sense since the row and col values aren't
 	meaningful anymore.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_deactivate_cursor_cell): always call the leave
 	update, even for "bad" locations. We need the wrap verify that
 	happens in the gnc_table_leave_update.

1999-12-15  Robert Graham Merkel  <rgmerk@mira.net>

	* src/gnome/dialog-add.c (xaccSetDefaultNewaccountCurrency): Added
 	an interface to set the default currency for new accounts.

	* src/scm/prefs.scm (gnc:make-string-option) added a new option
 	generator for strings, used this to add a "default new account
 	currency" option

	* src/gnome/top-level.c (gnc_configure_newacc_currency_cb)
 	callback to update the default currency when options are changed
	(default_configure_newacc_currency) does the work of updating
	(gnucash_ui_init) registered the new callback

1999-12-14  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/table-allgui.c (gnc_table_traverse_update): a fix
 	for the auto modes.

	* src/SplitLedger.c (xaccSRCountRows): Look for the cursor
 	position using the transaction, as well as the split. Useful when
 	changing modes when you are on a blank split in multi-line.
	(xaccSRGetCurrentTrans): new function. Gets current transaction.
  	Works when you are on blank splits as well.
	(LedgerTraverse): save the old register values and then restore
 	them.

1999-12-13  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-header.c
 	(gnucash_header_reconfigure): check for a valid header row before
 	proceeding.

1999-12-13  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-cursor.c (gnucash_cursor_set): Set
 	the type and row arguments in the header.

	* src/register/gnome/gnucash-header.c (gnucash_header_draw): Tweak
 	the coords on the separator line a bit.  Draw the header based on
 	header->type and header->row.
	(gnucash_header_set_arg): Add two new arguments to support setting
 	the type of the header from the current cursor and the row within
 	the cursor to draw.

	* src/register/gnome/gnucash-style.c
 	(gnucash_sheet_style_compile): Set the header font.

1999-12-13  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/option-util.c (gnc_lookup_multichoice_option): Rob
 	Merkel's patch.

	* src/engine/date.c (printDate): Rob Merkel's patch to i18n date
 	formats.

	* src/gnome/top-level.c (gnc_configure_date_format): Rob Merkel's
	patch to i18n date formats.

1999-12-12  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/table-allgui.c (gnc_table_traverse_update): Put an
 	assert(0) in the default case, since now we handle all possible
 	cases.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_key_press_event): Remove hack to wrap around when
 	moving the cursor.  splitreg.c takes care of this, after a
 	fashion.

1999-12-12  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/combocell-gnome.c (disconnect_list_signals):
 	if the list has been destroyed, don't bother.
	(connect_list_signals): ditto.

1999-12-10  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/splitreg.c (configTraverse): Configure left
 	traverses, too.

	* src/register/cellblock.[c,h] (xaccInitCellBlock): Allocate left
 	traverse matrices.
 	(FreeCellBlockMem): Free left traverse matrices.
 	(xaccNextLeft): New function.

	* src/register/table-allgui.c (gnc_table_traverse_update): Add
 	support for left traverses.

1999-12-10  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (jump_cb): new callback. Used to
 	jump to 'other' account.

	* src/gnome/option-util.c: modify multichoice
 	functions. multichoice options are now a list of vectors,
	where each vector contains the value, name, and description.

	* src/gnome/dialog-options.c (gnc_option_set_ui_widget): Rob
 	Merkel's patch to add the option name to a multichoice option.

1999-12-09  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-utils.c (gnc_build_option_menu): change this
 	function so that the callback includes the index of the selection
 	as well as the user_data.

	* src/gnome/option-util.c
 	(gnc_option_value_num_permissible_values): new function. return #
 	of permissible values.
	(gnc_option_value_permissible_value_index): new function. search
 	for SCM value in permissible value list.
	(gnc_option_value_permissible_value_name): new function. return
 	name of indexth permissible value.
	(gnc_option_value_permissible_value_help): new function. return
 	help of indexth permissible value.

	* src/gnome/dialog-options.c (gnc_option_set_ui_value): add
 	multichoice option.
	(gnc_option_get_ui_value): add multichoice option.
	(gnc_option_multichoice_cb): new function. callback for
 	multichoice buttons. We use an object data with key
 	"gnc_multichoice_index" to store the index with the option menu.
	(gnc_option_create_multichoice_widget): new function. create the
 	widget for multichoice options.
	(gnc_option_set_ui_widget): add multichoice option.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_block_destroy): Don't free the entries and colors,
 	that is done by gnucash_sheet_block_clear_entries now.
	(gnucash_sheet_block_clear_entries): Set the freed pointers to
 	NULL for safety.

1999-12-09  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-color.c (color_hash): The argument is
 	an argb, not a GdkColor. So we'll just use its value directly.
  	This fixes a bug in that we were getting lots of failed color
 	lookups in the hash table, and therefore lots of redundant
 	insertions.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_sheet_block_clear_entries): Free entries, fg_colors,
 	bg_colors here. We were leaking [fg,bg]_colors.


1999-12-09  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (regWindowLedger): set the window
	policy to allow shrinking and growing.

	* src/SplitLedger.c (xaccSRSaveRegEntry): change the memo
	before you create the 'other' split, so it gets the same memo.
	Also, if we are committing the blank split, insert it into the
	account before we create the 'other' split, so the other split
	can get a parent account, too.

1999-12-08  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/main.scm (gnc:ui-finish): destroy the ui subwindows
	before doing a file-query-save. The register windows need to
	be closed before saving, in case there are edited transactions.

	* src/gnome/top-level.c (gnc_ui_destroy_all_subwindows): new
 	function.  used by guile to destroy all non-main windows.

	* src/gnome/window-help.c (gnc_ui_destroy_html_windows): new
 	function.  destroy any help or report windows open.

1999-12-08  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-cursor.c (gnucash_item_cursor_draw):
 	Draw an inner rectangle in the cell cursor.  This balances the
 	cursor top/bottom versus sides, and fixes some ugliness especially
 	in double line mode.

1999-12-08  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c (xaccSRLoadRegister): restore original
 	position a bit more accurately.

1999-12-07  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/scm/text-export.scm (gnc:account-transactions-export-as-text):
	return #f as value so the traversal keeps going. (See Group.h).

	* src/g-wrap/gnc-helpers.c: use gh_long2scm instead of the
	long long version. This is incorrect for very large values,
	but longlong doesn't seem to be working right now.

	* src/engine/LedgerUtils.c (accListHasAccount): new function.
	search for account in list.

	* src/MultiLedger.c: Only add the leader if it wasn't in the list.

	* src/gnome/window-register.c (gnc_register_create_menu_bar):
	Added an option to scrub the account. Changed Register menu
	to Account menu.

	* src/engine/Transaction.c (MARK_SPLIT): mark the account group
	as not saved. Ensures we get a "do you want to save" dialog.

	* src/register/gnome/gnucash-sheet.c (compute_optimal_height):
	request height for DEFAULT_REGISTER_ROWS rows.

	* src/gnome/window-register.c (deleteCB): fancy deletes.

1999-12-06  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c (xaccSRSaveRegEntry): Insert the blank split
 	into the account when it is committed, not when it is created.
  	Otherwise, the blank split gets saved to a file if you save with
 	an open register. Also, it gets stuck in the reconcile window if
 	you open that with an open register.

	* src/register/pricecell.c (xaccSetDebCredCellValue): simplify
	and fix value setting bug.

	* src/SplitLedger.c (xaccSRCancelCursorTransChanges): new
 	function. Cancel the changes to the current transaction.

	* src/motif/RegWindow.c (cancelCB): use SR functions instead.

	* src/g-wrap/gnc.gwp: add wrapper for xaccGroupGetBalance

	* src/gnome/window-register.c (regWindowLedger): take out the size
 	code altogether.

1999-12-06  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c (DEFAULT_REGISTER_WIDTH):
 	Increase this a little, so at least a checking account register is
 	drawn correctly.  This is a hack for now anyway until the
 	computations in gnucash-style.c are reworked.

	* src/gnome/window-register.c (regWindowLedger): Comment out the
 	call to gtk_widget_set_usize (), so the register window finds it's
 	own natural size.

	* src/register/gnome/gnucash-header.c
 	(gnucash_header_reconfigure): Compute w, h correctly.

1999-12-05  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (closeCB): Query the user as to
 	whether or not to save a changed transaction.

	* src/MultiLedger.c (xaccLedgerDisplayClose): Only refresh
	if there were really changes.

	* src/SplitLedger.c (LedgerDestroy): Paranoia checks.

	* src/gnome/window-register.c (regWindowLedger): catch the register
	"activate_cursor" signal. Upon receipt, record the transaction and
	move to the next virtual row.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_register_goto_next_virt_row): new function. Cause the
	register cursor to advance to the next virtual row.

	* src/register/gnome/gnucash-sheet.h: Add a "activate_cursor"
 	callback to the register that is emitted when the user pressed
 	return.

1999-12-04  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-main.c (gnc_ui_mainWindow_scrub): new function.
  	Scrub the current account.
	(gnc_ui_mainWindow_toolbar_open_subs): new function.
	Open subaccounts.

	* src/gnome/window-register.c (gnc_register_raise): new function.
	Cause the given register window to be raised to the top.

	* src/gnome/scripts_menu.c (gnc_extensions_menu_add_item): We have
 	to register the scheme scripts to make sure they aren't
 	garbage-collected.
	(gnc_extensions_shutdown): New function. Call when shutting down
	to free memory structures and unregister scheme scripts.

	* src/gnome/window-register.c (gnc_register_create_popup_menu): new
	function. Create a popup menu for the register.
	(regWindowLedger): Add the popup menu to the register.

	* src/register/gnome/gnucash-sheet.c (gnucash_button_press_event):
	return FALSE for unused events so they are passed up the hierarchy.

	* src/gnome/window-adjust.c (adjBWindow): use fully qualified
	account name in window title.

	* src/gnome/window-register.c (regWindowLedger): use fully
 	qualified name in the title of the window.

	* src/gnome/dialog-utils.c (gnc_ui_get_account_full_name): new
 	function. Construct the fully-qualified account name using the
	given separator string.

	* src/engine/Account.c (xaccAccountGetParentAccount): new function.
	Return the parent account of an account.

	* src/engine/Group.c (xaccGroupGetParentAccount): new function.
	Return the parent account of a group.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_key_press_event):
	respond to keypad directional keys.

1999-12-03  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/SplitLedger.c (xaccSRLoadRegister): When we refresh, look
 	for the pending transaction. If we don't find it, clear the
 	pending transaction to prevent it being committed later.

	* src/g-wrap/gnc.gwp: added binding for reportWindowDirect

	* src/gnome/window-register.c (helpCB): help window should not
	be parented.

	* src/gnome/window-main.c (gnc_ui_help_cb): help window should
	not be parented.
	(gnc_ui_reports_cb): reports window should not be parented.

	* src/engine/Transaction.c (xaccTransBeginEdit): Check for an
 	already open transaction.
	(xaccTransIsOpen): new function. returns true if transaction
	is open for editing.

	* src/gnome/window-register.c (regWindowLedger): Use a gnome dock
 	to hold the window contents. This is more flexible.
	(gnc_register_create_tool_bar): use graphical buttons. Also, don't
 	create the handle box, the gnome dock item will handle that.
	(gnc_register_create_menu_bar): don't create the handle box.

	* src/reports/Sheet.c: Rob Merkel's patch for locating eperl

	* src/gnome/account-tree.c (gnc_account_tree_refresh): tighter
 	bounds on adjustment value. Prevents quirks when refreshing to
	a smaller number of accounts.

	* configure.in: Rob Merkel's eperl and gtkxmhtml build patches

	* Makefile.in: Rob Merkel's patch to enforce gtkxmhtml requirement

	* src/gnome/window-register.c (deleteCB): use
 	xaccSRDeleteCurrentSplit to delete the split.

1999-12-02  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/combocell-gnome.c (moveCombo): disconnect
	the list signals.

	* src/SplitLedger.c (LedgerMoveCursor): update cursor_phys_row and
 	cursor_virt_row in the SplitRegiter.
	(xaccSRDeleteCurrentSplit): new function. delete the current split
 	in the register.
	(xaccSRCountRows): don't move the saved physical and virtual rows
	if the current split was NULL.

	* Makefile.in: Added Tyson Dowd's rules to rerun autoconf
	and configure when needed.

1999-12-01  Rob Browning  <rlb@cs.utexas.edu>

	* src/scm/txn-create.scm: remove trailing garbage.

	* src/scm/srfi: new directory containing source for various Scheme
	Requests for Implementation.  We now have srfi-8 and srfi-1.
	These are very useful.  Docs are available at
	http://srfi.schemers.org/.

	* src/scm/report/folio.scm: new file implementing
	Reports/report-folio.phtml.  Not finished, but not loaded either.

	* src/scm/report/dummy.scm: new file to test the report system.
	Shows the current date.

	* src/scm/report/balance-and-pnl.scm: new file to generate balance
	sheet and profit and loss reports.  Implements
	Reports/report-baln.phtml and Reports/report-pnl.phtml.  The code
	in here could be better, but it's not awful.  It's mostly a
	straight eperl port.

	* src/scm/report.scm: new file implementing the initial
	scheme-based report system.

	* src/scm/main.scm: use the new depend mechanism and load the new
	srfis

	* src/scm/extensions.scm: reformat so all the code doesn't go off
	the right side of a normal screen (with tabs set to 8, etc).
	Linas might veto this, but I thought it was worthwhile.

	* src/scm/depend.scm: new file adding a support/depend mechanism.
	Modify other files to start using it.

1999-11-30  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-help.c: extensive rewrite. Revamped look to use
	dockable toolbar. Handle motion keys. Escape key closes window.
	Graphics are now loaded.

1999-11-28  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/table-allgui.c (doMoveCursor): don't scroll when we
	update the cursor after the the callback.

	* src/register/table-gnome.c (doRefreshCursorGUI): same as below

	* src/register/table-motif.c (doRefreshCursorGUI): same as below

	* src/register/table-allgui.c (xaccRefreshCursorGUI): add a
 	do_scroll argument to determine whether the gui should scroll to
 	make the cursor visible. This lets us cut down on flashing.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_table_load):
 	try to avoid scrolling
	(gnucash_sheet_cursor_set_from_table): remove redundant call to
 	update adjustments.

	* src/gnome/window-register.c (cancelCB): use
 	xaccSplitRegisterClearChangeFlag.
	(gnc_register_create_tool_bar): right-align the displayed balances

	* src/register/splitreg.c (xaccSplitRegisterClearChangeFlag): new
 	function. Clear the change flags of the register.

	* src/SplitLedger.c (xaccSRCancelCursorChanges): new
 	function. Cancel the changes made to the current cursor.

1999-11-27  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c (regWindowLedger): set default sort
	order to the standard order.
	(gnc_build_ledger_sort_order_menu): add the standard order to the
	list of options.
	(gnc_ledger_sort_cb): handle the standard order

	* src/engine/Query.c (xaccQuerySetSortOrder): added BY_STANDARD and
 	BY_NONE sort orders.

	* src/register/splitreg.c (configLayout): configure the single
 	cursor last so the header is the most reasonable. This is a
 	hack. Eventually, we should probably switch headers dyamically.

	* src/register/gnome/gnucash-sheet.c
 	(gnucash_register_goto_virt_row_col): replaces and generalizes
 	gnucash_sheet_go_to_last_row.

	* src/gnome/window-register.c (gnc_register_jump_to_blank): new
 	function to jump to the blank split.
	(new_trans_cb): use gnc_register_jump_to_blank
	(regWindowLedger): jump to the blank split with above function
 	before returning

	* src/SplitLedger.c (xaccSRGetSplitRowCol): new function
	(xaccSRGetBlankSplit): new function

	* src/register/splitreg.c (configLabels): apply Rob Walker's patch
	to fix the labels.

	* src/gnome/window-register.c (gnc_register_date_cb): set start
 	date to the first second of the day selected and the end date to
 	the last second of the day selected.

	* src/engine/Query.c (xaccQueryGetSplits): fixed a problem to
 	prevent returning one split too many. We need to check for the
	max date before we add the split.

1999-11-23  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_go_to_last_row): 
	jump to the last row in the sheet. This will be the blank split.

	* src/gnome/window-register.c (gnc_register_create_menu_bar): add
	a menu item for moving to the blank split
	(regWindowLedger): jump to the last row, i.e., the blank split,
	before you return.

	* src/register/gnome/gnucash-style.c (gnucash_style_layout_init):
 	make the reconcile cell visible in mult-line mode. It's not
 	active, but it looks better.

	* src/SplitLedger.c (LedgerMoveCursor): tell xaccSRSaveRegEntry
 	which transaction we are moving to.
	(xaccSRSaveRegEntry): add an argument to indicate which
 	transaction will be current after the save. This allows us to
 	commit right away if we are changing transactions and keeps the
 	register gui in sync with the engine.

	* src/register/table-allgui.c (doMoveCursor): refresh the gui
 	cursor after the second makePassive if we are moving the gui.
  	This fixes a refresh bug that happens if the splits get reordered.

	* configure.in and src/gnome/Makefile.in: Rob Merkel's patch
	to check for gtkxmhtml
	
	* src/scm: applied Rob Walker's patch to add a version argument
	
	* src/gnome/account-tree.c (gnc_account_tree_init): auto resize
	the first column

	* src/gnome/window-main.c (mainWindow): give focus to the
	account tree before we exit

1999-11-22  Rob Browning  <rlb@cs.utexas.edu>

	* src/register/table-motif.c (modifyCB): *trivial* modification to
	support modify_verify cursor_position arg.  I'm not in a position
	to easily deal with the XmBae callback complexity.  This should
	just leave the status-quo.

	* src/motif/RegWindow.c (dateChangeCB): ditto.

	* src/register/table-allgui.[hc]: quickfill fixes, support the new
	modify_verify cursor_position arg.

	* src/register/gnome/gnucash-sheet.c: quickfill fixes, use the new
	modify_verify cursor_position arg.

	* ChangeLog: merge all the src/register/gnome/ChangeLog entries
	into this file and delete that file to finish up what Dave started
	on 1999-11-20.  Aside from being cleaner, it also makes emacs (and
	I suspect other editors) automatically find the right file when
	you do a "C-x 4 a" (changelog-add-entry).

	* src/register/*cell.h: added position (int *) parameter to
	all cell MV calls.  This allows the callback to reposition the
	cursor within the text if needed.  This was required by the
	quickfill fix, but is probably useful elsewhere.

	* src/register/quickfillcell.c (quick_modify): fixed so that
	cursor tracks as you type along with some other important bugs
	(quickfill divergences now cause the remainder of the stale fill
	to be deleted, etc.)

1999-11-21  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/window-register.c: (recordCB): when when record
	a new or existing transaction, make sure it will be in the
	date range we are viewing.

	* src/register/table-allgui.c: (gnc_table_traverse_update): handle
 	pointer traversals a bit more intelligently.

	* src/register/gnome/gnucash-item-edit.c: (item_edit_set_cursor_pos)
	fix for when you enter a cell that's right-aligned.
	
1999-11-20  Dave Peticolas  <peticola@cs.ucdavis.edu>

        * src/register/gnome/ChangeLog: we're going to stop using this
	changlog file and put all changes in the top-level ChangLog file.

	* src/gnome/reconcile-list.[ch]: Use a hash table to remember
	reconcile flags after a refresh. Also remember scroll position.
	Change row styles so active row isn't highlited.

	* src/register/gnome/gnucash-sheet.c:
 	(gnucash_button_press_event): For now, we need to enter the cell,
 	even if we're already there. The reconcile cell, for instance,
 	depends on this behavior. But, if we're entering the cell where we
 	already are, we remember the cursor position and try to go back to
 	it. Also, when we're entering a new cell it's drawn as if we're at
 	cursor position 0, so tell item_edit_set_cursor.

	* src/register/gnome/gnucash-item-edit.c (item_edit_draw_info):
 	new function to calculate drawing parameters for the item
 	editor. This is used both in drawing and in calculating the place
 	to move the cursor to for mouse traversals.
	(item_edit_draw): use item_edit_draw_info
	(item_edit_set_cursor_pos): use item_edit_draw_info

1999-11-19  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* gnucash-cursor.c (gnucash_item_cursor_draw): Use light gray for
 	the cell cursor; experimental to see if we like it.
	(gnucash_item_cursor_draw): Draw the inside rectangle slightly
 	inside.
	(gnucash_cursor_request_redraw): Tighten up the bounds now that we
 	don't have the outside rectangle.

	* gnucash-sheet.c (gnucash_button_press_event): Only move the cursor
	if the button press moves us to a new cell.  Set the editing cursor.

	* gnucash-item-edit.c (item_edit_draw): Take justification into
 	account here.  Use CELL_HPADDING, CELL_VPADDING instead of magic
 	constants to set the clip rectangle and the offsets.
	(item_edit_set_cursor_pos): New function.
	(item_edit_update): Adjust the positioning of the list now that we
 	don't have the outer rectangle.

1999-11-19  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/account-tree.c: remember expansion state and
	scroll position after a refresh.

	* src/gnome/query-user.[ch]: add parented versions of the
	query dialogs.

	* src/gnome/: modify dialogs to use parented dialogs

	* src/register/gnome/gnucash-cursor.c: (gnucash_item_cursor_draw):
	Heath's mod which removes the outer rectangle.

	* src/register/gnome/gnucash-item-edit.c: (item_edit_update):
	Heath's mod to make the combo list draw correctly

1999-11-18  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/util.c: (PrtAmtComma): fixed
	rounding error when remainder is close to 1.

1999-11-17  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-header.[ch]: removed type
	variable. The header should always be type GNUCASH_CURSOR_HEADER

	* src/register/gnome/gnucash-style.c:
	(gnucash_sheet_style_compile): use the cell labels for the header
	style labels
	
	* src/register/gnome/gnucash-item-edit.[ch]: Added a toggle button
	for popping the combo list.

	* src/register/gnome/gnucash-style.c: (gnucash_style_layout_init)
	make the width of the 'num' column of the split cursor the same as
	the others.

1999-11-15  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-sheet.c: (gnucash_sheet_delete_cb)
	and
	(gnucash_sheet_insert_cb): use malloc/free instead of glib
	routines for newval. newval may be free()d by routines in the
	register code. You can't mix-n-match.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_destroy) and
	(gnucash_sheet_new): sink the entry and unref it after the item
	editor is destroyed. This fixes a memory leak, the entry was not
	being finalized.

	* src/register/gnome/gnucash-sheet.c add
	(gnucash_sheet_key_press): allow outside entities to pass
	keystrokes to the sheet. Used by the combocell.

	* src/register/gnome/combocell-gnome-c: extensive modifications to
	support the new list item.

	* src/register/gnome/gnucash-item-edit.[ch]: ditto

1999-11-12  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/engine/util.c: (xaccSPrintAmount): print values
	very close to 0 as 0 without negative sign.

	* lib/README: updated to indicate obsolete packages.

	* lib/Makefile.in: don't build g-wrap if g-wrap-install
	directory exists

	* src/guile-util.c: (gnc_register_c_side_scheme_ptr):
	modified to return SCM handle, which is used with
	(gnc_unregister_c_side_scheme_ptr) to unregister.

	* src/gnome/option-util.c: added (gnc_options_init)
	and (gnc_options_shutdown).

	* src/gnome/top-level.c: call above functions at
	appropriate times.

	* src/gnome/account-tree.c: (gnc_account_tree_select_account):
	scroll to make sure account is visible.

	* src/register/gnome/gnucash-item-edit.c: (item_edit_draw): make
	the cursor larger and allow it to be seen even when it's at the
	end of a too-long-to-fit-in-cell string.

	* src/register/gnome/gnucash-item-list.[ch]: new code to support
	the combo cell.
	
1999-11-10  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/gnome/dialog-filebox.c: Use GtkFileSelection instead
	of GtkFileSelection2.

	* build: Changed configure.in/Makefile.in's to remove dependencies
	on gtkfilel2.

	* build: automatically rebuild gnc.[ch] when gnc.gwp changes *or*
	if you switch from motif to gnome build or vice versa.

	* src/gnome/window-main.: added Save As menu item.

	* src/register/gnome/combocell-gnome.c: reformatted to be
	idiomatic

	* src/register/gnome/gnucash-sheet.c:
	(gnucash_sheet_key_press_event): Added support for pageup/down and
	home/end keypressed.

1999-11-07  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/Refresh.c: Added this code for refreshing account-related
 	windows when accounts change. Right now, this is registers and
 	reconcile windows.

	* src/gnome/window-register.c: fixed deleting of blank split
	
	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_activate_cursor_cell): handle enter updates when
	new_text is non-null by updating the cell from the table and *not*
	src/register/gnome/starting the editing widget.

	* gnucash-grid.c (draw_cell): used CELL_HPADDING for right justify
	adjustment on x value instead of CELL_VPADDING.

1999-11-05  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* src/register/gnome/gnucash-grid.c (gnucash_grid_draw): use
	g_return_if_fail for error checks.

	* src/register/gnome/gnucash-grid.c (gnucash_grid_unrealize):
	Sanity checks before unrefing the gc's.

	* src/register/gnome/gnucash-header.c (gnucash_header_unrealize):
	sanity checks

	* src/register/gnome/gnucash-currsor.c (gnucash_cursor_unrealize):
	sanity checks

	* src/register/gnome/gnucash-sheet.h (GnucashRegisterClass):
	parent class should be GtkTableClass

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_update_adjustments): update page_increment, so
	clicking on the rest of the scrollbar scrolls one page

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_key_press_event): call gnc_table_traverse_update on
	up/down motion.

1999-11-04  Dave Peticolas  <peticola@cs.ucdavis.edu>

	* Add this changelog entry which I should have done a long
	time ago.

	* Rework most of the src/gnome stuff to be compliant with
	gnome-standards.

	* Add QIF fixes.

	* Add Transfer and Adjust Balance windows.

	* Add gnome<->guile options interface.

	* Add c-side SCM registry, courtesy of Rob.

	* Add Alexandru's register window enhancements.

	* Add Heath's gnome register enhancements.

	* Remove dependencies on gtksheet. Hooray!

	* src/register/gnome Various: a few fixes here and there to make
	everything compile cleanly under -Wall. Mainly removing unused
	local variables, and changing g_return_if_fail to
	g_return_val_if_fail for functions which return a value. Added a
	few prototypes that were missing. Cleaned up #includes.

	* src/register/gnome/gnucash-sheet.c (gnucash_register_new): Make
	the vertical scrollbar flush with the top of the register.

	* src/register/gnome/Makefile.in: removed motif and qt
	targets. Made gnome target the default.

1999-08-30  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_key_press_event): Be sure to set new_p_row in the
	case GDK_Tab, since the function gnc_table_traverse_update checks
	the proposed new row/col, so we need to initialize properly.

1999-08-28  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* TODO: New file.

	* src/register/gnome/gnucash-style.c (gnucash_style_init): Removed
	the dependency on gnome-print for now.  We may want to use the
	gnome-print library in the future.

	* Makefile.in (LIBS): Ditto

1999-08-25  Rob Browning  <rlb@cs.utexas.edu>

	* Add ./README.gnome-hackers.

	* Add ./README.guile-hackers.

	* Add this file (./ChangeLog).  I'm planning to add change
	information here, and I invite others to do the same.  For those
	that use emacs, 'C-x 4 a' adds a new entry.  If people don't like
	this idea, we can drop it.

	* Add new scheme function gnc:choose-item-from-list-dialog.  There
	is C side code, but it's only meant to be called from scheme.
	This function is quite flexible in handles selections.  Eventually
	we might want to generalize this even more, but there are some GC
	issues to consider.  See src/gnome/query-user.c and gnc.gwp for
	details, and see src/scm/extensions.scm for an example usage.

	* IMPORTANT: queryBox signature has changed.  See the docs in
	src/gnome/query-user.c and in gnc.gwp for details.

	* Remove queryBox stubs from Motif side.  Motif doesn't support it
	(yet), and with gnc.gwp conditional inclusion we can just ignore
	it on the motif side.

	* Add function (current-gnc-compile-flavor) to gnc.gwp so that we
	can have conditional blocks.  Possible return values are 'gnome
	and 'motif.

1999-08-23  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-header.c (gnucash_header_draw): Added
	a separator line between the header and the register entries.

	* src/register/gnome/gnucash-item-edit.c (item_edit_new): Attempt
	to implement the comboboxes.  For some reason, I can't get combos
	to work, something related to how the widget size is computed.
	Comment this out for now.

	* src/register/gnome/gnucash-item-edit.c (item_edit_set_arg):
	Ditto

1999-08-20  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-grid.c (draw_cell): Set the
	background/foreground color on a per cell basis.  This obsoletes
	the bg/fg colors in the styles for now.

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_block_clear_entries): Fixed a big memory leak here.
	(gnucash_sheet_block_set_entries): Support for background and
	foreground colors for the cells.  Set these from the table.

1999-08-19  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-style.c (gnucash_style_layout_init):
	Layout the stock registers.

1999-08-18  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-grid.c (gnucash_grid_draw): When the
	block is active, if a cell doesn't have a user-entered string,
	then draw the label for that cell type as a hint for what should
	be entered.  TODO: Don't draw the label if the cell isn't an
	input/output cell, or whatever.

	* src/register/gnome/gnucash-style.c
	(gnucash_sheet_style_compile): Initialize the labels[][] array in
	the style.

1999-08-17  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-cursor.c (configure_bounds): Do this
	the right way.

	* src/register/gnome/gnucash-item-edit.c (item_edit_draw): Added
	the clip rectangle, and made it so the text scrolls to keep the
	cursor in view.

	* src/register/gnome/gnucash-grid.c (gnucash_grid_draw): Added the
	clip rectangle.

1999-08-14  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-cursor.c
	(gnucash_cursor_get_pixel_coords): Take into account the alignment
	offsets.

	* src/register/gnome/gnucash-item-edit.c
	(item_edit_get_pixel_coords): Take into account the alignment
	offsets.

	* src/register/gnome/gnucash-grid.c
	(gnucash_grid_find_block_origin_by_pixel): Fixed an off-by-one
	mistake.

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_make_cell_visible): New function
	(gnucash_sheet_cursor_move): Make the cell visible.
	(gnucash_sheet_set_top_row): Added support for aligning on the top
	or bottom row.
	(gnucash_sheet_update_adjustments): Fixed this so the sheet can't
	scroll past the bottom row.

1999-08-12  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_activate_cursor_cell): With Alexandru's patches, we
	seem to need to grab the focus.  We'll probably need this
	elsewhere.

1999-08-11  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c (gnucash_button_press_event):
	New function.

	* src/register/gnome/gnucash-grid.c
	(gnucash_grid_find_block_origin_by_pixel): Add a return value.
	(gnucash_grid_find_cell_origin_by_pixel): New function.

1999-08-10  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_key_press_event): Added up/down movement.
	(gnucash_sheet_style_set_dimensions): Change the way we set
	dimensions.
	(gnucash_sheet_size_allocate): Recompute style dimensions.

	* src/register/gnome/gnucash-item-edit.c
	(item_edit_get_pixel_coords): We need to compute pixels relative
	to the canvas origin, not the window origin.  Duh.  (Note that
	canvas sends coordinates to a draw function relative to the canvas
	origin.)

	* src/register/gnome/gnucash-cursor.c
	(gnucash_cursor_get_pixel_coords): Ditto.

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_deactivate_cursor_cell): New function.
	(gnucash_sheet_activate_cursor_cell):
	(gnucash_sheet_cursor_move):
	(gnucash_sheet_start_editing_at_cursor):
	(gnucash_sheet_stop_editing):

1999-08-09  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/combocell-gnome.c: New file, everything is a
	no-op for now, we just need the stubs.

	* src/register/gnome/gnucash-item-edit.[ch]: New file.  Implements
	an entry for the sheet.

1999-08-08  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-cursor.[ch] : New file.  Implements a
	block/cell cursor.

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_style_get_cell_pixel_rel_coords): New function.

1999-08-06  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-grid.c (gnucash_grid_draw): Updated
	to reflect the changes below.
	(gnucash_grid_find_block_origin_by_pixel): Bug fix (off by one).

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_table_load):
	Another overhaul of the structure.  We need to keep a local copy
	of the table, to keep what we need to redraw from changing
	underneath us.  So we needed some memory management and some minor
	API adjustments.
	(gnucash_sheet_resize):
	(gnucash_sheet_resize_row):
	(gnucash_sheet_destroy_row):
	(gnucash_sheet_block_new_row):
	(gnucash_sheet_block_set_from_table):
	(gnucash_sheet_block_set_entries):
	(gnucash_sheet_block_clear_entries):
	(gnucash_sheet_insert_block_row):
	(gnucash_sheet_get_block):

1999-08-04  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_compute_visible_range): New

	* src/register/gnome/gnucash-grid.c (gnucash_grid_draw): Basic
	support for drawing the text of a cell.
	(gnucash_grid_draw): Added support for justifications.

1999-08-03  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c (gnucash_register_new): Make
	register into an independent widget.

	* src/register/gnome/gnucash-sheet.c, gnucash-grid.c: Overhaul of
	the structure.  We don't need to keep a list of blocks, or a hash
	list of styles.  All the info we need is in the Table, and there
	are only five styles associated to a given table (from
	splitreg.h).  Many functions touched to reflect the change.  Also,
	keep track of the SplitRegister associated to this table.

1999-08-02  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-color.c (gnucash_color_init): move
	the color allocation and hash table routines from table-gnome.c to
	here.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_block_append):
	fixed a silly bug.
	(gnucash_sheet_block_style_new): Fix up the key.
	(gnucash_register_new): This is complex widget that already has
	the vertical/horizontal scrollbars attached.

	* src/register/gnome/gnucash-grid.c (gnucash_grid_find_block): Be
	sure we get a valid sheet_block.  Our register window may be
	larger than the number of blocks.

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_load): Initial
	load of the table into the register.

	* src/register/gnome/gnucash-color.[c,h]:  steal these files from gnumeric

1999-08-01  Heath Martin  <martinh@pegasus.cc.ucf.edu>

	* src/register/gnome/gnucash-sheet.c
	(gnucash_sheet_style_recompile): make height, width a member of
	the style, so we don't have to change every block when the style
	gets recompiled (on sheet allocation changes for example).

	* src/register/gnome/gnucash-grid.c (gnucash_grid_get_type): First
	hack at getting a grid going.
	(gnucash_grid_class_init): Ditto
	(gnucash_grid_set_arg):
	(gnucash_grid_init):
	(gnucash_grid_draw):
	(gnucash_grid_find_block):
	(gnucash_grid_update):
	(gnucash_grid_unrealize):
	(gnucash_grid_realize):

	* src/register/gnome/gnucash-sheet.c (gnucash_sheet_new): New
	(gnucash_sheet_get_type): New
	(gnucash_sheet_class_init): New
	(gnucash_sheet_create): New
	(gnucash_sheet_realize): New
	(gnucash_sheet_block_new): New
	(gnucash_sheet_block_destroy): New
	(gnucash_sheet_vadjustment_value_changed): New
	(gnucash_sheet_set_top_block): New
	(gnucash_sheet_block_get_pixels): New
	(gnucash_sheet_get_block): New
	(gnucash_sheet_style_init): etc, per block style handling
